/*
    GL-117
    Copyright 2001, 2002 Thomas A. Drexl aka heptargon

    This file is part of GL-117.

    GL-117 is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    GL-117 is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Jabytad; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* This file includes the main program. */

/*
TODO:
- draw more fighters, ships
- mission sheet, save mission data, mission interface
- source code: DynamicObj, AIObj => aiobject.cpp; MissionX => mission.cpp
- desert landscape
- southern seashore landscape
- torpedo, water
*/

#ifndef IS_MAIN_H

#include "main.h"

int mousex, mousey;

int quality = 3;
float view = 75.0;
int width = 800, height = 600, bpp = 32;
int volumesound = 100;
int volumemusic = 100;

bool debug = false;
bool multiplayer = false, isserver = false;
int fullscreen = 1;
int day = 1;
int weather = 0;
int controls = 0;
float sungamma = 45.0;

int camera = 0;
float camx = 0, camy = 0, camz = 0, camphi = 0, camgamma = 0, camtheta = 0;
float sunlight = 1.0;

int lighting = 1;
int mode = 0;

Server *server;
Client *client;

#ifdef HAVE_SDL
SDL_Thread *threadnet = NULL;
#endif

int net_thread_main (void *data);

int game = GAME_INIT;

SoundSystem *sound = NULL;

GL *gl;

//const int maxchars = 8;
//CTexture *texchar [maxchars];

float getView ()
{
  if (weather == 1 && view > 40.0)
    return 40.0;
  return view;
}



const int maxpilotdata = 100;

class Pilot
{
  public:
  char name [16];
  int mission_state [maxpilotdata];
  int mission_time [maxpilotdata];
  int mission_fighterkills [maxpilotdata];
  int mission_shipkills [maxpilotdata];
  int mission_tankkills [maxpilotdata];
  int mission_otherkills [maxpilotdata];
  int mission_shield [maxpilotdata];
  int mission_points [maxpilotdata];
  int mission_score [maxpilotdata];

  void load ()
  {
    int i;
    for (i = 0; i < maxpilotdata; i ++)
    {
      mission_state [i] = 0;
      mission_time [i] = 0;
      mission_fighterkills [i] = 0;
      mission_shipkills [i] = 0;
      mission_tankkills [i] = 0;
      mission_otherkills [i] = 0;
      mission_shield [i] = 0;
      mission_points [i] = 0;
      mission_score [i] = 0;
    }
    char buf [256] = "../saves/";
    strcat (buf, name);
    FILE *in = fopen (buf, "rb");
    if (in == NULL)
    {
      fprintf (stderr, "Error loading pilot!\n");
      return;
    }
    fread (mission_state, sizeof (int), 100, in);
    fread (mission_time, sizeof (int), 100, in);
    fread (mission_fighterkills, sizeof (int), 100, in);
    fread (mission_shipkills, sizeof (int), 100, in);
    fread (mission_tankkills, sizeof (int), 100, in);
    fread (mission_otherkills, sizeof (int), 100, in);
    fread (mission_shield, sizeof (int), 100, in);
    fread (mission_points, sizeof (int), 100, in);
    fread (mission_score, sizeof (int), 100, in);
    fclose (in);
  }

  void save ()
  {
    char buf [256] = "../saves/";
    strcat (buf, name);
    FILE *out = fopen (buf, "wb");
    if (out == NULL)
    {
      fprintf (stderr, "Error writing pilot!\n");
      return;
    }
    fwrite (mission_state, sizeof (int), 100, out);
    fwrite (mission_time, sizeof (int), 100, out);
    fwrite (mission_fighterkills, sizeof (int), 100, out);
    fwrite (mission_shipkills, sizeof (int), 100, out);
    fwrite (mission_tankkills, sizeof (int), 100, out);
    fwrite (mission_otherkills, sizeof (int), 100, out);
    fwrite (mission_shield, sizeof (int), 100, out);
    fwrite (mission_points, sizeof (int), 100, out);
    fwrite (mission_score, sizeof (int), 100, out);
    fclose (out);
  }

  Pilot (char *name)
  {
    strcpy (this->name, name);
    load ();
  }
};

const int maxpilots = 5;

class PilotList
{
  public:
  int aktpilots, aktpilot;
  Pilot *pilot [maxpilots];

  void load (char *fname)
  {
    char buf [16];
    int i;
    FILE *in = fopen (fname, "rb");
    if (in == NULL)
    {
      fprintf (stderr, "Error loading saves/pilots!\n");
      aktpilots = 0;
      add ("PLAYER");
      return;
    }
    fgets (buf, 16, in);
    aktpilots = atoi (buf);
    fgets (buf, 16, in);
    aktpilot = atoi (buf);
    int z = 0;
    while (fgets (buf, 16, in) && z < maxpilots)
    {
      for (i = 0; i < (int) strlen (buf); i ++)
        if (buf [i] == '\n')
          buf [i] = '\0';
      pilot [z] = new Pilot (buf);
      z ++;
    }
    fclose (in);
  }

  void save (char *fname)
  {
    char buf [256];
    int i;
    
    FILE *out = fopen (fname, "wb");
    if (out == NULL)
    {
      fprintf (stderr, "Error writing saves/pilots!\n");
      return;
    }
    sprintf (buf, "%d\n%d\n", aktpilots, aktpilot);
    fwrite (buf, 1, strlen (buf), out);
    for (i = 0; i < aktpilots; i ++)
    {
      sprintf (buf, "%s\n", pilot [i]->name);
      fwrite (buf, 1, strlen (buf), out);
    }
    fclose (out);
    
    for (i = 0; i < aktpilots; i ++)
    {
      pilot [i]->save ();
    }
  }

  PilotList (char *fname)
  {
    int i;
    for (i = 0; i < maxpilots; i ++)
      pilot [i] = NULL;
    load (fname);
  }

  ~PilotList ()
  {
    int i;
    for (i = 0; i < aktpilots; i ++)
    {
      if (pilot [i] != NULL)
        delete pilot [i];
    }
  }

  void remove ()
  {
    int i;
    if (pilot [aktpilot] != NULL)
    {
      delete pilot [aktpilot];
      pilot [aktpilot] = NULL;
    }
    for (i = aktpilot; i < aktpilots; i ++)
      pilot [i] = pilot [i + 1];
    pilot [aktpilots] = NULL;
    aktpilots --;
    if (aktpilots < 0) aktpilots = 0;
    aktpilot = 0;
  }

  void add (char *name)
  {
    if (aktpilots >= maxpilots) return;
    aktpilot = aktpilots;
    pilot [aktpilot] = new Pilot (name);
    aktpilots ++;
  }
};




const int maxexplosion = 30, maxfighter = 10, maxlaser = 120, maxmissile = 30, maxstar = 70, maxgroundobj = 10;

CTexture *texsun, *texflare, *texfont1, *textfont2, *texmoon, *texcross, *texcross2;

PilotList *pilots;

CExplosion *explosion [maxexplosion];
GLLandscape *l = NULL;
Font *font1, *font2;




class EditField
{
  public:
  char text [256];
  bool active;
  int maxlen, cursorpos;

  EditField ()
  {
    maxlen = 16;
    memset (text, 0, 256);
  }

  EditField (int maxlen)
  {
    if (maxlen > 254) maxlen = 254;
    this->maxlen = maxlen;
    memset (text, 0, 256);
  }
  void init ()
  {
    memset (text, 0, 256);
    cursorpos = 0;
    active = true;
  }
  void event (unsigned char key)
  {
    if (key == 8)
    {
      if (cursorpos > 0)
      {
        cursorpos --;
        text [cursorpos] = '\0';
      }
    }
    if (cursorpos >= maxlen)
      return;
    if (key == 27)
    {
      active = false;
    }
    else if (key == 13)
    {
      active = false;
      text [cursorpos ++] = '\0';
    }
    else if (key >= ' ')
    {
      if (key >= 'a' && key <= 'z')
        key = key - 'a' + 'A';
      if (key >= font1->n + font1->start) return;
      text [cursorpos ++] = key;
    }
  }
  void draw (float x, float y, float z, int timer)
  {
    if (!active)
      return;
    char buf [256];
    memcpy (buf, text, 256);
    if (timer & 1)
    {
      buf [cursorpos] = 'I';
      buf [cursorpos + 1] = '\0';
    }
    font1->drawText (x, y, z, buf);
  }
};




#define CANNON1 0
#define CANNON2 99
#define MISSILE1 100
#define MISSILE_AIR1 100
#define MISSILE_AIR2 101
#define MISSILE_AIR3 102
#define MISSILE_GROUND1 103
#define MISSILE_GROUND2 104
#define MISSILE2 199
#define FIGHTER1 200
#define FIGHTER_FALCON 200
#define FIGHTER_SWALLOW 201
#define FIGHTER_HAWK 202
#define FIGHTER_HAWK2 203
#define FIGHTER_BUZZARD 204
#define FIGHTER_TRANSPORT 280
#define FIGHTER2 299
#define SHIP1 800
#define SHIP_CRUISER 800
#define SHIP2 899
#define FLAK1 1000
#define FLAK_AIR1 1000
#define FLARAK_AIR1 1010
#define FLAK2 1099
#define STATIC 10000

class DynamicObj : public CSpaceObj
{
  public:
  int id;
  bool controls;
  bool active;
  bool easymodel;
  int ttl, immunity;
  int impact;
  float phi, theta, gamma, speed, acceleration, realspeed; //, height;
  float forcex, forcez, forcey;
  float braking, manoeverability, maxspeed;
  float rectheta, recspeed, recheight, maxtheta, maxgamma;
  float recgamma, nimbility;
  float aileroneffect, ruddereffect, rolleffect;
  int party;
  int points, fighterkills, shipkills, tankkills, otherkills;
  int sink;
  bool killed;
  Space *space;
  DynamicObj *source;
  char net [100];
//  GLLandscape *l;
  
  int shield, maxshield;

  int net_write ()
  {
    net [0] = '.';
    int z = 1;
    memcpy (&net [z], &tl->x, sizeof (&tl->x));
    z += sizeof (&tl->x);
    memcpy (&net [z], &tl->y, sizeof (&tl->y));
    z += sizeof (&tl->y);
    memcpy (&net [z], &tl->z, sizeof (&tl->z));
    z += sizeof (&tl->z);
    memcpy (&net [z], &phi, sizeof (&phi));
    z += sizeof (&phi);
    memcpy (&net [z], &theta, sizeof (&theta));
    z += sizeof (&theta);
    memcpy (&net [z], &gamma, sizeof (&gamma));
    z += sizeof (&gamma);
    return z;
  }

  void net_read ()
  {
    int z = 1;
    memcpy (&tl->x, &net [z], sizeof (&tl->x));
    z += sizeof (&tl->x);
    memcpy (&tl->y, &net [z], sizeof (&tl->y));
    z += sizeof (&tl->y);
    memcpy (&tl->z, &net [z], sizeof (&tl->z));
    z += sizeof (&tl->z);
    memcpy (&phi, &net [z], sizeof (&phi));
    z += sizeof (&phi);
    memcpy (&theta, &net [z], sizeof (&theta));
    z += sizeof (&theta);
    memcpy (&gamma, &net [z], sizeof (&gamma));
    z += sizeof (&gamma);
  }

  void activate ()
  {
    active = true;
    draw = true;
  }
  
  void deactivate ()
  {
    active = false;
    draw = false;
  }

  void dinit ()
  {
    rot->a = 90;
    phi = 0; theta = 0; gamma = 180;
    rectheta = 0;
    tl->z = 0; tl->x = 0;
    forcex = 0; forcez = 0; forcey = 0;
    maxspeed = 0.4; braking = 0.5; manoeverability = 0.5;
    acceleration = maxspeed / 10;
    speed = maxspeed; recspeed = speed; recheight = 5.0;// height = 5.0;
    ttl = -1;
    shield = 1; maxshield = 1;
    immunity = 0;
    controls = false;
    recgamma = 180;
    id = CANNON1;
    impact = 10;
    source = NULL;
    points = 0;
    party = 0;
    easymodel = true;
    aileroneffect = 0;
    ruddereffect = 0;
    rolleffect = 0;
    maxgamma = 80;
    maxtheta = 90;
    gamma = 180;
    theta = 0;
    explode = 0;
    sink = 0;
    nimbility = 1.0;
    fighterkills = 0;
    shipkills = 0;
    tankkills = 0;
    otherkills = 0;
    killed = false;
  }

  DynamicObj ()
  {
    dinit ();
  }

  DynamicObj (Space *space2, CModel *o2, float zoom2)
  {
    this->space = space2;
    o = o2;
    zoom = zoom2;
    dinit ();
    space->addObject (this);
  }

  void toLeft ()
  {
    rectheta += manoeverability * 4;
//  if (theta > 360.0) theta -= 360.0;
  }

  void toRight ()
  {
    rectheta -= manoeverability * 4;
//    if (theta < -360.0) theta += 360.0;
  }

  void speedUp ()
  {
    recspeed += acceleration;
    if (recspeed > maxspeed) recspeed = maxspeed;
  }

  void speedDown ()
  {
    recspeed -= acceleration;
    if (recspeed < maxspeed / 2) recspeed = maxspeed / 2;
  }

  float distance (DynamicObj *target)
  {
    float dx = target->tl->x - tl->x;
    float dz = target->tl->z - tl->z;
    return sqrt (dx * dx + dz * dz);
  }

  void checkExplosion ()
  {
    if (explode > 0)
    {
      explode ++;
      if (explode == 3)
        setExplosion (0.6, 30);
      if (explode >= 35)
      {
        deactivate (); ttl = -1;
      }
    }
    if (sink)
    {
      sink ++;
      if (sink > 100)
      {
        deactivate (); ttl = -1;
      }
    }
  }

  void checkShield ()
  {
    if (shield <= 0)
    {
      shield = 0;
      if (!explode)
      {
        if (id >= MISSILE1 && id <= MISSILE2)
        { explode = 1; active = false; }
        if (id >= FIGHTER1 && id <= FIGHTER2)
        { explode = 1; active = false; }
        if (id >= FLAK1 && id <= FLAK2)
        { explode = 1; active = false; }
        if (id == STATIC)
        { explode = 1; active = false; }
      }
      if (!sink)
        if (id >= SHIP1 && id <= SHIP2)
        { sink = 1; }
    }
//    printf ("\nshield=%d", shield); fflush (stdout);
  }
  
  void crashGround ()
  {
    if ((id >= SHIP1 && id <= SHIP1) || (id >= FLAK1 && id <= FLAK2) || id == STATIC)
      return;
    float height = tl->y - l->getExactHeight (tl->x, tl->z);
    if (height < zoom)
    {
      tl->y -= (height - zoom);
      gamma += 10;
      if (shield > 0)
      {
        if (id >= MISSILE1 && id <= MISSILE2)
          setExplosion (1.2, 25);
        if (id >= FIGHTER1 && id <= FIGHTER2)
          setExplosion (0.2, 20);
      }
      if (id >= CANNON1 && id <= CANNON2)
        deactivate ();
      shield -= 1;
//      shield += (int) height - 2;
    }
    if (height > 50) tl->y = l->getHeight (tl->x, tl->z) + 50;
  }
  
  void collide (DynamicObj *d) // d must be the medium (laser, missile)
  {
    if (immunity > 0 || d->immunity > 0) return;
    if (explode > 0 || sink > 0) return;
    float z = d->zoom > zoom ? d->zoom : zoom;
    if ((id >= MISSILE1 && id <= MISSILE2) || (d->id >= MISSILE1 && d->id <= MISSILE2))
    {
      z *= 2;
    }
    if ((id >= SHIP1 && id <= SHIP2) || (d->id >= SHIP1 && d->id <= SHIP2))
      z *= 0.3;
/*    else if ((id >= CANNON1 && id <= CANNON2) || (d->id >= CANNON1 && d->id <= CANNON2))
      z *= 1.0;
    else if (id >= FLAK1 && id <= FLAK2)
      z *= 1.0;*/
    if (tl->x >= d->tl->x - z && tl->x <= d->tl->x + z &&
        tl->y >= d->tl->y - z && tl->y <= d->tl->y + z &&
        tl->z >= d->tl->z - z && tl->z <= d->tl->z + z)
    {
      shield -= d->impact;
      d->shield -= impact;
//      printf (" c(%d,%d)=>s(%d,%d)\n", id, d->id, shield, d->shield);
      if (d->source != NULL && active)
      {
        if (d->source->party != party && maxshield < 2000) // calculate points
          d->source->points += impact;
        else
          d->source->points -= impact;
        
        if (d->source->party != party && active && draw && !killed)
          if (d->source->id >= FIGHTER1 && d->source->id <= FIGHTER2)
          {
            killed = true;
            if (id >= FIGHTER1 && id <= FIGHTER2)
              d->source->fighterkills ++;
            else if (id >= SHIP1 && id <= SHIP2)
              d->source->shipkills ++;
            else if (id >= FLAK1 && id <= FLAK2)
              d->source->tankkills ++;
            else
              d->source->otherkills ++;
          }
      }
      setExplosion (0.2, 20);
//      printf ("collision"); fflush (stdout);
    }
  }

  void setExplosion (float maxzoom, int len)
  {
    int i;
    for (i = 0; i < maxexplosion; i ++)
      if (explosion [i]->ttl <= 0)
        break;
    if (i >= maxexplosion) i = 0;
    explosion [i]->setExplosion (tl->x, tl->y, tl->z, maxzoom, len);
  }

  int getAngle (DynamicObj *o)
  {
    float dx2 = o->tl->x - tl->x, dz2 = o->tl->z - tl->z;
	  int a, w = (int) phi;
    if (dz2 > -0.0001 && dz2 < 0.0001) dz2 = 0.0001;

    a = (int) (atan (dx2 / dz2) * 180 / PI);
    if (dz2 > 0)
    {
      if (dx2 > 0) a -= 180;
      else a += 180;
    }
    int aw = a - w;
    if (aw < -180) aw += 360;
    if (aw > 180) aw -= 360;
    return aw;
  }

  bool checkLooping ()
  {
    if (gamma > 270)
    {
      gamma = 540 - gamma;
      theta += 180;
      phi += 180;
      rectheta += 180;
      if (theta >= 360) theta -= 360;
      if (rectheta >= 360) rectheta -= 360;
      if (phi >= 360) phi -= 360;
      return true;
    }
    else if (gamma < 90)
    {
      gamma = 180 - gamma;
      theta += 180;
      phi += 180;
      rectheta += 180;
      if (theta >= 360) theta -= 360;
      if (rectheta >= 360) rectheta -= 360;
      if (phi >= 360) phi -= 360;
      return true;
    }
    return false;
  }
  
  void move ()
  {
    if (id == STATIC) return;
    checkExplosion ();
    if (sink) // only ships
    {
      tl->y -= 0.02;
      gamma = recgamma = 180.0 + 0.5 * (float) sink;
      return;
    }
    if (!active) return;

    int theta0 = (int) theta;
    while (theta0 < 0) theta0 += 360;
    while (theta0 > 360) theta0 -= 360;
    if (easymodel)
    {
      if (id >= FLAK1 && id <= FLAK2)
      {
        phi += sine [(int) theta0] * manoeverability * 10.0;
      }
      else
      {
        float div = maxspeed + speed;
        if (div == 0) div = 1;
        phi += sine [(int) theta0] * manoeverability * 10.0 * maxspeed / div;
      }
    }
    else
    {
      int vz = 1;
      if (gamma < 90 || gamma > 270)
        vz = -1;
      phi += vz * sine [(int) theta0] * aileroneffect * manoeverability * 10.0 * maxspeed / (maxspeed + speed);
      gamma += cosi [(int) theta0] * aileroneffect * manoeverability * 10.0 * maxspeed / (maxspeed + speed);
      phi += -vz * cosi [(int) theta0] * ruddereffect * manoeverability * 1.5 * maxspeed / (maxspeed + speed);
      gamma += sine [(int) theta0] * ruddereffect * manoeverability * 1.5 * maxspeed / (maxspeed + speed);
      if (rolleffect)
      {
        rectheta += rolleffect;
      }
    }
    if (phi < 0) phi += 360.0;
    else if (phi >= 360.0) phi -= 360.0;

    if (easymodel)
    {
      if (rectheta > maxtheta) rectheta = maxtheta;
      else if (rectheta < -maxtheta) rectheta = -maxtheta;
      if (recgamma > 180 + maxgamma) recgamma = 180 + maxgamma;
      else if (recgamma < 180 - maxgamma) recgamma = 180 - maxgamma;
    }
    else
    {
      if (theta < -180 && rectheta < -180)
      { rectheta += 360; theta += 360; }
      else if (theta >= 180 && rectheta >= 180)
      { rectheta -= 360; theta -= 360; }
    }

  	if (controls)
    {
	  }

    if (recspeed > speed)
      speed += acceleration / 5;
    else if (recspeed < speed)
      speed -= acceleration / 5;

    CVector3 vaxis (cosi [(int) gamma] * sine [(int) phi], sine [(int) gamma], cosi [(int) gamma] * cosi [(int) phi]);

    // Throttle
    forcez += speed * vaxis.z;
    forcex += speed * vaxis.x;
    forcey -= speed * vaxis.y;

    if (id >= FIGHTER1 && id <= FIGHTER1 + 50)
    {
      // Normal
      int ngamma = gamma + 90;
      if (ngamma >= 360) ngamma -= 360;
      else if (ngamma < 0) ngamma += 360;
      CVector3 vx (cosi [ngamma] * sine [(int) phi], sine [ngamma], cosi [ngamma] * cosi [(int) phi]);
      CVector3 x1;
      x1.take (&vx);
      int mytheta = (int) -theta;
      while (mytheta < 0) mytheta += 360;
      while (mytheta >= 360) mytheta -= 360;
      x1.x *= cosi [mytheta];
      x1.y *= cosi [mytheta];
      x1.z *= cosi [mytheta];
      vx.mult (&vaxis);
      vx.x *= sine [mytheta];
      vx.y *= sine [mytheta];
      vx.z *= sine [mytheta];
      vx.add (&x1);
      float addy = speed * vx.x * 0.3;
      if (addy >= -100 && addy <= 100)
      {
        forcex += speed * vx.x * 0.35;
        forcey -= speed * vx.y * 0.35;
        forcez += speed * vx.z * 0.35;

        // Weight
        forcey -= 0.065;
      }
//      cosi [(int) phi]
    }

    // Drag
    forcex *= braking; forcez *= braking; forcey *= braking;
    tl->x += forcex;
    tl->z += forcez;
    tl->y += forcey;
//	tl->y = l->getHeight (tl->x, tl->z)+5;
//	gamma = 180;

    rot->setAngles ((short) (90 + gamma - 180), (short) theta + 180, (short) -phi);
    realspeed = sqrt (forcex * forcex + forcez * forcez);

    if (ttl > 0) ttl --;
    if (ttl == 0)
    {
	    if (id >= MISSILE1 && id <= MISSILE2) recheight = -10;
	    else deactivate ();
    }
    checkShield ();
    if (id >= FLAK1 && id <= FLAK1)
    {
    }
    else
    {
      crashGround ();
    }
    if (immunity > 0) immunity --;
  }

};

const int missiletypes = 5;

class AIObj : public DynamicObj
{
  protected:
  public:
  bool ai;
  bool autofire;
  DynamicObj *target;
  int acttype;
  int intelligence, aggressivity, precision;
  int manoevertheta, manoeverheight;
  int idle;
  int firemissilettl;
  int missiletype; // only relevant for the player
  int missiles [missiletypes];
  int aw; // aktueller Winkel zum Ziel
  int score;
  float dtheta, dgamma;
  float disttarget; // aktuelle Distanz zum Ziel
  CSmoke *smoke;

  void aiinit ()
  {
    acttype = 0;
    intelligence = 100;
    aggressivity = 100;
    precision = 100;
    ai = true;
    active = true;
    draw = true;
    target = NULL;
	  controls = true;
	  dtheta = 0;
	  dgamma = 0;
	  id = MISSILE1;
    impact = 30;
    manoevertheta = 0;
    manoeverheight = 0;
    idle = 0;
    firemissilettl = 0;
    aw = 0;
    source = NULL;
    points = 0;
    easymodel = true;
    aileroneffect = 0;
    ruddereffect = 0;
    gamma = 180;
    theta = 0;
    maxgamma = 80;
    maxtheta = 90;
    missiletype = 0;
    autofire = false;
    ttl = -1;
    score = -1;
    for (int i = 0; i < missiletypes; i ++)
      missiles [i] = 0;
  }

  void newinit (int id, int party, int intelligence)
  {
    ai = true;
    this->id = id;
    this->party = party;
    this->intelligence = intelligence;
    this->precision = intelligence;
    this->aggressivity = intelligence;
    activate ();
    if (id == FIGHTER_FALCON)
    {
      maxspeed = 0.42;
      nimbility = 0.9;
      manoeverability = 0.48;
      maxshield = 95;
      zoom = 0.4;
      maxtheta = 90.0;
      maxgamma = 80.0;
      missiles [0] = 6;
      missiles [3] = 2;
    }
    else if (id == FIGHTER_SWALLOW)
    {
      maxspeed = 0.4;
      nimbility = 1.0;
      manoeverability = 0.52;
      maxshield = 80;
      zoom = 0.38;
      maxtheta = 90.0;
      maxgamma = 80.0;
      missiles [0] = 8;
      missiles [3] = 0;
    }
    else if (id == FIGHTER_HAWK)
    {
      maxspeed = 0.36;
      nimbility = 0.75;
      manoeverability = 0.44;
      maxshield = 120;
      zoom = 0.43;
      maxtheta = 90.0;
      maxgamma = 80.0;
      missiles [0] = 6;
      missiles [3] = 6;
    }
    else if (id == FIGHTER_HAWK2)
    {
      maxspeed = 0.38;
      nimbility = 0.82;
      manoeverability = 0.45;
      maxshield = 140;
      zoom = 0.44;
      maxtheta = 90.0;
      maxgamma = 80.0;
      missiles [1] = 2;
      missiles [3] = 6;
      missiles [4] = 2;
    }
    else if (id == FIGHTER_TRANSPORT)
    {
      maxspeed = 0.2;
      maxshield = 45;
      missiles [0] = 0;
      manoeverability = 0.1;
      impact = 5;
      zoom = 1.5;
      maxgamma = 20;
      maxtheta = 30;
    }
    else if (id == FIGHTER_BUZZARD)
    {
      maxspeed = 0.385;
      nimbility = 0.88;
      manoeverability = 0.475;
      maxshield = 70;
      zoom = 0.37;
      maxtheta = 90.0;
      maxgamma = 80.0;
      missiles [0] = 4;
      missiles [3] = 2;
    }
    if (id >= FIGHTER1 && id <= FIGHTER2)
    {
      acceleration = maxspeed / 12.0;
      recspeed = maxspeed / 2.0;
      shield = maxshield;
      speed = recspeed = maxspeed / 2;
      smoke->type = 1;
      impact = 2;
    }

    if (id == FLAK_AIR1)
    {
      maxspeed = 0;
      speed = 0;
      maxgamma = 0;
      maxtheta = 3;
      manoeverability = 20.0;
      shield = 80;
      zoom = 0.35;
    }
    if (id == FLARAK_AIR1)
    {
      maxspeed = 0;
      speed = 0;
      maxgamma = 0;
      maxtheta = 3;
      manoeverability = 10.0;
      shield = 80;
      zoom = 0.3;
      missiles [0] = 100;
    }

    if (id == SHIP_CRUISER)
    {
      zoom = 3.5;
      acceleration = 0;
      maxspeed = 0;
      speed = 0;
      maxgamma = 0;
      maxtheta = 3;
      manoeverability = 5.0;
      impact = 20;
      shield = 500;
      missiles [1] = 200;
    }

    if (id == MISSILE_AIR1)
    {
      intelligence = 100;
      maxspeed = 0.52;
      nimbility = 2.5;
      manoeverability = 2.5;
      ttl = 200;
      impact = 30;
    }
    else if (id == MISSILE_AIR2)
    {
      intelligence = 50;
      maxspeed = 0.55;
      nimbility = 4.5;
      manoeverability = 3.5;
      ttl = 220;
      impact = 40;
    }
    else if (id == MISSILE_AIR3)
    {
      intelligence = 0;
      maxspeed = 0.6;
      nimbility = 6.5;
      manoeverability = 4.5;
      ttl = 250;
      impact = 55;
    }
    else if (id == MISSILE_GROUND1)
    {
      intelligence = 0;
      maxspeed = 0.55;
      nimbility = 1.0;
      manoeverability = 1.0;
      ai = true;
      ttl = 250;
      impact = 150;
    }
    else if (id == MISSILE_GROUND2)
    {
      intelligence = 0;
      maxspeed = 0.6;
      nimbility = 2.0;
      manoeverability = 1.0;
      ai = true;
      ttl = 310;
      impact = 250;
    }
  }

  AIObj ()
  {
    o = NULL;
    zoom = 1.0;
    aiinit ();
    smoke = new CSmoke (0);
  }

  AIObj (Space *space2, CModel *o2, float zoom2)
  {
    this->space = space2;
    o = o2;
    zoom = zoom2;
    aiinit ();
    smoke = new CSmoke (0);
    space->addObject (this);
  }
  
  void initValues (DynamicObj *dobj, float phi)
  {
    // Hier bitte exakte Kugelkoordinaten auf Grund von gamma und theta verwenden!
    dobj->tl->x = tl->x + cosi [(int) gamma] * sine [(int) phi] * zoom;
    dobj->tl->y = tl->y - sine [(int) gamma] * zoom;
    if (id >= FLAK1 && id <= FLAK2)
      dobj->tl->y += zoom;
    dobj->tl->z = tl->z + cosi [(int) gamma] * cosi [(int) phi] * zoom;
    dobj->phi = phi;
    dobj->theta = 0;
    dobj->rectheta = dobj->theta;
    dobj->forcex = forcex;
    dobj->forcey = forcey;
    dobj->forcez = forcez;
    dobj->rot->setAngles ((short) (90 + dobj->gamma - 180), (short) dobj->theta + 180, (short) -dobj->phi);
  }

  void fireCannon (DynamicObj *laser, float phi)
  {
    laser->speed = speed + 0.4;
    laser->realspeed = realspeed + 0.4;
    laser->recspeed = laser->speed;
    laser->manoeverability = 0.0;
    laser->maxspeed = 1.0;
	  if (target != NULL && ai)
    {
	    if (target->active)
	    {
	      float timelaser = distance (target) / (laser->realspeed - target->realspeed); // urks, should be target->speed*(norm2(v_target||v_laser))
	      laser->gamma = 180.0 + atan ((target->tl->y - tl->y) / timelaser / laser->realspeed) * 180.0 / pitab;
	    }
	  }
	  else
      laser->gamma = gamma; // + 90.0;
	  laser->party = party;
    laser->ttl = 50;
    laser->shield = 1;
    laser->immunity = (int) (zoom * 10);
    laser->source = this;
    laser->phi = phi;
    initValues (laser, phi);
    laser->activate ();
  }

  void fireCannon (DynamicObj **laser, float phi)
  {
    int i;
    for (i = 0; i < maxlaser; i ++)
    {
      if (!laser [i]->active) break;
    }
//    printf ("i=%d, ", i); fflush (stdout);
    if (i < maxlaser)
    {
//      printf ("e%d ", i); fflush (stdout);
      fireCannon (laser [i], phi);
//      printf ("l%d ", i); fflush (stdout);
    }
  }

  void fireCannon (DynamicObj **laser)
  {
    fireCannon (laser, phi);
  }

  void fireMissile2 (int id, AIObj *missile, AIObj *target)
  {
    missile->dinit ();
    missile->aiinit ();
    missile->newinit (id, party, 0);
    initValues (missile, phi);
    missile->id = MISSILE1;
    missile->explode = 0;
    missile->speed = speed + 0.0005;
    missile->recspeed = 0.5;
//    missile->gamma = gamma / 2.0 + 90.0;
    missile->gamma = gamma;
    missile->target = target;
    missile->recgamma = gamma;
    missile->shield = 1;
//	  missile->recheight = 5;
	  missile->party = party;
    missile->immunity = 15 + (int) (zoom * 5.0);
	  missile->dtheta = 0;
	  missile->dgamma = 0;
    missile->source = this;
    missile->activate ();
    if (id >= FIGHTER1 && id <= FIGHTER2)
    {
      missile->manoeverheight = 30;
      missile->recheight = missile->tl->y - l->getHeight (missile->tl->x, missile->tl->z) - 4;
    }
  }

  int nextMissile (int from)
  {
    int i = from + 1;
    if (i >= missiletypes) i = 0;
    while (!missiles [i])
    {
      i ++;
      if (i >= missiletypes) i = 0;
      if (i == from) break;
    }
    return i;
  }

  bool haveMissile (int id)
  {
    if (missiles [id - MISSILE1] > 0)
      return true;
    return false;
  }

  void decreaseMissile (int id)
  {
    missiles [id - MISSILE1] --;
  }

  void fireMissile (int id, AIObj **missile, AIObj *target)
  {
    int i;
    if (!haveMissile (id)) return;
    for (i = 0; i < maxmissile; i ++)
    {
      if (missile [i]->ttl <= 0) break;
    }
    if (i < maxmissile)
    {
      fireMissile2 (id, missile [i], target);
      decreaseMissile (id);
      firemissilettl = 100;
    }
  }

  void fireMissile (int id, AIObj **missile)
  {
    fireMissile (id, missile, (AIObj *) target);
  }
  
  void fireMissileAir (AIObj **missile, AIObj *target)
  {
    if (haveMissile (MISSILE_AIR3))
      fireMissile (MISSILE_AIR3, missile, (AIObj *) target);
    else if (haveMissile (MISSILE_AIR2))
      fireMissile (MISSILE_AIR2, missile, (AIObj *) target);
    else if (haveMissile (MISSILE_AIR1))
      fireMissile (MISSILE_AIR1, missile, (AIObj *) target);
  }

  void fireMissileGround (AIObj **missile)
  {
    if (haveMissile (MISSILE_GROUND2))
      fireMissile (MISSILE_GROUND2, missile, (AIObj *) target);
    else if (haveMissile (MISSILE_GROUND1))
      fireMissile (MISSILE_GROUND1, missile, (AIObj *) target);
  }

  void targetNearestEnemy (AIObj **f)
  {
    int i;
    float d = 10000;
    for (i = 0; i < maxfighter; i ++)
    {
      if (this != f [i] && party != f [i]->party && f [i]->active)
      {
        float d2 = distance (f [i]);
        if (d2 < d)
        {
          d = d2;
          target = f [i];
        }
      }
    }
  }

  void targetNext (AIObj **f)
  {
    int i;
//    float d = 10000;
    if (target == NULL) target = f [0];
    for (i = 0; i < maxfighter; i ++)
      if (target == f [i])
        break;
    i ++;
    if (i >= maxfighter) i = 0;
    if (target == this) i ++;
    if (i >= maxfighter) i = 0;
    target = f [i];
  }

  void targetPrevious (AIObj **f)
  {
    int i, lastfighter = 0;
//    float d = 10000;
    if (target == NULL) target = f [0];
    for (i = maxfighter - 1; i >= 0; i --)
      if (f [i]->active)
      {
        lastfighter = i;
        break;
      }
    for (i = 0; i < maxfighter; i ++)
      if (target == f [i])
        break;
    i --;
    if (i >= 0) i = lastfighter;
    if (target == this) i --;
    if (i >= 0) i = lastfighter;
    target = f [i];
  }

  void aiAction (AIObj **f, AIObj **m, DynamicObj **c)
  {
    if (debug)
    { printf ("a("); fflush (stdout); }
    if (!active && !draw)
    {
      if (debug)
      { printf (")"); fflush (stdout); }
      return;
    }

    if (firemissilettl > 0) firemissilettl --;

    // Move object according to our physics
    move ();

    // Set smoke
//    if (ai) // at the moment no smoke for player's fighter
    if ((id >= MISSILE1 && id <= MISSILE2) || (id >= FIGHTER1 && id <= FIGHTER2))
    {
      float sz = cosi [(int) gamma] * cosi [(int) phi] * zoom * 1.1;
      float sy = -sine [(int) gamma] * zoom * 1.1;
      float sx = cosi [(int) gamma] * sine [(int) phi] * zoom * 1.1;
      smoke->move ();
      smoke->setSmoke (tl->x - sx - forcex * 0.67, tl->y - sy - forcey * 0.67, tl->z - sz - forcez * 0.67, (int) phi, 8);
      smoke->setSmoke (tl->x - sx - forcex * 0.33, tl->y - sy - forcey * 0.33, tl->z - sz - forcez * 0.33, (int) phi, 9);
      smoke->setSmoke (tl->x - sx, tl->y - sy, tl->z - sz, (int) phi, 10);
    }

    if (!active)
    {
      if (debug)
      { printf (")"); fflush (stdout); }
      return;
    }
    if (explode || sink)
    {
      if (debug)
      { printf (")"); fflush (stdout); }
      return;
    }

    // Do expensive calculations only once
    float myheight = l->getExactHeight (tl->x, tl->z);
    float targetheight = tl->y;
    if (target != NULL)
      targetheight = l->getExactHeight (target->tl->x, target->tl->z);

    // Which height???
    float recheight2; // this is the height, the object wants to achieve
    float flyx = tl->x + forcex * 6, flyz = tl->z + forcez * 6;
    if (ttl != 0)
    {
      if (manoeverheight)
      {
        // precalculated height
        recheight2 = l->getExactHeight (flyx, flyz) + recheight;
      }
      else
      {
         // missiles and non intelligent objects will not change their height due to the surface
        if ((id >= MISSILE1 && id <= MISSILE2 && target != NULL) ||
            (tl->y - myheight > 6 && target != NULL && tl->y - myheight < 50/* && !manoeverheight*/))
        {
          recheight2 = target->tl->y - 8 * target->speed * sine [(int) target->gamma];
        }
        else
        {
          // precalculated height
          recheight2 = l->getExactHeight (flyx, flyz) + recheight;
        }
      }
	  }
    else recheight2 = -100;

    if (manoeverheight > 0) manoeverheight --;
    if (!manoeverheight)
    {
      if (!(id >= FIGHTER1 && id <= FIGHTER2) && target != NULL)
      {
        recheight = target->tl->y - targetheight;
      }
      else if (id >= FIGHTER1 && id <= FIGHTER2 && target != NULL)
	    {
  	    recheight = target->tl->y - targetheight;
        if (!l->isWater (l->f [(int) flyx] [(int) flyz]))
        {
	        if (recheight < 3.5 + 0.005 * aggressivity) recheight = 3.5 + 0.005 * aggressivity;
          if (maxgamma < 40)
            if (recheight < 20) recheight = 20;
        }
        float minh = 2.0 + 0.005 * aggressivity;
        if (l->type == 2) minh = 5.0 + 0.005 * aggressivity;
        if (fabs (l->getHeight (flyx, flyz) - myheight) < minh)
        {
          recheight = 8 + 0.01 * aggressivity;
          manoeverheight = 30;
        }
/*        if (myrandom (intelligence + 50) == 0)
        {
          recheight = 10.0 * fabs (l->getHeight (flyx, flyz) - myheight);
          manoeverheight = 15;
        }*/
	    }
    }

    if (ai)
    {
      if (id >= MISSILE_GROUND1 && id <= MISSILE_GROUND2)
      {
        float dgamma = atan ((target->tl->y - tl->y) / disttarget) * 180 / PI - (gamma - 180);
        recgamma = gamma + dgamma;
      }
      else
        recgamma = (int) ((recheight2 - tl->y) * 10 - gamma + 360);
    }

//	recgamma = 180 + atan ((recheight2 - tl->y) / speed) * 180 / pitab;
//	if (recgamma < -80) recgamma = -80;
//	if (recgamma > 80) recgamma = 80;
/*  if (recgamma > gamma + 4) gamma += (recgamma - gamma) / 8 + 1;
    else if (recgamma < gamma - 4) gamma += (recgamma - gamma) / 8 - 1;
    if (gamma > 250) gamma = 250;
    if (gamma < 110) gamma = 110;*/

//  float nimbility;

	float deltatheta = rectheta - theta;
//	nimbility = 1.0;
	if (deltatheta > 0 && dtheta < 0) dtheta += nimbility;
	else if (deltatheta < 0 && dtheta > 0) dtheta -= nimbility;
	else if (deltatheta > 0)
	{
	  float estimatedtheta = dtheta * (dtheta + nimbility) / 2 / nimbility;
	  if (deltatheta > estimatedtheta + 2) dtheta += nimbility;
	  else if (deltatheta < estimatedtheta - 2) dtheta -= nimbility;
	}
	else
	{
	  float estimatedtheta = -dtheta * (dtheta - nimbility) / 2 / nimbility;
	  if (deltatheta < estimatedtheta - 2) dtheta -= nimbility;
	  else if (deltatheta > estimatedtheta + 2) dtheta += nimbility;
	}
	theta += dtheta;

  if (easymodel)
  {
	if (theta > maxtheta) theta = maxtheta;
	else if (theta < -maxtheta) theta = -maxtheta;

	float deltagamma = recgamma - gamma;
//	nimbility = maxspeed * 2;
	if (deltagamma > 0 && dgamma < 0) dgamma += nimbility;
	else if (deltagamma < 0 && dgamma > 0) dgamma -= nimbility;
	else if (deltagamma > 0)
	{
	  float estimatedgamma = dgamma * (dgamma + nimbility) / nimbility;
	  if (deltagamma > estimatedgamma + 2) dgamma += nimbility;
	  else if (deltagamma < estimatedgamma - 2) dgamma -= nimbility;
	}
	else if (deltagamma < 0)
	{
	  float estimatedgamma = -dgamma * (dgamma - nimbility) / nimbility;
	  if (deltagamma < estimatedgamma - 2) dgamma -= nimbility;
	  else if (deltagamma > estimatedgamma + 2) dgamma += nimbility;
	}
	gamma += dgamma;

  }
  
  if (easymodel)
  {
	  if (gamma > 180 + maxgamma) gamma = 180 + maxgamma;
	  else if (gamma < 180 - maxgamma) gamma = 180 - maxgamma;
  }
  else
  {
    (void) checkLooping ();
  }

/*	  if (gamma > 180 + maxgamma) gamma = 180 + maxgamma;
	  else if (gamma < 180 - maxgamma) gamma = 180 - maxgamma;*/

    if (target == NULL)
      targetNearestEnemy (f);
    if (target != NULL)
      if (!target->active)
        targetNearestEnemy (f);

    if (!ai || target == NULL)
    {
      if (debug)
      { printf (")"); fflush (stdout); }
      return;
    }

  disttarget = distance (target); // distance to target

	float dx2, dz2, ex, ez;
  float dx = target->tl->x - tl->x, dz = target->tl->z - tl->z; // actual distances
	if ((id >= FIGHTER1 && id <= FIGHTER2) || (id >= MISSILE1 && id <= MISSILE2) || (id >= FLAK1 && id <= FLAK2))
	{
	  float t = 10.0 * disttarget; // generous time to new position
	  if (t > 60) t = 60; // higher values will not make sense
    int tt = (int) target->theta;
    if (tt < 0) tt += 360;
	  float newphi = t * sine [tt] * 5.0 * target->manoeverability; // new angle of target after time t
    if (newphi > 90) newphi = 90;
    else if (newphi < -90) newphi = -90;
    newphi += (float) target->phi;
	  if (newphi >= 360) newphi -= 360;
	  if (newphi < 0) newphi += 360;
    if ((id >= FIGHTER1 && id <= FIGHTER2) || (id >= FLAK1 && id <= FLAK2))
    {
      ex = target->tl->x - sine [(int) newphi] * t * target->realspeed * 0.25; // estimated target position x
      ez = target->tl->z - cosi [(int) newphi] * t * target->realspeed * 0.25; // estimated target position z
    }
    else
    {
      ex = target->tl->x - sine [(int) newphi] * t * target->realspeed * 0.05; // estimated target position x
      ez = target->tl->z - cosi [(int) newphi] * t * target->realspeed * 0.05; // estimated target position z
    }
    dx2 = ex - tl->x; dz2 = ez - tl->z; // estimated distances
	}
	else
	{
	  dx2 = dx; dz2 = dz;
	}
    int a, w = (int) phi;
    if (dz2 > -0.0001 && dz2 < 0.0001) dz2 = 0.0001;

/*  if (intelligence == 0)
  {
	m [0]->tl->x = ex; //tl->x + dx2; // visualize estimated point by a missile
	m [0]->tl->z = ez; //tl->z + dz2;
	m [0]->active = false;
	m [0]->draw = true;
	m [0]->tl->y = target->tl->y;
  }*/

    a = (int) (atan (dx2 / dz2) * 180 / PI);
    if (dz2 > 0)
    {
      if (dx2 > 0) a -= 180;
      else a += 180;
    }
//    this->aw = a;
    aw = a - w;
    if (aw < -180) aw += 360;
    if (aw > 180) aw -= 360;

    if (manoevertheta > 0) manoevertheta --;
    if (id >= FIGHTER1 && id <= FIGHTER2)
    {
    if (!acttype && disttarget <= 1000 && !manoevertheta)
    {
      if (aw > 0)
      {
        if (aw > 180 - intelligence / 20 && disttarget < 15)
        {
          rectheta = -90;
          manoevertheta = 10 + myrandom ((400 - intelligence) / 4);
          recspeed = maxspeed - myrandom (intelligence) * 0.0003;
          if (!manoeverheight)
          { recheight = 5; manoeverheight = 8 - intelligence / 50; }
        }
        else
        {
          int maw = aw > 90 ? 90 : aw;
          maw = 90 - maw;
          rectheta = 90 - maw * intelligence / 100;
        }
      }
      else
      {
        if (aw < -180 + intelligence / 20 && disttarget < 15)
        {
          rectheta = 90;
          manoevertheta = 10 + myrandom ((400 - intelligence) / 4);
          recspeed = maxspeed - myrandom (intelligence) * 0.0003;
          if (!manoeverheight)
          { recheight = 5; manoeverheight = 8 - intelligence / 50; }
        }
        else
        {
          int maw = aw < -90 ? -90 : aw;
          maw = -90 - maw;
          rectheta = -90 - maw * intelligence / 100;
        }
//        rectheta = -90;
      }
//      if (rectheta > theta + 5.0) toLeft ();
//      else if (rectheta < theta - 5.0) toRight ();
    }
    }
    else if (id >= MISSILE1 && id <= MISSILE2)
    {
      if (abs (aw) < 50 && disttarget > 10)
        rectheta = 0;
      else
      {
      if (aw > 0)
      {
        rectheta = aw > 90 ? 90 : aw;
      }
      else
      {
        rectheta = aw < -90 ? -90 : aw;
      }
      }
    }
    else if (id >= FLAK1 && id <= FLAK2)
    {
      recspeed = 0; speed = 0;
      if (aw > 0)
      {
        rectheta = aw > 90 ? 90 : aw;
      }
      else
      {
        rectheta = aw < -90 ? -90 : aw;
      }
    }
    if (id >= FIGHTER1 && id <= FIGHTER2)
    {
      if (disttarget > 2.5 + aggressivity / 100)
  	  {
        if (disttarget < 50 && abs (aw) > 30)
          recspeed = maxspeed / 2;
        else speedUp ();
	    }
      else
      {
        if (recspeed > target->speed)
		    {
          speedDown ();
		    }
        else
    		{
          speedUp ();
		    }
      }
      if (disttarget > 60 && abs (aw) < 20)
        rectheta = 0; // fly straight
      float agr = 4.0 - aggressivity / 100;
      if (fabs (rectheta - theta) < 2 + agr && fabs (aw) < 20 + agr * 4 && disttarget < 30)
  	    fireCannon (c);
      else if (disttarget < 2 + agr && fabs (aw) < 20 + agr * 4)
  	    fireCannon (c);
      if (!firemissilettl)
      {
        if (target->id >= FIGHTER1 && target->id <= FIGHTER2)
          if (fabs (rectheta - theta) < 2 + agr && fabs (aw) < 20 + agr * 4 && disttarget < 30 && target->theta < 20)
  	        fireMissileAir (m, (AIObj *) target);
        else // ground target
          if (fabs (rectheta - theta) < 2 + agr && fabs (aw) < 20 + agr * 4 && disttarget < 50)
  	        fireMissileGround (m);
      }
      if (!manoevertheta)
      {
        rectheta += myrandom (precision) - precision / 2;
        if (rectheta > 90 - precision / 5) rectheta = 90 - precision / 5;
        else if (rectheta < -90 + precision / 5) rectheta = -90 + precision / 5;
      }
//      if (recspeed > maxspeed - 0.001 * intelligence)
//        recspeed = maxspeed - 0.001 * intelligence;
      idle ++;
      if (idle > 400)
      {
        idle = 0;
        if (rectheta < 0)
        { rectheta = 90; manoevertheta = 50 + myrandom (100); }
        if (rectheta > 0)
        { rectheta = -90; manoevertheta = 50 + myrandom (100); }
      }
    }

    if ((id >= FLAK1 && id <= FLAK2) || id == SHIP_CRUISER)
    {
      if (!(l->lsticker & 4))
      for (int i = 0; i < maxfighter; i ++)
      if (party != f [i]->party)
      {
        disttarget = distance (f [i]); // distance to target
        ex = f [i]->tl->x; // estimated target position x
        ez = f [i]->tl->z; // estimated target position z
        dx2 = ex - tl->x; dz2 = ez - tl->z; // estimated distances
        w = (int) phi;
        if (dz2 > -0.0001 && dz2 < 0.0001) dz2 = 0.0001;
        a = (int) (atan (dx2 / dz2) * 180 / PI);
        if (dz2 > 0)
        {
          if (dx2 > 0) a -= 180;
          else a += 180;
        }
        aw = a - w;
        if (aw < -180) aw += 360;
        if (aw > 180) aw -= 360;
        if (id == FLAK_AIR1)
          if (fabs (aw) < 35 && disttarget < 40) // + aggressive
            if (f [i]->tl->y > tl->y + 2)
    	        fireCannon (c);
        if (id == FLARAK_AIR1)
          if (!(l->lsticker & 31))
            if (fabs (aw) < 25 && disttarget < 40) // + aggressive
              if (f [i]->tl->y > tl->y + 2)
      	        fireMissileAir (m, f [i]);
        if (id == SHIP_CRUISER)
        {
          if (!(l->lsticker & 31))
          if (fabs (aw) >= -30 && fabs (aw) < 30 && disttarget < 40) // + aggressive
          {
    	      fireMissileAir (m, f [i]);
//            missiles ++;
          }
          if (fabs (aw) >= 0 && fabs (aw) < 40 && disttarget < 40) // + aggressive
    	      fireCannon (c, aw);
          if (fabs (aw) >= -40 && fabs (aw) < 0 && disttarget < 40) // + aggressive
    	      fireCannon (c, aw + 360);
          if (fabs (aw) >= 120 && fabs (aw) < 160 && disttarget < 40) // + aggressive
    	      fireCannon (c, aw);
          if (fabs (aw) >= -160 && fabs (aw) < -120 && disttarget < 40) // + aggressive
    	      fireCannon (c, aw + 360);
        }
      }
      rectheta += myrandom (intelligence) - intelligence / 2;
      if (rectheta > 90 - intelligence / 5) rectheta = 90 - intelligence / 5;
      else if (rectheta < -90 + intelligence / 5) rectheta = -90 + intelligence / 5;
    }
    if (debug)
    { printf (")"); fflush (stdout); }
  }
};

/*class Fighter : public AIObj
{
  public:

  void fighterinit ()
  {
    shield = 100; maxshield = 100;
    id = FIGHTER1;
    speed = 0.3;
    recspeed = 0.3;
    smoke->type = 1;
    impact = 2;
    missiles [0] = 10;
    missiles [1] = 10;
    missiles [2] = 10;
    missiles [3] = 10;
    missiles [4] = 10;
    ttl = -1;
    easymodel = true;
    aileroneffect = 0;
    ruddereffect = 0;
  }
  Fighter ()
  {
    o = NULL;
    zoom = 1.0;
    fighterinit ();
  }
  Fighter (Space *space2, CModel *o2, float zoom2)
  {
    o = o2;
    zoom = zoom2;
    this->space = space2;
    fighterinit ();
    space->addObject (this);
  }
};*/






CLoad3DS g_Load3ds;
CModel model_fig;
CModel model_figa;
CModel model_figb;
CModel model_figc;
CModel model_figd;
CModel model_figt;
CModel model_cannon1;
CModel model_cannon2;
CModel model_missile1;
CModel model_missile2;
CModel model_missile3;
CModel model_missile4;
CModel model_missile5;
CModel model_flak1;
CModel model_flarak1;
CModel model_tent1;
CModel model_ship1;
CModel model_gl117;




/*void RenderScene() 
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	// Clear The Screen And The Depth Buffer
	glLoadIdentity();									// Reset The matrix
    glShadeModel (GL_SMOOTH);
	glRotatef (-50, 1, 1, 1);

//////////// *** NEW *** ////////// *** NEW *** ///////////// *** NEW *** ////////////////////

	// Give OpenGL our position,	then view,		then up vector
//	gluLookAt(		0, 1.5f, 8,		0, 0.5f, 0,			0, 1, 0);
	
	// We want the model to rotate around the axis so we give it a rotation
	// value, then increase/decrease it. You can rotate right of left with the arrow keys.


	// Since we know how many objects our model has, go through each of them.
//model.draw ();

//////////// *** NEW *** ////////// *** NEW *** ///////////// *** NEW *** ////////////////////

	glutSwapBuffers ();
}
*/

/*void drawText (float x, float y, float z, char *str, CColor *c)
{
  int len = strlen (str);
  float zoom = 0.1;
  glDisable (GL_LIGHTING);
  glDisable (GL_DEPTH_TEST);
  gl->enableTextures (texfont1->textureID);
  gl->enableAlphaBlending ();
  glEnable (GL_ALPHA_TEST);
  glAlphaFunc (GL_GEQUAL, 0.1);
  glBegin (GL_QUADS);
  glColor4ub (c->c [0], c->c [1], c->c [2], c->c [3]);
  for (int i = 0; i < len; i ++)
  if (str [i] >= '-' && str [i] <= 'Z')
  {
    int c = (int) (str [i] - '-');
    if (c >= 14) c = (int) (str [i] - 'A') + 14;
    float dx = 34.0 / 256.0;
    float dy = 42.0 / 256.0, dy2 = dy;
    float tx = dx * (c % 7);
    float ty = 1.0 - dy * (c / 7);
    glTexCoord2f (tx, ty - dy2);
    glVertex3f ((x + i) * zoom, y * zoom, z);
    glTexCoord2f (tx, ty);
    glVertex3f ((x + i) * zoom, (y + 1) * zoom, z);
    glTexCoord2f (tx + dx, ty);
    glVertex3f ((x + i + 1) * zoom, (y + 1) * zoom, z);
    glTexCoord2f (tx + dx, ty - dy2);
    glVertex3f ((x + i + 1) * zoom, y * zoom, z);
  }
  glEnd ();
  glDisable (GL_ALPHA_TEST);
  gl->disableAlphaBlending ();
  glDisable (GL_TEXTURE_2D);
}

void drawText (float x, float y, float z, char *str)
{
  CColor stdcol (255, 255, 255, 190);
  drawText (x, y, z, str, &stdcol);
}

void drawTextRotated (float x, float y, float z, char *str, CColor *col, int timer)
{
  int len = strlen (str);
  float zoom = 0.1;
  glDisable (GL_LIGHTING);
  glDisable (GL_DEPTH_TEST);
  gl->enableTextures (texfont1->textureID);
  gl->enableAlphaBlending ();
  glEnable (GL_ALPHA_TEST);
  glAlphaFunc (GL_GEQUAL, 0.1);
  for (int i = 0; i < len; i ++)
  if (str [i] >= '-' && str [i] <= 'Z')
  {
    int c = (int) (str [i] - '-');
    if (c >= 14) c = (int) (str [i] - 'A') + 14;
    float dx = 34.0 / 256.0;
    float dy = 42.0 / 256.0, dy2 = dy;
    float tx = dx * (c % 7);
    float ty = 1.0 - dy * (c / 7);
    glPushMatrix ();
    glTranslatef ((0.5 + x + i) * zoom, (0.5 + y) * zoom, z);
    gl->rotate (timer + i * 20, 0, 0);
    glBegin (GL_QUADS);
    glColor4ub (col->c [0], col->c [1], col->c [2], col->c [3]);
    glTexCoord2f (tx, ty - dy2);
    glVertex3f (-0.5 * zoom, -0.5 * zoom, 0);
    glTexCoord2f (tx, ty);
    glVertex3f (-0.5 * zoom, 0.5 * zoom, 0);
    glTexCoord2f (tx + dx, ty);
    glVertex3f (0.5 * zoom, 0.5 * zoom, 0);
    glTexCoord2f (tx + dx, ty - dy2);
    glVertex3f (0.5 * zoom, -0.5 * zoom, 0);
    glEnd ();
    glPopMatrix ();
  }
  gl->disableAlphaBlending ();
  glDisable (GL_ALPHA_TEST);
  glDisable (GL_TEXTURE_2D);
}*/










AIObj *missile [maxmissile];
DynamicObj *laser [maxlaser];
AIObj *fighter [maxfighter];
Star *star [maxstar];
DynamicObj *groundobj [maxgroundobj];
Flash *flash1;

Space *space;

AIObj *fplayer;
CSpaceObj *sphere;
CSphere *objsphere;

//GLLandscape *l;
CModel *obj, *objlaser, *objmissile;
CVector3 *clip1, *clip2, *tlnull, *tlinf, *tlminf;

EditField pilotedit;

GLenum polygonMode = GL_FILL;

GLfloat light_position0[] = { 0.0, 0.5, -1.0, 0 };

#define max(x,y) ((x)>(y)?(x):(y))

int NX, NY;

int joystick;

#define MISSION_DEMO 0
#define MISSION_TUTORIAL 1
#define MISSION_DOGFIGHT 2
#define MISSION_SADEFENSE 3
#define MISSION_CRUISER 4
#define MISSION_MOON 5
#define MISSION_CANYON 6
#define MISSION_DESERT 7
#define MISSION_MULTIPLAYER 1000
#define MISSION_MULTIPLAYER_DOGFIGHT 1000

class Mission
{
  protected:
  void autoLFBriefing ()
  {
    int i, z = 0;
    for (i = 0; i < (int) strlen (briefing); i ++)
    {
      z ++;
      if (z > 50 && briefing [i] == ' ')
      {
        briefing [i] = '\n';
        z = 0;
      }
    }
  }

  public:
  int timer;
  int maxtime;
  int alliedfighters;
  char briefing [1000];
  char name [64];
  int id;
  int selfighter [3];
  int selfighters, wantfighter;
  CColor textcolor;

  Mission ()
  {
    int i;
    timer = 0;
    for (i = 0; i < 3; i ++)
      selfighter [i] = 0;
    selfighter [0] = FIGHTER_FALCON;
    selfighter [1] = FIGHTER_HAWK;
    selfighter [2] = FIGHTER_HAWK2;
    selfighters = 2;
    wantfighter = 0;
    textcolor.setColor (255, 255, 0, 128);
  }
  void playerInit ()
  {
    fplayer = fighter [0];
    if (controls != 100)
      fplayer->easymodel = false;
    fplayer->target = NULL;
    fplayer->newinit (selfighter [wantfighter], 1, 0);
    if (selfighter [wantfighter] == FIGHTER_FALCON) fplayer->o = &model_fig;
    else if (selfighter [wantfighter] == FIGHTER_HAWK) fplayer->o = &model_figb;
    else if (selfighter [wantfighter] == FIGHTER_HAWK2) fplayer->o = &model_figc;
    fplayer->ai = false;
  }
  void init ()
  {
  }
  virtual void start ()
  {
  }
  virtual int processtimer ()
  {
    return 0;
  }
  virtual void draw ()
  {
  }
  void checkScore (int missionstate, int timebonus, int fighterkills, int shipkills, int tankkills, int otherkills, int shieldbonus, int points)
  {
    Pilot *p = pilots->pilot [pilots->aktpilot];
    int oldscore = getScore (p->mission_state [id], p->mission_time [id], p->mission_fighterkills [id], p->mission_shipkills [id], p->mission_tankkills [id], p->mission_otherkills [id], p->mission_shield [id], p->mission_points [id]);
    int newscore = getScore (missionstate, timebonus, fighterkills, shipkills, tankkills, otherkills, shieldbonus, points);
    if (newscore > oldscore)
    {
      p->mission_state [id] = missionstate;
      p->mission_time [id] = timebonus;
      p->mission_fighterkills [id] = fighterkills;
      p->mission_shipkills [id] = shipkills;
      p->mission_tankkills [id] = tankkills;
      p->mission_otherkills [id] = otherkills;
      p->mission_shield [id] = shieldbonus;
      p->mission_points [id] = points;
      p->mission_score [id] = newscore;
      p->save ();
    }
  }
  int getScore (int missionstate, int timebonus, int fighterkills, int shipkills, int tankkills, int otherkills, int shieldbonus, int points)
  {
    int score = timebonus + shieldbonus + fighterkills * 20 + shipkills * 12 + tankkills * 10 + otherkills * 5 + points / 20;
    if (missionstate == 2) // if failed
    {
      score /= 4;
      score -= 100;
    }
    return score;
  }
  int getScore (int missionstate)
  {
    int shieldbonus = fplayer->shield * 100 / fplayer->maxshield;
    int timebonus = 0;
    if (timer < maxtime)
      timebonus = (maxtime - timer) * 100 / maxtime;
    checkScore (missionstate, timebonus, fplayer->fighterkills, fplayer->shipkills, fplayer->tankkills, fplayer->otherkills, shieldbonus, fplayer->points);
    return getScore (missionstate, timebonus, fplayer->fighterkills, fplayer->shipkills, fplayer->tankkills, fplayer->otherkills, shieldbonus, fplayer->points);
  }
};

class MissionDemo1 : public Mission
{
  public:
  
  MissionDemo1 ()
  {
    id = MISSION_DEMO;
    strcpy (name, "DEMO");
    alliedfighters = 2;
  }

  virtual void start ()
  {
    int i;
    if (l != NULL) delete l;
    l = new GLLandscape (space, LANDSCAPE_ALPINE, NULL);
    day = 0;
    weather = 0;
    camera = 5;
    sungamma = 45;
    fplayer = fighter [0];
    fplayer->tl->x = 220;
    fplayer->tl->z = -30;
    fplayer->target = fighter [2];
    fplayer->newinit (FIGHTER_FALCON, 1, 0);
    fighter [1]->target = fighter [3];
    fighter [1]->o = &model_fig;
    fighter [1]->tl->x = 49;
    fighter [1]->tl->z = -30;
    fighter [1]->newinit (FIGHTER_FALCON, 1, 0);
    for (i = 2; i <= 8; i ++)
    {
      fighter [i]->target = fighter [myrandom (2)];
      fighter [i]->o = &model_figa;
      fighter [i]->newinit (FIGHTER_SWALLOW, 0, 400 - i * 20);
    }
  }
  
  virtual int processtimer ()
  {
    bool b = false;
    int i;
    timer ++;
    if (!fplayer->active && fplayer->explode >= 35)
    {
      return 2;
    }
    for (i = 0; i <= 8; i ++)
    {
      if (fighter [i]->active)
        if (fighter [i]->party == 0)
          b = true;
    }
    if (b) return 0;
    return 1;
  }
  
  virtual void draw ()
  {
  }
};

class MissionTutorial1 : public Mission
{
  private:
  bool loop;

  public:
  
  MissionTutorial1 ()
  {
    id = MISSION_TUTORIAL;
    strcpy (name, "TUTORIAL");
    alliedfighters = 1;
    strcpy (briefing, "LEARN TO HANDLE YOUR FIGHTER AND THE BASIC CONTROLS LIKE TARGETING OR FIRING A MISSILE.");
    autoLFBriefing ();
    maxtime = 1200;
  }

  virtual void start ()
  {
    if (l != NULL) delete l;
    l = new GLLandscape (space, LANDSCAPE_LOW_ALPINE, NULL);
//    l = new GLLandscape (space, LANDSCAPE_CANYON, NULL);
    day = 1;
    weather = 0;
    camera = 0;
    sungamma = 50;
    playerInit ();
    fplayer->tl->x = 220;
    fplayer->tl->z = -30;
    loop = false;
  }

  virtual int processtimer ()
  {
    timer ++;
    if (!fplayer->active && fplayer->explode >= 35)
      return 2;
    if (!fighter [1]->active && fighter [1]->explode >= 35 && !fighter [2]->active && fighter [2]->explode >= 35)
      return 1;
    return 0;
  }

  virtual void draw ()
  {
    int timeroff = 70, timerdelay = 200;
    if (timer >= 0 && timer <= timeroff - 20)
    {
      font1->drawTextCentered (0, 4, -2, name, &textcolor);
    }
    else if (timer > timeroff && timer <= timeroff + timerdelay - 20)
    {
      if (controls == 2)
      {
        font1->drawTextCentered (0, 7, -2.5, "LEAVE THE JOYSTICK CENTERED", &textcolor);
        font1->drawTextCentered (0, 6, -2.5, "THE FIGHTER SHOULD FLY STRAIGHT ON", &textcolor);
        font1->drawTextCentered (0, 5, -2.5, "IF NOT, RECALIBRATE YOUR JOYSTICK", &textcolor);
      }
      else if (controls == 1)
      {
        font1->drawTextCentered (0, 7, -2.5, "THE MENU OPTIONS/CONTROLS LETS YOU", &textcolor);
        font1->drawTextCentered (0, 6, -2.5, "DETERMINE THE INPUT DEVICE.", &textcolor);
        font1->drawTextCentered (0, 5, -2.5, "CURRENTLY, THIS IS THE MOUSE", &textcolor);
      }
      else if (controls == 0)
      {
        font1->drawTextCentered (0, 7, -2.5, "THE MENU OPTIONS/CONTROLS LETS YOU", &textcolor);
        font1->drawTextCentered (0, 6, -2.5, "DETERMINE THE INPUT DEVICE.", &textcolor);
        font1->drawTextCentered (0, 5, -2.5, "CURRENTLY, THIS IS THE KEYBOARD", &textcolor);
      }
/*      if (!loop) fplayer->gamma += 2;
      else fplayer->gamma -= 2;
      if (fplayer->checkLooping ()) loop = !loop;*/
    }
    else if (timer > timeroff + timerdelay && timer <= timeroff + 2 * timerdelay - 20)
    {
      if (controls == 2)
      {
        font1->drawTextCentered (0, 7, -2.5, "MOVING THE JOYSTICK LEFT OR RIGHT", &textcolor);
        font1->drawTextCentered (0, 6, -2.5, "WILL AFFECT THE AILERON", &textcolor);
        font1->drawTextCentered (0, 5, -2.5, "THUS YOU WILL ONLY ROLL", &textcolor);
      }
      else if (controls == 1)
      {
        font1->drawTextCentered (0, 7, -2.5, "THE MOUSE INTERFACE IS VERY EASY", &textcolor);
        font1->drawTextCentered (0, 6, -2.5, "ALWAYS POINT TO WHERE YOU WANT TO FLY", &textcolor);
        font1->drawTextCentered (0, 5, -2.5, "YOU'LL HAVE TO MOVE THE MOUSE PERMANENTLY", &textcolor);
      }
      else if (controls == 0)
      {
        font1->drawTextCentered (0, 7, -2.5, "THE KEYBOARD INTERFACE IS NOT SO EASY", &textcolor);
        font1->drawTextCentered (0, 6, -2.5, "USING THE MOUSE IS STRONLY RECOMMENDED", &textcolor);
      }
    }
    else if (timer > timeroff + 2 * timerdelay && timer <= timeroff + 3 * timerdelay - 20)
    {
      if (controls == 2)
      {
        font1->drawTextCentered (0, 7, -2.5, "MOVING UP OR DOWN WILL AFFECT", &textcolor);
        font1->drawTextCentered (0, 6, -2.5, "THE ELEVATOR", &textcolor);
        font1->drawTextCentered (0, 5, -2.5, "YOU'LL START TO FLY A LOOP", &textcolor);
      }
      else if (controls == 1 || controls == 0)
      {
        font1->drawTextCentered (0, 7, -2.5, "MOVING RIGHT OR LEFT WILL AFFECT THE AILERON", &textcolor);
        font1->drawTextCentered (0, 6, -2.5, "MOVING UP OR DOWN WILL AFFECT THE ELEVATOR", &textcolor);
        font1->drawTextCentered (0, 5, -2.5, "THUS YOU CAN FLY ROLLS AND LOOPS", &textcolor);
      }
    }
    else if (timer > timeroff + 3 * timerdelay && timer <= timeroff + 4 * timerdelay - 20)
    {
      if (controls == 2)
      {
        font1->drawTextCentered (0, 7, -2.5, "IF YOUR JOYSTICK HAS A SO-CALLED \"RUDDER\",", &textcolor);
        font1->drawTextCentered (0, 6, -2.5, "YOU MAY ALTER THE FIGHTER'S RUDDER", &textcolor);
        font1->drawTextCentered (0, 5, -2.5, "YOU'LL SLIGHTLY FLY TO THE LEFT OR RIGHT", &textcolor);
      }
      else if (controls == 1)
      {
        font1->drawTextCentered (0, 7, -2.5, "HOWEVER, THERE IS NO RUDDER CONTROL", &textcolor);
        font1->drawTextCentered (0, 6, -2.5, "PLEASE USE THE KEYS PGUP AND PGDN", &textcolor);
      }
      else if (controls == 0)
      {
        font1->drawTextCentered (0, 7, -2.5, "TO ALTER THE RUDDER", &textcolor);
        font1->drawTextCentered (0, 6, -2.5, "USE THE KEYS PGUP AND PGDN", &textcolor);
      }
    }
    else if (timer > timeroff + 4 * timerdelay && timer <= timeroff + 5 * timerdelay - 20)
    {
      if (controls == 2)
      {
        font1->drawTextCentered (0, 7, -2.5, "YOUR JOYSTICK HAS ALSO A THROTTLE", &textcolor);
        font1->drawTextCentered (0, 6, -2.5, "TO SPEEDUP OR DECELERATE", &textcolor);
        font1->drawTextCentered (0, 5, -2.5, "THERE IS NO WAY TO ENTIRELY STOP", &textcolor);
      }
      else
      {
        font1->drawTextCentered (0, 7, -2.5, "USE THE KEYS '1' THROUGH '9' TO ALTER", &textcolor);
        font1->drawTextCentered (0, 6, -2.5, "YOUR THROTTLE (SPEED)", &textcolor);
        font1->drawTextCentered (0, 5, -2.5, "THERE IS NO WAY TO ENTIRELY STOP", &textcolor);
      }
    }
    else if (timer > timeroff + 5 * timerdelay && timer <= timeroff + 6 * timerdelay - 20)
    {
      if (controls == 2)
      {
        font1->drawTextCentered (0, 7, -2.5, "THE FIRST FOUR JOYSTICK BUTTONS:", &textcolor);
        font1->drawTextCentered (0, 6, -2.5, "1: FIRE CANNON, 2: TARGET NEAREST ENEMY", &textcolor);
        font1->drawTextCentered (0, 5, -2.5, "3: FIRE MISSILE, 4: CHOOSE MISSILE", &textcolor);
      }
      else if (controls == 1)
      {
        font1->drawTextCentered (0, 7, -2.5, "LEFT MOUSE BUTTON: FIRE CANNON", &textcolor);
        font1->drawTextCentered (0, 6, -2.5, "RIGHT MOUSE BUTTON: FIRE MISSILE", &textcolor);
        font1->drawTextCentered (0, 5, -2.5, "BUT YOU WILL ALSO HAVE TO USE THE KEYBOARD", &textcolor);
      }
      else if (controls == 0)
      {
        font1->drawTextCentered (0, 6, -2.5, "NOW, LETS HAVE A LOOK AT SOME IMPORTANT KEYS", &textcolor);
      }
    }
    else if (timer > timeroff + 6 * timerdelay && timer <= timeroff + 7 * timerdelay - 20)
    {
      if (controls == 2)
      {
        font1->drawTextCentered (0, 7, -2.5, "A SUMMARY OF COMMANDS CAN BE FOUND IN THE MENU", &textcolor);
        font1->drawTextCentered (0, 6, -2.5, "\"ESC\" WILL SHOW THE MENU", &textcolor);
        font1->drawTextCentered (0, 5, -2.5, "AND RETURN BACK TO THE ACTION", &textcolor);
      }
      else
      {
        font1->drawTextCentered (0, 7, -2.5, "SPACE: FIRE CANNON (UNLIMITED AMMO)", &textcolor);
        font1->drawTextCentered (0, 6, -2.5, "M: CHOOSE MISSILE", &textcolor);
        font1->drawTextCentered (0, 5, -2.5, "ENTER: FIRE MISSILE", &textcolor);
      }
    }
    else if (timer > timeroff + 7 * timerdelay && timer <= timeroff + 8 * timerdelay - 20)
    {
      font1->drawTextCentered (0, 7, -2.5, "LOOK AT THE RADAR ON THE BOTTOM OF YOUR SCREEN", &textcolor);
      font1->drawTextCentered (0, 6, -2.5, "THERE ARE ENEMIES REPRESENTED BY A YELLOW POINT (TARGETED)", &textcolor);
      font1->drawTextCentered (0, 5, -2.5, "AND A RED POINT (NOT TARGETED)", &textcolor);
    }
    else if (timer > timeroff + 8 * timerdelay && timer <= timeroff + 9 * timerdelay - 20)
    {
      if (controls == 2)
      {
        font1->drawTextCentered (0, 7, -2.5, "YOU MAY TARGET AN ENEMY USING THE COOLIE HAT,", &textcolor);
        font1->drawTextCentered (0, 6, -2.5, "BUTTON2, OR PRESSING 'T' ON THE KEYBOARD", &textcolor);
        font1->drawTextCentered (0, 5, -2.5, "THEN APPROACH!", &textcolor);
      }
      else
      {
        font1->drawTextCentered (0, 7, -2.5, "YOU MAY TARGET AN ENEMY PRESSING", &textcolor);
        font1->drawTextCentered (0, 6, -2.5, "'T' ON THE KEYBOARD", &textcolor);
        font1->drawTextCentered (0, 5, -2.5, "THEN APPROACH!", &textcolor);
      }
    }
    else if (timer > timeroff + 9 * timerdelay && timer <= timeroff + 10 * timerdelay - 20)
    {
      font1->drawTextCentered (0, 7, -2.5, "SHOOT THE TARGETS TO COMPLETE", &textcolor);
      font1->drawTextCentered (0, 6, -2.5, "THIS TUTORIAL SUCCESSFULLY", &textcolor);
    }
    if (timer == timeroff + 7 * timerdelay - 10)
    {
      fighter [1]->activate ();
      fighter [1]->target = fighter [0];
      fighter [1]->o = &model_figt;
      fighter [1]->newinit (FIGHTER_TRANSPORT, 0, 200);
      fighter [1]->tl->x = fplayer->tl->x - 30;
      fighter [1]->tl->z = fplayer->tl->z - 30;
      fighter [2]->activate ();
      fighter [2]->target = fighter [0];
      fighter [2]->o = &model_figt;
      fighter [2]->newinit (FIGHTER_TRANSPORT, 0, 200);
      fighter [2]->tl->x = fplayer->tl->x + 30;
      fighter [2]->tl->z = fplayer->tl->z + 30;
    }
  }
};

class MissionDogfight1 : public Mission
{
  public:

  MissionDogfight1 ()
  {
    id = MISSION_DOGFIGHT;
    strcpy (name, "DOGFIGHT");
    strcpy (briefing, "THIS IS JUST A SIMPLE DEMO MISSION TO PRACTICE YOUR DOGFIGHT SKILLS.");
    autoLFBriefing ();
    alliedfighters = 2;
    maxtime = 2000;
  }
    
  virtual void start ()
  {
    int i;
    if (l != NULL) delete l;
    l = new GLLandscape (space, LANDSCAPE_ALPINE, NULL);
    day = 1;
    weather = 0;
    camera = 0;
    sungamma = 25;
    playerInit ();
    fplayer->tl->x = 50;
    fplayer->tl->z = 100;
    fighter [1]->target = fighter [4];
    fighter [1]->o = &model_fig;
    fighter [1]->newinit (FIGHTER_FALCON, 1, 100);
    fighter [1]->tl->x = 55;
    fighter [1]->tl->z = 110;
    for (i = 2; i <= 6; i ++)
    {
      fighter [i]->intelligence = 400;
      fighter [i]->party = 0;
      fighter [i]->target = fighter [0];
      fighter [i]->o = &model_figd;
      fighter [i]->newinit (FIGHTER_BUZZARD, 0, 450 - i * 50);
    }
  }

  virtual int processtimer ()
  {
    bool b = false;
    int i;
    timer ++;
    if (!fplayer->active && fplayer->explode >= 35)
    {
      return 2;
    }
    for (i = 0; i <= 4; i ++)
    {
      if (fighter [i]->active)
        if (fighter [i]->party == 0)
          b = true;
    }
    if (b) return 0;
    return 1;
  }

  virtual void draw ()
  {
    if (timer >= 0 && timer <= 50)
    {
      font1->drawTextCentered (0, 4, -2, name, &textcolor);
    }
  }
};

class MissionGround1 : public Mission
{
  public:

  MissionGround1 ()
  {
    id = MISSION_SADEFENSE;
    strcpy (name, "SA DEFENSE");
    strcpy (briefing, "THIS IS JUST A SIMPLE DEMO MISSION");
    autoLFBriefing ();
    alliedfighters = 1;
    maxtime = 2000;
  }

  virtual void start ()
  {
    int i;
    if (l != NULL) delete l;
    l = new GLLandscape (space, LANDSCAPE_ALPINE_NOLAKE, NULL);
    day = 0;
    weather = 1;
    camera = 0;
    sungamma = 60;
    int px, py;
    l->searchPlain (1, 1, &px, &py);
    l->gauss (px, py);
    px = px - MAXX / 2;
    py = MAXX / 2 - py;
    groundobj [0]->activate ();
    groundobj [0]->tl->x = px - 1;
    groundobj [0]->tl->z = py - 1;
    groundobj [0]->tl->y = l->getHeight (px - 1, py - 1);
    groundobj [0]->o = &model_tent1;
    groundobj [0]->shield = 100;
    groundobj [0]->zoom = 0.5;
    groundobj [1]->activate ();
    groundobj [1]->tl->x = px + 1;
    groundobj [1]->tl->z = py - 1;
    groundobj [1]->tl->y = l->getHeight (px + 1, py - 1);
    groundobj [1]->o = &model_tent1;
    groundobj [1]->shield = 100;
    groundobj [1]->zoom = 0.5;
    playerInit ();
    fplayer->tl->x = px + 50;
    fplayer->tl->z = py + 50;
    for (i = 1; i <= 3; i ++)
    {
      fighter [i]->tl->x = px - 3 + i * 3;
      fighter [i]->tl->z = py + 2;
      fighter [i]->target = fighter [0];
      if (i == 2)
      {
        fighter [i]->o = &model_flarak1;
        fighter [i]->newinit (FLARAK_AIR1, 0, 400);
      }
      else
      {
        fighter [i]->o = &model_flak1;
        fighter [i]->newinit (FLAK_AIR1, 0, 400);
      }
    }
/*      fighter [2]->activate ();
      fighter [2]->intelligence = 300;
      fighter [2]->party = 0;
      fighter [2]->target = fighter [0];
      fighter [2]->o = &model_figa;
      fighter [3]->activate ();
      fighter [3]->intelligence = 150;
      fighter [3]->party = 0;
      fighter [3]->target = fighter [0];
      fighter [3]->o = &model_figa;*/
  }

  virtual int processtimer ()
  {
    bool b = false;
    int i;
    timer ++;
    if (!fplayer->active && fplayer->explode >= 35)
    {
      return 2;
    }
    for (i = 0; i <= 4; i ++)
    {
      if (fighter [i]->active)
        if (fighter [i]->party == 0)
          b = true;
    }
    if (b) return 0;
    return 1;
  }

  virtual void draw ()
  {
    if (timer >= 0 && timer <= 50)
    {
      font1->drawTextCentered (0, 4, -2, name, &textcolor);
    }
  }
};

class MissionShip1 : public Mission
{
  public:

  MissionShip1 ()
  {
    id = MISSION_CRUISER;
    strcpy (name, "CRUISER ATTACK");
    strcpy (briefing, "THIS IS JUST A SIMPLE DEMO MISSION");
    autoLFBriefing ();
    alliedfighters = 2;
    maxtime = 2000;
  }

  virtual void start ()
  {
    if (l != NULL) delete l;
    l = new GLLandscape (space, LANDSCAPE_SEA, NULL);
    day = 0;
    weather = 0;
    camera = 0;
    sungamma = 60;
    playerInit ();
    fplayer->tl->x = 50;
    fplayer->tl->z = 50;
    fighter [2]->tl->x = 0;
    fighter [2]->tl->z = 0;
    fighter [2]->target = fighter [0];
    fighter [2]->o = &model_ship1;
    fighter [2]->newinit (SHIP_CRUISER, 0, 0);
    fighter [3]->target = fighter [2];
    fighter [3]->o = &model_figc;
    fighter [3]->tl->x = 60;
    fighter [3]->tl->z = 60;
    fighter [3]->newinit (FIGHTER_HAWK2, 1, 150);
  }

  virtual int processtimer ()
  {
    bool b = false;
    int i;
    timer ++;
    if (!fplayer->active && fplayer->explode >= 35)
    {
      return 2;
    }
    for (i = 0; i <= 4; i ++)
    {
      if (fighter [i]->active)
        if (fighter [i]->party == 0)
          b = true;
    }
    if (b) return 0;
    return 1;
  }

  virtual void draw ()
  {
    if (timer >= 0 && timer <= 50)
    {
      font1->drawTextCentered (0, 4, -2, name, &textcolor);
    }
  }
};

class MissionMoon1 : public Mission
{
  public:

  MissionMoon1 ()
  {
    id = MISSION_MOON;
    strcpy (name, "MOON");
    strcpy (briefing, "THIS IS JUST A SIMPLE DEMO MISSION");
    autoLFBriefing ();
    alliedfighters = 1;
    maxtime = 2000;
  }

  virtual void start ()
  {
    if (l != NULL) delete l;
    l = new GLLandscape (space, LANDSCAPE_MOON, NULL);
    day = 0;
    weather = 2;
    camera = 0;
    sungamma = 50;
    playerInit ();
    fplayer->tl->x = 50;
    fplayer->tl->z = 50;
    fighter [1]->target = fighter [0];
    fighter [1]->o = &model_figa;
    fighter [1]->newinit (FIGHTER_SWALLOW, 0, 200);
    fighter [2]->target = fighter [0];
    fighter [2]->o = &model_figa;
    fighter [2]->newinit (FIGHTER_SWALLOW, 0, 150);
  }

  virtual int processtimer ()
  {
    bool b = false;
    int i;
    timer ++;
    if (!fplayer->active && fplayer->explode >= 35)
    {
      return 2;
    }
    for (i = 0; i <= 4; i ++)
    {
      if (fighter [i]->active)
        if (fighter [i]->party == 0)
          b = true;
    }
    if (b) return 0;
    return 1;
  }

  virtual void draw ()
  {
    if (timer >= 0 && timer <= 50)
    {
      font1->drawTextCentered (0, 4, -2, name, &textcolor);
    }
  }
};

class MissionCanyon1 : public Mission
{
  public:

  MissionCanyon1 ()
  {
    id = MISSION_CANYON;
    strcpy (name, "CANYON");
    strcpy (briefing, "THIS IS JUST A SIMPLE DEMO MISSION");
    autoLFBriefing ();
    alliedfighters = 2;
    maxtime = 2000;
  }

  virtual void start ()
  {
    int i;
    if (l != NULL) delete l;
    l = new GLLandscape (space, LANDSCAPE_CANYON, NULL);
    day = 1;
    weather = 0;
    camera = 0;
    sungamma = 15;
    playerInit ();
    fplayer->tl->x = 50;
    fplayer->tl->z = 100;
    fighter [1]->target = fighter [4];
    fighter [1]->o = &model_fig;
    fighter [1]->newinit (FIGHTER_FALCON, 1, 100);
    fighter [1]->tl->x = 55;
    fighter [1]->tl->z = 110;
    for (i = 2; i < 8; i ++)
    {
      fighter [i]->intelligence = 400;
      fighter [i]->party = 0;
      fighter [i]->target = fighter [myrandom (2)];
      fighter [i]->o = &model_figa;
      fighter [i]->newinit (FIGHTER_SWALLOW, 0, 450 - i * 40);
    }
  }

  virtual int processtimer ()
  {
    bool b = false;
    int i;
    timer ++;
    if (!fplayer->active && fplayer->explode >= 35)
    {
      return 2;
    }
    for (i = 0; i <= 4; i ++)
    {
      if (fighter [i]->active)
        if (fighter [i]->party == 0)
          b = true;
    }
    if (b) return 0;
    return 1;
  }

  virtual void draw ()
  {
    if (timer >= 0 && timer <= 50)
    {
      font1->drawTextCentered (0, 4, -2, name, &textcolor);
    }
  }
};

class MissionDesert1 : public Mission
{
  public:

  MissionDesert1 ()
  {
    id = MISSION_DESERT;
    strcpy (name, "DESERT");
    strcpy (briefing, "THIS IS JUST A SIMPLE DEMO MISSION");
    autoLFBriefing ();
    alliedfighters = 2;
    maxtime = 2000;
  }

  virtual void start ()
  {
    int i;
    if (l != NULL) delete l;
    l = new GLLandscape (space, LANDSCAPE_DESERT, NULL);
    day = 1;
    weather = 0;
    camera = 0;
    sungamma = 45;
    playerInit ();
    fplayer->tl->x = 50;
    fplayer->tl->z = 100;
    fighter [1]->target = fighter [4];
    fighter [1]->o = &model_fig;
    fighter [1]->newinit (FIGHTER_FALCON, 1, 100);
    fighter [1]->tl->x = 55;
    fighter [1]->tl->z = 110;
    for (i = 2; i < 6; i ++)
    {
      fighter [i]->intelligence = 400;
      fighter [i]->party = 0;
      fighter [i]->target = fighter [myrandom (2)];
      fighter [i]->o = &model_figa;
      fighter [i]->newinit (FIGHTER_SWALLOW, 0, 450 - i * 40);
    }
  }

  virtual int processtimer ()
  {
    bool b = false;
    int i;
    timer ++;
    if (!fplayer->active && fplayer->explode >= 35)
    {
      return 2;
    }
    for (i = 0; i <= 4; i ++)
    {
      if (fighter [i]->active)
        if (fighter [i]->party == 0)
          b = true;
    }
    if (b) return 0;
    return 1;
  }

  virtual void draw ()
  {
    if (timer >= 0 && timer <= 50)
    {
      font1->drawTextCentered (0, 4, -2, name, &textcolor);
    }
  }
};

class MissionMultiDogfight1 : public Mission
{
  public:

  MissionMultiDogfight1 ()
  {
    id = MISSION_MULTIPLAYER_DOGFIGHT;
    strcpy (name, "MULTIPLAYER");
    strcpy (briefing, "THIS IS JUST A SIMPLE DEMO MISSION");
    autoLFBriefing ();
    alliedfighters = 2;
  }

  virtual void start ()
  {
    int i;
    if (l != NULL) delete l;
    l = new GLLandscape (space, LANDSCAPE_ALPINE, NULL);
    day = 1;
    weather = 0;
    camera = 0;
    sungamma = 25;
    for (i = 0; i <= 1; i ++)
    {
      fighter [i]->activate ();
      fighter [i]->ai = false;
      fighter [i]->party = i;
      fighter [i]->target = fighter [0];
      fighter [i]->o = &model_fig;
      fighter [i]->tl->x = 50 + i * 30;
      fighter [i]->tl->z = 100;
    }
    fighter[1]->ai = true;
    if (isserver)
      fplayer = fighter [0];
    else
      fplayer = fighter [1];
    if (controls != 100)
      fplayer->easymodel = false;
  }

  virtual int processtimer ()
  {
    bool b = false;
    int i;
    timer ++;
    if (!fplayer->active && fplayer->explode >= 35)
    {
      return 2;
    }
    for (i = 0; i <= 4; i ++)
    {
      if (fighter [i]->active)
        if (fighter [i]->party == 0)
          b = true;
    }
    if (b) return 0;
    return 1;
  }

  virtual void draw ()
  {
    if (timer >= 0 && timer <= 50)
    {
      font1->drawTextCentered (0, 0, -1, "DOGFIGHT");
    }
  }
};

Mission *mission = NULL;
Mission *missionnew = NULL;

class Cockpit
{
  public:

/*  float getGamma (DynamicObj *obj)
  {
    float dy = obj->tl->y - fplayer->tl->y;
    float dx = fplayer->distance (obj);
    if (dx == 0) dx = 1E-5;
    return atan (dy / dx) * 180.0 / PI;
  }

  float getPhi (DynamicObj *obj)
  {
    float dx2 = obj->tl->x - fplayer->tl->x, dz2 = obj->tl->z - fplayer->tl->z; // actual distances
    float a, aw, w = fplayer->phi;
    if (dz2 > -0.0001 && dz2 < 0.0001) dz2 = 0.0001;
    a = atan (dx2 / dz2) * 180 / PI;
    if (dz2 > 0)
    {
      if (dx2 > 0) a -= 180;
      else a += 180;
    }
    aw = a - w;
    if (aw < -180) aw += 360;
    if (aw > 180) aw -= 360;
    return aw;
  }*/

  void drawTargeter ()
  {
    if (fplayer->target)
    if (fplayer->target->active)
    {
/*      float gamma = getGamma (fplayer->target);
      float phi = getPhi (fplayer->target);
      float mx = width / 2, my = height / 2;
      float x = mx + phi / 90.0 * width;
      float y = my + gamma / 90.0 * height;
      float dx = x - mx, dy = my - y;
      int t = (int) fplayer->theta;
      if (t < 0) t += 360;
      float rx = dx * cosi [t] - dy * sine [t];
      float ry = dx * sine [t] + dy * cosi [t];
      rx += mx;
      ry = my - ry;*/
/*      DynamicObj *o = fplayer->target;
      glBegin (GL_LINE_STRIP);
      glColor4ub (255, 255, 0, 150);
      glVertex3f (o->tl->x - o->zoom, o->tl->y - o->zoom, o->tl->z - o->zoom);
      glVertex3f (o->tl->x + o->zoom, o->tl->y - o->zoom, o->tl->z - o->zoom);
      glVertex3f (o->tl->x + o->zoom, o->tl->y - o->zoom, o->tl->z + o->zoom);
      glVertex3f (o->tl->x - o->zoom, o->tl->y - o->zoom, o->tl->z + o->zoom);
      glVertex3f (o->tl->x - o->zoom, o->tl->y - o->zoom, o->tl->z - o->zoom);
      glVertex3f (o->tl->x - o->zoom, o->tl->y + o->zoom, o->tl->z - o->zoom);
      glVertex3f (o->tl->x + o->zoom, o->tl->y + o->zoom, o->tl->z - o->zoom);
      glVertex3f (o->tl->x + o->zoom, o->tl->y + o->zoom, o->tl->z + o->zoom);
      glVertex3f (o->tl->x - o->zoom, o->tl->y + o->zoom, o->tl->z + o->zoom);
      glVertex3f (o->tl->x - o->zoom, o->tl->y + o->zoom, o->tl->z - o->zoom);
      glEnd ();
      glBegin (GL_LINES);
      glVertex3f (o->tl->x + o->zoom, o->tl->y - o->zoom, o->tl->z - o->zoom);
      glVertex3f (o->tl->x + o->zoom, o->tl->y + o->zoom, o->tl->z - o->zoom);
      glVertex3f (o->tl->x + o->zoom, o->tl->y - o->zoom, o->tl->z + o->zoom);
      glVertex3f (o->tl->x + o->zoom, o->tl->y + o->zoom, o->tl->z + o->zoom);
      glVertex3f (o->tl->x - o->zoom, o->tl->y - o->zoom, o->tl->z + o->zoom);
      glVertex3f (o->tl->x - o->zoom, o->tl->y + o->zoom, o->tl->z + o->zoom);
      glEnd ();*/
      DynamicObj *o = fplayer->target;
      float myphi = fplayer->phi;
      if (myphi < 0) myphi += 360;
      float ex1 = cosi [(int) myphi] * o->zoom, ey1 = -sine [(int) myphi] * o->zoom;
      float ex2 = -ex1, ey2 = -ey1;
      float ez = o->zoom;
      gl->enableAlphaBlending ();
      glBegin (GL_LINE_STRIP);
      if (((AIObj *) fplayer->target)->party != fplayer->party)
        glColor4ub (255, 0, 0, 255);
      else
        glColor4ub (0, 0, 255, 255);
      glVertex3f (o->tl->x + ex1, o->tl->y + ez, o->tl->z + ey1);
      glVertex3f (o->tl->x + ex2, o->tl->y + ez, o->tl->z + ey2);
      glVertex3f (o->tl->x + ex2, o->tl->y - ez, o->tl->z + ey2);
      glVertex3f (o->tl->x + ex1, o->tl->y - ez, o->tl->z + ey1);
      glVertex3f (o->tl->x + ex1, o->tl->y + ez, o->tl->z + ey1);
      glEnd ();
      gl->disableAlphaBlending ();
    }

  }

  void drawCross ()
  {
    glDisable (GL_LIGHTING);
/*    gl->enableAlphaBlending ();
    glDisable (GL_DEPTH_TEST);
    glLineWidth (2.0);
    glDisable (GL_DEPTH_TEST);
    glBegin (GL_LINES);
    glColor4f (1.0, 1.0, 0.0, 0.5);
    float zf = -18.0, g = 2.0, g2 = 0.8;
    glVertex3f (-g, 0.0, zf);
    glVertex3f (g, 0.0, zf);
    glVertex3f (0.0, -g, zf);
    glVertex3f (0.0, g, zf);
    glVertex3f (-g2, -g, zf);
    glVertex3f (g2, -g, zf);
    glVertex3f (-g2, g, zf);
    glVertex3f (g2, g, zf);
    glVertex3f (-g, -g2, zf);
    glVertex3f (-g, g2, zf);
    glVertex3f (g, -g2, zf);
    glVertex3f (g, g2, zf);
    glEnd ();
    gl->disableAlphaBlending ();*/

  gl->enableAlphaBlending ();
  glEnable (GL_ALPHA_TEST);
  glAlphaFunc (GL_GEQUAL, 0.1);
//  glTexEnvi (GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
  gl->enableTextures (texcross->textureID);

  float xf = 0.1, yf = 0.1, zf = 1.0;
  glBegin (GL_QUADS);
  glColor4ub (255, 255, 0, 255);
  glTexCoord2d (0, 0);
  glVertex3f (-xf, -yf, -zf);
  glTexCoord2d (0, 1);
  glVertex3f (-xf, yf, -zf);
  glTexCoord2d (1, 1);
  glVertex3f (xf, yf, -zf);
  glTexCoord2d (1, 0);
  glVertex3f (xf, -yf, -zf);
  glEnd ();
  glDisable (GL_ALPHA_TEST);
  glDisable (GL_TEXTURE_2D);
  gl->disableAlphaBlending ();
//  glTexEnvi (GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
  }

  void drawHeading ()
  {
    CColor color;
    int i = 0;
    int alpha = 175;
    color.setColor (255, 255, 0);
    color.c [3] = alpha;
    glDisable (GL_LIGHTING);
    glLineWidth (2.0);
    glDisable (GL_DEPTH_TEST);
    float xf;
    float yf = 17.5;
    float zf = -2.5;
    float g = 0.5;
//    float p1 = fplayer->phi - 40.0;
//    float p2 = fplayer->phi + 40.0;
    for (i = 0; i < 360; i += 5)
    {
      float p = (float) i - fplayer->phi;
      if (p < -180) p += 360;
      if (p > 180) p -= 360;
      if (p >= -40 && p <= 40)
      {
        if (i == 0 || i == 90 || i == 180 || i == 270)
          g = 0.6;
        else if (!(i % 10))
          g = 0.3;
        else
          g = 0.1;
        xf = p / 6.0;
        gl->enableAlphaBlending ();
        glBegin (GL_LINES);
        glColor4ub (255, 255, 0, alpha);
        glVertex3f (xf * 0.1, (yf - g) * 0.1, zf);
        glVertex3f (xf * 0.1, (yf + g) * 0.1, zf);
        glEnd ();
        if (i == 0)
          font1->drawText (xf - 0.5, yf - 2.0, zf, "N", &color);
        else if (i == 90)
          font1->drawText (xf - 0.5, yf - 2.0, zf, "W", &color);
        else if (i == 180)
          font1->drawText (xf - 0.5, yf - 2.0, zf, "S", &color);
        else if (i == 270)
          font1->drawText (xf - 0.5, yf - 2.0, zf, "E", &color);
      }
    }

/*    if (fplayer->target != NULL)
      if (fplayer->target->active)
      {
        int aw = fplayer->getAngle (fplayer->target);
//        printf ("aw = %d\n", aw);
        if (aw < -50)
        {
          glBegin (GL_LINE_STRIP);
          if (((AIObj *) fplayer->target)->party != fplayer->party)
            glColor4ub (255, 0, 0, alpha);
          else
            glColor4ub (0, 0, 255, alpha);
          glVertex3f (0.6, 0.1 * (yf - 1), zf);
          glVertex3f (0.65, 0.1 * yf, zf);
          glVertex3f (0.6, 0.1 * (yf + 1), zf);
          glEnd ();
        }
        else if (aw > 50)
        {
          glBegin (GL_LINE_STRIP);
          if (((AIObj *) fplayer->target)->party != fplayer->party)
            glColor4ub (255, 0, 0, alpha);
          else
            glColor4ub (0, 0, 255, alpha);
          glVertex3f (-0.6, 0.1 * (yf - 1), zf);
          glVertex3f (-0.65, 0.1 * yf, zf);
          glVertex3f (-0.6, 0.1 * (yf + 1), zf);
          glEnd ();
        }
      }*/

    if (fplayer->target != NULL)
      if (fplayer->target->active)
      {
        float dgamma = atan ((fplayer->target->tl->y - fplayer->tl->y) / fplayer->distance (fplayer->target)) * 180 / PI - (fplayer->gamma - 180);
        float dphi = fplayer->getAngle (fplayer->target);
        if (fabs (dphi) > 50 || fabs (dgamma) > 50)
        {
        if (dphi < -90) dphi = -90;
        else if (dphi > 90) dphi = 90;
        float delta = atan (dgamma / dphi) * 180 / PI;
        if (dphi > 0) delta -= 180;
//        printf ("delta=%f, dgamma=%f, dphi=%f\n",delta, dgamma, dphi);
        delta += fplayer->theta;
        while (delta < 0) delta += 360;
        while (delta >= 360) delta -= 360;
        float xs = cosi [(int) delta] * 3;
        float ys = -sine [(int) delta] * 3;
/*        if (xs > 3) xs = 3;
        else if (xs < -3) xs = -3;
        if (ys > 3) ys = 3;
        else if (ys < -3) ys = -3;*/
        zf = -4;
        glBegin (GL_LINE_STRIP);
        glColor4ub (255, 0, 0, alpha);
        glVertex3f (xs - 0.12, ys - 0.12, zf);
        glVertex3f (xs + 0.12, ys - 0.12, zf);
        glVertex3f (xs + 0.12, ys + 0.12, zf);
        glVertex3f (xs - 0.12, ys + 0.12, zf);
        glVertex3f (xs - 0.12, ys - 0.12, zf);
        glEnd ();
        glBegin (GL_LINES);
        glVertex3f (xs - 0.15, ys - 0.15, zf);
        glVertex3f (xs + 0.15, ys + 0.15, zf);
        glVertex3f (xs + 0.15, ys - 0.15, zf);
        glVertex3f (xs - 0.15, ys + 0.15, zf);
        glEnd ();
        }
      }

    zf = -3.5;
    for (i = 0; i < 360; i += 5)
    {
      float p = (float) i - fplayer->gamma;
      if (p < -180) p += 360;
      if (p > 180) p -= 360;
      if (p >= -30 && p <= 30)
      {
        if (i == 0 || i == 90 || i == 180 || i == 270)
          g = 0.6;
        else if (!(i % 10))
          g = 0.3;
        else
          g = 0.1;
        xf = p / 6.0;
        gl->enableAlphaBlending ();
        yf = -7;
        glBegin (GL_LINES);
        glColor4ub (255, 255, 0, alpha);
        glVertex3f ((yf - g) * 0.1, xf * 0.1, zf);
        glVertex3f ((yf + g) * 0.1, xf * 0.1, zf);
        glEnd ();
        yf = -8.5;
        if (i == 120)
          font1->drawText (yf - 2.0, xf - 0.5, zf, "-60", &color);
        else if (i == 150)
          font1->drawText (yf - 2.0, xf - 0.5, zf, "-30", &color);
        else if (i == 180)
          font1->drawText (yf - 2.0, xf - 0.5, zf, "0", &color);
        else if (i == 210)
          font1->drawText (yf - 2.0, xf - 0.5, zf, "30", &color);
        else if (i == 240)
          font1->drawText (yf - 2.0, xf - 0.5, zf, "60", &color);
      }
    }

    gl->enableAlphaBlending ();
    int t1 = (int) (fplayer->theta - 135.0);
    int t2 = t1 + 90, t3 = t1 + 180, t4 = t1 + 270;
    if (t1 != 0) t1 %= 360;
    if (t2 != 0) t2 %= 360;
    if (t3 != 0) t3 %= 360;
    if (t4 != 0) t4 %= 360;
    if (t1 < 0) t1 += 360;
    if (t2 < 0) t2 += 360;
    if (t3 < 0) t3 += 360;
    if (t4 < 0) t4 += 360;
    xf = 0.6; yf = 0.6;
    glBegin (GL_LINES);
    glColor4ub (255, 255, 0, 130);
    glVertex3f (xf * cosi [t1], yf * sine [t1], zf);
    glVertex3f (xf * cosi [t2], yf * sine [t2], zf);
    glVertex3f (xf * cosi [t3], yf * sine [t3], zf);
    glVertex3f (xf * cosi [t4], yf * sine [t4], zf);
    glEnd ();
    gl->disableAlphaBlending ();
  }

  void drawTargetedElement ()
  {
    char str [20];
    CColor color;
    CVector3 tl, n;
    CRotation r;
    color.setColor (255, 0, 0);
    color.c [3] = 255;
    tl.x = -0.35; tl.y = -0.3; tl.z = -0.5;
    gl->disableAlphaBlending ();
    glEnable (GL_DEPTH_TEST);
    if (fplayer->target != NULL)
      if (fplayer->target->active)
      {
        fplayer->target->o->draw3 (&n, &tl, fplayer->target->rot, 0.05, 0);
        if (((AIObj *) fplayer->target)->party == fplayer->party)
          color.setColor (0, 0, 255);
        font1->drawText (-24.0, -23.0, -4.0, fplayer->target->o->name, &color);
        sprintf (str, "%d", (int) (15.0 * fplayer->distance (fplayer->target)));
        font1->drawText (-24.0, -25.0, -4.0, str, &color);
      }
/*    color.setColor (255, 255, 255);
    sprintf (str, "MISSILES: %d", fplayer->missiles);
    font1->drawText (20.0, -25.0, -4.0, str, &color);*/
    glDisable (GL_DEPTH_TEST);
//    font1->drawText (0, 0, -5.0, "ABCDEFG", &color);
  }

  void drawWeapon ()
  {
    char str [20];
    CColor color;
    CVector3 tl, n;
    CRotation r;
    if (fplayer->missiles [fplayer->missiletype] <= 0)
      return;
    color.setColor (255, 0, 0);
    color.c [3] = 255;
    tl.x = 0.35; tl.y = -0.3; tl.z = -0.5;
    gl->disableAlphaBlending ();
    glEnable (GL_DEPTH_TEST);
    CModel *missile;
    if (fplayer->missiletype == 0) missile = &model_missile1;
    else if (fplayer->missiletype == 1) missile = &model_missile2;
    else if (fplayer->missiletype == 2) missile = &model_missile3;
    else if (fplayer->missiletype == 3) missile = &model_missile4;
    else if (fplayer->missiletype == 4) missile = &model_missile5;
    glEnable (GL_LIGHTING);
    missile->draw (&n, &tl, fplayer->rot, 0.05, 1.0, 0);
    glDisable (GL_LIGHTING);
    glDisable (GL_DEPTH_TEST);
    font1->drawText (16.0, -22.0, -4.0, missile->name, &color);
    sprintf (str, "N %d", fplayer->missiles [fplayer->missiletype]);
    font1->drawText (16.0, -24.0, -4.0, str, &color);
  }

  void drawRadar ()
  {
    int i;
    float yf = -4.5, zf = -7.0;
    gl->enableAlphaBlending ();
    glDisable (GL_DEPTH_TEST);
    glBegin (GL_QUADS);
    glColor4ub (255, 255, 0, 100);
    glVertex3f (-1.2, yf - 1.0, zf);
    glVertex3f (1.2, yf - 1.0, zf);
    glVertex3f (1.2, yf + 1.0, zf);
    glVertex3f (-1.2, yf + 1.0, zf);
    glEnd ();
    glPointSize (2.0);
    glBegin (GL_POINTS);
    glColor4ub (200, 200, 200, 255);
    glVertex3f (0.0, yf, zf);
    for (i = 0; i < maxfighter; i ++)
      if (fighter [i] != fplayer && fighter [i]->active)
      {
        int aw = fplayer->getAngle (fighter [i]);
        if (aw < 0) aw += 360;
        float d = fplayer->distance (fighter [i]) / 100.0;
        float px = - d * sine [aw];
        float py = yf + d * cosi [aw];
        if (px >= -1.2 && px <= 1.2 && py >= yf - 1.0 && py <= yf + 1.0)
        {
          if (fighter [i] == fplayer->target)
            glColor4ub (255, 200, 0, 255);
          else if (fighter [i]->party != fplayer->party)
            glColor4ub (255, 0, 0, 255);
          else
            glColor4ub (0, 0, 255, 255);
          glVertex3f (px, py, zf);
        }
      }
    glEnd ();
    gl->disableAlphaBlending ();
  }

};




class ConfigFile
{
  public:
  char buf [32000];
  int length;
  FILE *out;
  ConfigFile () {}
  ConfigFile (char *fname)
  {
//    int z;
    bool commentmode = false;
    FILE *in;
    length = 0;
    in = fopen (fname, "rb");
    if (in != NULL)
    {
      length = fread (buf, 1, 32000, in);
      fclose (in);
    }
    else buf [0] = 0;
    for (int i = 0; i < length; i ++)
    {
      if (buf [i] == '#') commentmode = true;
      if (buf [i] == '\n') commentmode = false;
      if (commentmode) buf [i] = ' ';
      else buf [i] = tolower (buf [i]);
    }
  }
  char *skipwhite (char *str)
  {
    while (*str == ' ' || *str == '\t')
      str ++;
    return str;
  }
  char *skipnum (char *str)
  {
    while (*str >= '0' && *str <= '9')
      str ++;
    return str;
  }
  char *getString (char *dest, char *str)
  {
    char *strf, *stre;
    char cmpstr [256];
    int i;
    if (strlen (str) >= 256) { return NULL; }
    strcpy (cmpstr, str);
    if (buf [0] == 0) { return NULL; }
    for (i = 0; i < (int) strlen (cmpstr); i ++)
    {
      cmpstr [i] = tolower (cmpstr [i]);
    }
    strf = strstr (buf, cmpstr);
    if (strf == NULL) { return NULL; }
    strf += strlen (cmpstr);
    strf = skipwhite (strf);
    if (*strf == 0) { return NULL; }
    strf ++;
    if (*strf == 0) { return NULL; }
    strf = skipwhite (strf);
    if (*strf == 0) { return NULL; }
    stre = skipnum (strf);
    if (stre - strf >= 256) { return NULL; }
    if (*strf == 0) { return NULL; }
    for (i = 0; i < (int) (stre - strf); i ++)
      dest [i] = *(strf+i);
    dest [i] = 0;
    return dest;
  }
  int getValue (char *str)
  {
    char res [256];
    getString (res, str);
    if (res == NULL) return -1;
    return atoi (res);
  }
  int openOutput (char *fname)
  {
    out = fopen (fname, "wb");
    if (out == NULL) return 0;
    return 1;
  }
  int write (char *str1, int n)
  {
    char str [256];
    if (strlen (str1) + 8 > 256) return 0;
    sprintf (str, "%s = %d\n", str1, n);
    fwrite (str, 1, strlen (str), out);
    return 1;
  }
  void writeText (char *str)
  {
    fwrite (str, 1, strlen (str), out);
    fwrite ("\n", 1, 1, out);
  }
  void close ()
  {
    fclose (out);
  }
};

void save_config ()
{
  ConfigFile *cf = new ConfigFile ();
  int ret1 = cf->openOutput ("conf");
  if (ret1 == 0) return;
  cf->writeText ("# Configuration\n");
  cf->writeText ("# Some possible width x height values for fullscreen mode:");
  cf->writeText ("#  640x480, 800x600, 1024x768");
  cf->write (" width", width);
  cf->write (" height", height);
  cf->writeText ("# Possible bits per pixel values (color depth):");
  cf->writeText ("#  8 (not recommended), 16, 24, 32");
  cf->write (" bpp", bpp);
  cf->writeText ("# Try to go fullscreen = 1, game in window = 0");
  cf->write (" fullscreen", fullscreen);
  cf->writeText ("# Quality: 0=software rendered up to 5=best (default=3)");
  cf->write (" quality", quality);
  cf->writeText ("# Far clipping plane: 20..100 (default=50)");
  cf->write (" view", (int) view);
#ifdef HAVE_SDL_MIXER
  cf->writeText ("# Sound volume: 0..100 (default=100) per cent");
  cf->write (" sound", (int) volumesound);
  cf->writeText ("# Music volume: 0..100 (default=100) per cent");
  cf->write (" music", (int) volumemusic);
#endif
  cf->writeText ("# Piloting controls: 0=keyboard, 1=mouse, 2=joystick");
  cf->write (" controls", controls);
  cf->writeText ("\n# This file is meant to give sensible startup settings");
  cf->writeText ("# as graphic cards and drivers may differ some 100 times in speed");
  cf->writeText ("\n# To get back to default settings, just delete this file!");
  cf->close ();
}

void load_config ()
{
  char ret [256];
  char *str;
  ConfigFile *cf = new ConfigFile ("conf");
  
  str = cf->getString (ret, "width");
  if (str == NULL)
  { width = 800; }
  else
  { width = atoi (str); }
  if (width < 100) width = 100;
  else if (width > 3000) width = 3000;

  cf->getString (ret, "height");
  if (str == NULL)
  { height = 600; }
  else
  { height = atoi (str); }
  if (height < 100) height = 100;
  else if (height > 2000) height = 2000;

  cf->getString (str, "bpp");
  if (str == NULL)
  { bpp = 32; }
  else
  { bpp = atoi (str); }
  if (bpp != 8 && bpp != 16 && bpp != 24 && bpp != 32)
    bpp = 32;

  cf->getString (str, "fullscreen");
  if (str == NULL)
  { fullscreen = 1; }
  else
  { fullscreen = atoi (str); }
  if (fullscreen) fullscreen = 1;

  cf->getString (str, "quality");
  if (str == NULL)
  { quality = 3; }
  else
  { quality = atoi (str); }
  if (quality < 0) quality = 0;
  else if (quality > 5) quality = 5;

  cf->getString (str, "view");
  if (str == NULL)
  { view = 50; }
  else
  { view = atoi (str); }
  if (view < 20) view = 20;
  else if (view > 100) view = 100;

#ifdef HAVE_SDL_MIXER
  cf->getString (str, "sound");
  if (str == NULL)
  { volumesound = 100; }
  else
  { volumesound = atoi (str); }
  if (volumesound < 0) volumesound = 0;
  else if (volumesound > 100) volumesound = 100;

  cf->getString (str, "music");
  if (str == NULL)
  { volumemusic = 100; }
  else
  { volumemusic = atoi (str); }
  if (volumemusic < 0) volumemusic = 0;
  else if (volumemusic > 100) volumemusic = 100;
#endif

  cf->getString (str, "controls");
  if (str == NULL)
  { controls = 1; }
  else
  { controls = atoi (str); }
  if (controls < 0) controls = 0;
  else if (controls > 2) controls = 0;
}




#ifndef USE_GLUT
SDL_Joystick *sdljoystick;
#endif
int sdldisplay = true;
int sdlreshape = true;
Cockpit *cockpit;

/*void drawTexture (float r, float p1, float t1, float p2, float t2)
{
  gl->enableTextures ();
  gl->enableAlphaBlending ();
  glDisable (GL_DITHER);
  glBegin (GL_QUADS);
  float f = atan(1.0)*4.0 / 180.0;
  float sinp1 = sin (p1*f), sinp2 = sin (p2*f), sint1 = sin (t1*f), sint2 = sin (t2*f);
  float cosp1 = cos (p1*f), cosp2 = cos (p2*f), cost1 = cos (t1*f), cost2 = cos (t2*f);
  float x = r * cosp1 * sint2, y = r * sinp1 * sint2, z = r * cost2;
  printf ("(%f,%f,%f)\n", x,y,z); fflush (stdout);
  glColor4f (1.0, 1.0, 1.0, 1.0);
  glTexCoord2d (0, 1);
  glVertex3f (x, y, z);
  x = r * cosp2 * sint2, y = r * sinp2 * sint2, z = r * cost2;
  glTexCoord2d (1, 1);
  glVertex3f (x, y, z);
  x = r * cosp2 * sint1, y = r * sinp2 * sint1, z = r * cost1;
  glTexCoord2d (1, 0);
  glVertex3f (x, y, z);
  x = r * cosp1 * sint1, y = r * sinp1 * sint1, z = r * cost1;
  glTexCoord2d (0, 0);
  glVertex3f (x, y, z);
  glEnd ();
  glDisable (GL_TEXTURE_2D);
}*/

bool initing = true;
int flash = 0;
int lastshield = 0;

void setPlaneVolume ()
{
  if (game == GAME_PLAY)
  {
    int lev = (int) ((float) 128 * fplayer->speed / fplayer->maxspeed) - 32;
    sound->setVolume (SOUND_PLANE1, lev);
  }
  else
    sound->setVolume (SOUND_PLANE1, 0);
}

void setLightSource (int gamma)
{
  light_position0 [0] = -cosi [gamma];
  light_position0 [1] = sine [gamma];
  light_position0 [2] = 0;
  glLightfv( GL_LIGHT0, GL_POSITION, light_position0 );
}

void game_levelInit ()
{
  int i;

  initing = true;
  flash = 0;

  for (i = 0; i < maxfighter; i ++)
  {
    fighter [i]->dinit ();
    fighter [i]->aiinit ();
//    fighter [i]->fighterinit ();
    fighter [i]->explode = 0;
    fighter [i]->tl->x = 0;
    fighter [i]->tl->z = -i * 10;
    fighter [i]->party = 0;
    fighter [i]->zoom = 0.35;
    fighter [i]->deactivate ();
    fighter [i]->recheight = 15;
    fighter [i]->recspeed = 0.2;
    fighter [i]->rectheta = 0;
    fighter [i]->o = &model_fig;
  }

  for (i = 0; i < maxgroundobj; i ++)
  {
    groundobj [i]->dinit ();
    groundobj [i]->zoom = 1;
    groundobj [i]->id = STATIC;
    groundobj [i]->deactivate ();
  }

//  if (l != NULL) delete l;
  if (!multiplayer || isserver || !isserver) // clients do not need the mission
  {
    if (mission != NULL)
    { delete mission; mission = NULL; }
    mission = missionnew;
    missionnew = NULL;
    mission->start ();
  }

  for (i = 0; i < maxfighter; i ++)
  {
    if (fighter [i]->id >= FLAK1 && fighter [i]->id <= FLAK2)
    {
      fighter [i]->tl->y = l->getExactHeight (fighter [i]->tl->x, fighter [i]->tl->z) + fighter [i]->zoom;
    }
    else if (fighter [i]->id >= SHIP1 && fighter [i]->id <= SHIP2)
    {
      fighter [i]->tl->y = l->getExactHeight (fighter [i]->tl->x, fighter [i]->tl->z) + fighter [i]->zoom / 4;
    }
    else
    {
      fighter [i]->tl->y = l->getHeight (fighter [i]->tl->x, fighter [i]->tl->z) + 20;
    }
  }

  for (i = 0; i < maxlaser; i ++)
  {
    laser [i]->deactivate ();
    if (day)
    {
      laser [i]->o = &model_cannon1;
      laser [i]->zoom = 0.07;
    }
    else
    {
      laser [i]->o = &model_cannon2;
      laser [i]->zoom = 0.1;
    }
  }

  for (i = 0; i < maxmissile; i ++)
  {
    missile [i]->aiinit ();
    missile [i]->deactivate ();
  }

  for (i = 0; i < maxstar; i ++)
  {
    star [i]->phi = myrandom (360);
    star [i]->gamma = myrandom (85);
    star [i]->size = 0.6 + 0.15 * myrandom (8);
  }

  if (day && weather == 0)
  {
    if (sungamma < 35)
      objsphere->setColor (new CColor ((unsigned short) (127 + 70 - 2 * sungamma), 127, 127));
    else
      objsphere->setColor (new CColor (127, 127, 127));
    if (sungamma < 35)
      gl->fogcolor [0] = (float) (127 + 70 - 2 * sungamma) / 256.0;
    else
      gl->fogcolor [0] = 0.5;
    gl->fogcolor [1] = 0.5;
    gl->fogcolor [2] = 0.5;
    objsphere->setNorthPoleColor (new CColor (50, 200, 255), 1.8);
    objsphere->setPoleColor (90, (int) (90 - sungamma), new CColor (200, 200, 200), 0.3);
  }
  else if (!day && weather == 0)
  {
    objsphere->setColor (new CColor (64, 64, 64));
    gl->fogcolor [0] = 0.25;
    gl->fogcolor [1] = 0.25;
    gl->fogcolor [2] = 0.25;
    objsphere->setNorthPoleColor (new CColor (0, 0, 170), 1.8);
    objsphere->setPoleColor (90, (int) (90 - sungamma), new CColor (64, 64, 64), 0.3);
  }
  else if (day && weather == 1)
  {
    objsphere->setColor (new CColor (102, 102, 102));
    gl->fogcolor [0] = 0.4;
    gl->fogcolor [1] = 0.4;
    gl->fogcolor [2] = 0.4;
    objsphere->setNorthPoleColor (new CColor (102, 102, 102), 1.8);
  }
  else if (!day && weather == 1)
  {
    objsphere->setColor (new CColor (40, 40, 40));
    gl->fogcolor [0] = 0.16;
    gl->fogcolor [1] = 0.16;
    gl->fogcolor [2] = 0.16;
    objsphere->setNorthPoleColor (new CColor (40, 40, 40), 1.8);
  }
  else if (weather == 2)
  {
    objsphere->setColor (new CColor (20, 20, 20));
    gl->fogcolor [0] = 0.08;
    gl->fogcolor [1] = 0.08;
    gl->fogcolor [2] = 0.08;
  }
  glDeleteLists (objsphere->list1, 1);
  glDeleteLists (objsphere->list2, 1);
  glDeleteLists (objsphere->list3, 1);
  objsphere->list1 = -1;
  objsphere->list2 = -1;
  objsphere->list3 = -1;

//  glLightfv( GL_LIGHT0, GL_AMBIENT, light_ambient );
/*  float light_specular [3] = {0.5, 0.5, 0.5};
  glLightfv( GL_LIGHT0, GL_SPECULAR, light_specular );*/
  setLightSource (sungamma);
  glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_FALSE);
	glEnable(GL_LIGHT0);								// Turn on a light with defaults set
	glEnable(GL_LIGHTING);								// Turn on lighting
	glEnable(GL_COLOR_MATERIAL);						// Allow color

  glHint (GL_PERSPECTIVE_CORRECTION_HINT, GL_FASTEST);
  glDisable (GL_DITHER);

//  mission = new MissionDemo1 (space);
  initing = false;
  lastshield = fplayer->shield;

#ifdef HAVE_SDL_NET
  if (multiplayer)
  {
    if (threadnet != NULL)
      SDL_KillThread (threadnet);
    threadnet = SDL_CreateThread (net_thread_main, NULL);
  }
#endif

}

void game_reshape ()
{
  /* Darstellung auf gesamten Clientbereich des Fensters zulassen */
  glViewport(0, 0, (GLint) width, (GLint) height);

  glMatrixMode (GL_PROJECTION);
  glLoadIdentity ();
  /* angle, aspect, near Clip, far Clip */
  float v = getView ();
  if (camera == 50) v = 100000.0;
  gluPerspective (80.0, (float) width / height, 0.20, v); // should be sqrt(2) or 1.5
  glPolygonMode (GL_FRONT_AND_BACK, polygonMode);

#ifndef USE_GLUT
  if (controls == 1)
    SDL_ShowCursor (1);
  else
    SDL_ShowCursor (0);
#endif
}

void menu_reshape ()
{
  /* Darstellung auf gesamten Clientbereich des Fensters zulassen */
  glViewport(0, 0, (GLint) width, (GLint) height);

  glMatrixMode (GL_PROJECTION);
  glLoadIdentity ();
  /* angle, aspect, near Clip, far Clip */
  float v = getView ();
  if (camera == 50) v = 100000.0;
  gluPerspective (80.0, 1.0, 0.20, v); // should be sqrt(2) or 1.5
  glPolygonMode (GL_FRONT_AND_BACK, polygonMode);

#ifndef USE_GLUT
  SDL_ShowCursor (0);
#endif
}

void credits_reshape ()
{
  /* Darstellung auf gesamten Clientbereich des Fensters zulassen */
  glViewport(0, 0, (GLint) width, (GLint) height);

  glMatrixMode (GL_PROJECTION);
  glLoadIdentity ();
  /* angle, aspect, near Clip, far Clip */
  float v = getView ();
  if (camera == 50) v = 100000.0;
  gluPerspective (80.0, 1.0, 0.20, v); // should be sqrt(2) or 1.5
  glPolygonMode (GL_FRONT_AND_BACK, polygonMode);

#ifndef USE_GLUT
  SDL_ShowCursor (0);
#endif
}

void game_quit ()
{
  int i;
  volumesound = sound->volumesound;
  volumemusic = sound->volumemusic;
  save_config ();
  pilots->save ("../saves/pilots");
  for (i = 0; i < maxfighter; i ++)
    delete (fighter [i]);
  delete pilots;
// free allocated memory (optional)
#ifndef USE_GLUT
/*	SDL_CloseAudio();
	SDL_FreeWAV(wave.sound);*/
  SDL_Quit ();
#endif
  exit (0);
}

void switch_menu ()
{
  setLightSource (sungamma);
  game = GAME_MENU;
  menu_reshape ();
  if (!sound->musicplaying)
    sound->playMusic (MUSIC_DARK1);
  sound->stop (SOUND_PLANE1);
}

void createMission (int missionid)
{
  if (missionid >= MISSION_MULTIPLAYER)
    multiplayer = true;
  else
  {
    multiplayer = false;
    isserver = false;
  }
  if (missionnew != NULL) delete missionnew;
  if (missionid == MISSION_DEMO) missionnew = new MissionDemo1 ();
  else if (missionid == MISSION_TUTORIAL) missionnew = new MissionTutorial1 ();
  else if (missionid == MISSION_DOGFIGHT) missionnew = new MissionDogfight1 ();
  else if (missionid == MISSION_SADEFENSE) missionnew = new MissionGround1 ();
  else if (missionid == MISSION_CRUISER) missionnew = new MissionShip1 ();
  else if (missionid == MISSION_MOON) missionnew = new MissionMoon1 ();
  else if (missionid == MISSION_CANYON) missionnew = new MissionCanyon1 ();
  else if (missionid == MISSION_DESERT) missionnew = new MissionDesert1 ();
  else if (missionid == MISSION_MULTIPLAYER_DOGFIGHT) missionnew = new MissionMultiDogfight1 ();
}

void switch_mission (int missionid)
{
  setLightSource (60);
  game = GAME_MISSION;
  createMission (missionid);
  menu_reshape ();
  if (!sound->musicplaying)
    sound->playMusic (MUSIC_DARK1);
  sound->stop (SOUND_PLANE1);
}

void switch_create ()
{
  setLightSource (60);
  game = GAME_CREATE;
  isserver = true;
  if (server != NULL) delete server;
  server = new Server ();
  menu_reshape ();
  if (!sound->musicplaying)
    sound->playMusic (MUSIC_DARK1);
  sound->stop (SOUND_PLANE1);
}

void switch_join ()
{
  setLightSource (60);
  game = GAME_JOIN;
  isserver = false;
  if (client != NULL) delete client;
  client = new Client ();
  menu_reshape ();
  if (!sound->musicplaying)
    sound->playMusic (MUSIC_DARK1);
  sound->stop (SOUND_PLANE1);
}

int creditstimer;

void switch_credits ()
{
  game = GAME_CREDITS;
  creditstimer = 50;
  credits_reshape ();
  if (sound->musicplaying)
    sound->haltMusic ();
  sound->playMusic (MUSIC_WINNER1);
  sound->stop (SOUND_PLANE1);
}

void switch_game ()
{
  setLightSource (sungamma);
  game = GAME_PLAY;
  game_reshape ();
  if (sound->musicplaying)
    sound->haltMusic ();
  sound->playLoop (SOUND_PLANE1);
  setPlaneVolume ();
}

void game_key (unsigned char key, int x, int y)
{
  if (camera == 50 && game == GAME_PAUSE)
  {
    camera = 0;
    game = GAME_PLAY;
    return;
  }
  if (key == 'v')
  {
    view += 10.0;
    if (view > 110) view = 30;
    game_reshape ();
    sound->play (SOUND_CLICK1);
  }
  else if (key == 'q')
  {
    quality ++;
    if (quality > 5) quality = 0;
    if (quality <= 1) space->drawlight = false;
    else space->drawlight = true;
    sound->play (SOUND_CLICK1);
//      printf ("\nQuality = %d", quality); fflush (stdout);
  }
  else if (key == 27)
  {
    switch_menu ();
  }
  else if (key == 13)
  {
    fplayer->fireMissile (fplayer->missiletype + MISSILE1, missile);
    sound->play (SOUND_MISSILE1);
  }
  else if (key == ' ')
  {
#ifdef USE_GLUT
    fplayer->fireCannon (laser);
    sound->play (SOUND_CANNON1);
#else
    fplayer->autofire = true;
#endif
  }
    else if (key == 'm')
    {
      fplayer->missiletype = fplayer->nextMissile (fplayer->missiletype);
//      printf ("%d missiles left\n", fplayer->missiles);
    }
/*    else if (key == 'l')
    {
      if (lighting == 0) lighting = 1;
      else lighting = 0;
    }
    else if (key == 'm')
    {
      if (mode == 0) mode = 1;
      else mode = 0;
    }*/
    else if (key >= '1' && key <= '9')
    {
      fplayer->recspeed = fplayer->maxspeed * (1.0 / 18.0 * (key - '0') + 0.5);
      sound->play (SOUND_CLICK1);
    }
    else if (key == 'a')
    {
      fplayer->ai = !fplayer->ai;
      fplayer->easymodel = fplayer->ai;
      if (controls == 100)
        fplayer->easymodel = true;
    }
    else if (key == 'p')
    {
/*      printf ("pos: x=%f, z=%f\n", fplayer->tl->x, fplayer->tl->z);
      printf ("mouse: x=%d, y=%d\n", mousex, mousey);
      printf ("gamma: f=%d, cam=%d\n", (int) fplayer->gamma, (int) camgamma);*/
      printf ("speed: f=%f\n", fplayer->speed);
	    fflush (stdout);
      if (game == GAME_PLAY) game = GAME_PAUSE;
      else game = GAME_PLAY;
    }
/*    else if (key == 'w')
    {
      fplayer->speedUp ();
      sound->play (SOUND_CLICK1);
      setPlaneVolume ();
    }
    else if (key == 's')
    {
      fplayer->speedDown ();
      sound->play (SOUND_CLICK1);
      setPlaneVolume ();
    }*/
/*    else if (key == 'n')
    {
      game_levelInit (0);
    }*/
/*    else if (key == '-')
    {
      width -= 50; height -= 50;
      if (width < 50) width = 50;
      if (height < 50) height = 50;
#ifdef USE_GLUT
      glutReshapeWindow (width, height);
#else
      sdlreshape = true;
#endif
    }
    else if (key == '+')
    {
      width += 50; height += 50;
      if (width > 1000) width = 1000;
      if (height > 1000) height = 1000;
#ifdef USE_GLUT
      glutReshapeWindow (width, height);
#else
      sdlreshape = true;
#endif
    }*/
    else if (key == 'e')
    {
      fplayer->targetNearestEnemy ((AIObj **) fighter);
//      explosion [0]->setExplosion (fplayer->tl->x, fplayer->tl->y, fplayer->tl->z, 1.0);
//      fplayer->explode ++;
      sound->play (SOUND_CLICK1);
    }
    else if (key == 't')
    {
      fplayer->targetNext ((AIObj **) fighter);
      sound->play (SOUND_CLICK1);
    }
/*    else if (key == 'g')
    {
      if (polygonMode==GL_FILL)
        polygonMode=GL_LINE;
      else
        polygonMode=GL_FILL;
      glPolygonMode (GL_FRONT_AND_BACK, polygonMode);
    }*/
#ifdef USE_GLUT
    glutPostRedisplay();
#else
    sdldisplay = true;
#endif
}

int aktcam = 0;

#ifdef USE_GLUT
  #define MOUSE_BUTTON_LEFT GLUT_LEFT_BUTTON
  #define MOUSE_BUTTON_MIDDLE GLUT_MIDDLE_BUTTON
  #define MOUSE_BUTTON_RIGHT GLUT_RIGHT_BUTTON
  #define MOUSE_UP GLUT_UP
  #define MOUSE_DOWN GLUT_DOWN
  #define KEY_F1 GLUT_KEY_F1
  #define KEY_F2 GLUT_KEY_F2
  #define KEY_F3 GLUT_KEY_F3
  #define KEY_F4 GLUT_KEY_F4
  #define KEY_F5 GLUT_KEY_F5
  #define KEY_F6 GLUT_KEY_F6
  #define KEY_F7 GLUT_KEY_F7
  #define KEY_F8 GLUT_KEY_F8
  #define KEY_F9 GLUT_KEY_F9
  #define KEY_UP GLUT_KEY_UP
  #define KEY_DOWN GLUT_KEY_DOWN
  #define KEY_LEFT GLUT_KEY_LEFT
  #define KEY_RIGHT GLUT_KEY_RIGHT
  #define KEY_PGUP GLUT_KEY_PAGE_UP
  #define KEY_PGDOWN GLUT_KEY_PAGE_DOWN
#else
  #define MOUSE_BUTTON_LEFT SDL_BUTTON_LEFT
  #define MOUSE_BUTTON_MIDDLE SDL_BUTTON_MIDDLE
  #define MOUSE_BUTTON_RIGHT SDL_BUTTON_RIGHT
  #define MOUSE_UP SDL_RELEASED
  #define MOUSE_DOWN SDL_PRESSED
  #define KEY_F1 SDLK_F1
  #define KEY_F2 SDLK_F2
  #define KEY_F3 SDLK_F3
  #define KEY_F4 SDLK_F4
  #define KEY_F5 SDLK_F5
  #define KEY_F6 SDLK_F6
  #define KEY_F7 SDLK_F7
  #define KEY_F8 SDLK_F8
  #define KEY_F9 SDLK_F9
  #define KEY_UP SDLK_UP
  #define KEY_DOWN SDLK_DOWN
  #define KEY_LEFT SDLK_LEFT
  #define KEY_RIGHT SDLK_RIGHT
  #define KEY_PGUP SDLK_PAGEUP
  #define KEY_PGDOWN SDLK_PAGEDOWN
#endif

void game_keyspecialup (int key, int x, int y)
{
  switch (key) {
  case ' ':
    fplayer->autofire = false;
    break;
  case KEY_UP:
//    fplayer->speedUp ();
//    sound->play (SOUND_CLICK1);
    fplayer->aileroneffect = 0.0;
    break;
  case KEY_DOWN:
//    fplayer->speedDown ();
//    sound->play (SOUND_CLICK1);
    fplayer->aileroneffect = 0.0;
    break;
  case KEY_LEFT:
    fplayer->rolleffect = 0;
//    fplayer->rectheta = fplayer->theta;
    break;
  case KEY_RIGHT:
    fplayer->rolleffect = 0;
//    fplayer->rectheta = fplayer->theta;
    break;
#ifdef HAVE_SDL
  case KEY_PGUP:
    fplayer->ruddereffect = 0;
    break;
  case KEY_PGDOWN:
    fplayer->ruddereffect = 0;
    break;
#endif
  }
}

void game_keyspecial (int key, int x, int y)
{
  if (camera == 50 && game == GAME_PAUSE)
  {
    camera = 0;
    game = GAME_PLAY;
  }
  switch (key) {
  case KEY_UP:
//    fplayer->speedUp ();
//    sound->play (SOUND_CLICK1);
    fplayer->aileroneffect = -0.5;
    break;
  case KEY_DOWN:
//    fplayer->speedDown ();
//    sound->play (SOUND_CLICK1);
    fplayer->aileroneffect = 1.0;
    break;
  case KEY_LEFT:
    fplayer->rolleffect = 10;
    break;
  case KEY_RIGHT:
    fplayer->rolleffect = -10;
    break;
  case KEY_PGUP:
    fplayer->ruddereffect = 1.0;
    break;
  case KEY_PGDOWN:
    fplayer->ruddereffect = -1.0;
    break;
  case KEY_F1:
    camera = 0;
    game_reshape ();
    break;
  case KEY_F2:
    camera = 1;
    game_reshape ();
    break;
  case KEY_F3:
    camera = 2;
    game_reshape ();
    break;
  case KEY_F4:
    camera = 6;
//    aktcam ++;
//    if (aktcam > 7) aktcam = 0;
    game_reshape ();
    break;
  case KEY_F5:
    camera = 7;
    game_reshape ();
    break;
  case KEY_F6:
    camera = 4;
    game_reshape ();
    break;
  case KEY_F7:
    camera = 5;
    game_reshape ();
    break;
  case KEY_F8:
    camera = 50;
    game_reshape ();
    break;
  case KEY_F9:
    aktcam ++;
    if (aktcam > 7) aktcam = 0;
    camera = 3;
    break;
  default:
    return;
  }
#ifdef USE_GLUT
  glutPostRedisplay();
#else
  sdldisplay = true;
#endif
}

void game_mouse (int button, int state, int x, int y)
{
  if (state == MOUSE_DOWN)
  {
    if (button == MOUSE_BUTTON_LEFT)
    {
      fplayer->fireCannon (laser);
      sound->play (SOUND_CANNON1);
    }
    else if (button == MOUSE_BUTTON_RIGHT)
    {
      if (fplayer->missiles [fplayer->missiletype] > 0)
      {
        fplayer->fireMissile (fplayer->missiletype + MISSILE1, missile);
        sound->play (SOUND_MISSILE1);
      }
    }
  }
}

float dtheta = 0, dgamma = 0;

void game_mousemotion (int x, int y)
{
  if (controls != 1) return;
  float f = (float) width / 240.0;
  float mx = width / 2, my = height / 2;
  float dx = x - mx, dy = my - y;
/*  int t = (int) fplayer->theta;
  if (t < 0) t += 360;
  float rx = dx * cosi [t] - dy * sine [t];
  float ry = dx * sine [t] + dy * cosi [t];
  rx += mx;
  ry = my - ry;
  fplayer->rectheta = (float) (width / 2 - rx) / f;
  fplayer->recgamma = 135.0 + (float) (height - ry) / height * 90.0;*/
  fplayer->rolleffect = (float) -dx / width * 20.0;
  fplayer->aileroneffect = dy / height * 2.5;
  if (fplayer->aileroneffect > 1.0)
    fplayer->aileroneffect = 1.0;
  else if (fplayer->aileroneffect < -0.5)
    fplayer->aileroneffect = -0.5;

#ifdef USE_GLUT
  glutPostRedisplay();
#else
  sdldisplay = true;
#endif
}

void game_joystickaxis (int x, int y, int throttle, int rudder)
{
  if (fplayer->ai) return;
/*  int t = (int) fplayer->theta;
  if (t < 0) t += 360;
  float rx = x * cosi [t] - y * sine [t];
  float ry = x * sine [t] + y * cosi [t];*/
  fplayer->rectheta -= (float) x / 5000;
/*  fplayer->recgamma += (float) ry / 5000;
  if (fplayer->recgamma > 225) fplayer->recgamma = 225;
  if (fplayer->recgamma < 135) fplayer->recgamma = 135;*/
  fplayer->aileroneffect = (float) y / 30000;
  if (fplayer->aileroneffect > 1.0) fplayer->aileroneffect = 1.0;
  else if (fplayer->aileroneffect < -1.0) fplayer->aileroneffect = -1.0;
  if (fplayer->aileroneffect < 0) fplayer->aileroneffect /= 2;
  fplayer->ruddereffect = (float) rudder / 30000;
  if (fplayer->ruddereffect > 1.0) fplayer->ruddereffect = 1.0;
  else if (fplayer->ruddereffect < -1.0) fplayer->ruddereffect = -1.0;
//  fplayer->aileroneffect = 0;
  fplayer->recspeed = fplayer->maxspeed * 0.75 - fplayer->maxspeed / 4 * throttle / 32638;
}

void game_joystickbutton (int button)
{
  if (button == 0)
  {
    fplayer->fireCannon (laser);
    sound->play (SOUND_CANNON1);
  }
  else if (button == 1)
  {
    fplayer->targetNearestEnemy ((AIObj **) fighter);
    sound->play (SOUND_CLICK1);
  }
  else if (button == 2)
  {
    if (fplayer->missiles [fplayer->missiletype] > 0)
    {
      fplayer->fireMissile (fplayer->missiletype + MISSILE1, missile);
      sound->play (SOUND_MISSILE1);
    }
  }
  else if (button == 3)
  {
    fplayer->missiletype = fplayer->nextMissile (fplayer->missiletype);
    sound->play (SOUND_CLICK1);
  }
}

void game_joystickhat (int hat)
{
#ifndef USE_GLUT
  if (hat == SDL_HAT_LEFT)
  {
    fplayer->targetPrevious ((AIObj **) fighter);
    sound->play (SOUND_CLICK1);
  }
  else if (hat == SDL_HAT_RIGHT)
  {
    fplayer->targetNext ((AIObj **) fighter);
    sound->play (SOUND_CLICK1);
  }
#endif
}

static void myDisplayFunc2 ()
{
//  RenderScene ();
//  glutSwapBuffers();
}

float fps;
int frames = 0, time2 = 0, time1 = 0;

void frame ()
{
  frames ++;
#ifndef USE_GLUT
  time2 = SDL_GetTicks ();
#else
  time2 = glutGet (GLUT_ELAPSED_TIME);
#endif
  if (time2 - time1 > 1000)
  {
    fps = (float) frames * 1000.0 / (time2 - time1);
    time1 = time2;
    frames = 0;
//    printf ("\nFrames=%f ", fps); fflush (stdout);
  }
}

void game_view ()
{
  frame ();
#ifdef USE_GLUT
  glutSwapBuffers();
#else
  SDL_GL_SwapBuffers ();
#endif
}

int missionending = 0;
int missionstate = 0;

bool missionactive = false;
int menuitem = 0, menutimer = 0, menuitemselected = -1, missionmenutimer;
int missionmenuitemselected = 0, missionmenufighterselected = -1;

void menu_key (unsigned char key, int x, int y)
{
  if (pilotedit.active)
  {
    pilotedit.event (key);
    if (key == 13)
      pilots->add (pilotedit.text);
    key = 0;
  }
  if (key == 27)
  {
    if (missionactive)
    {
      switch_game ();
    }
  }
}

void credits_key (unsigned char key, int x, int y)
{
  if (key)
  {
    sound->haltMusic ();
    switch_menu ();
  }
}

void mission_key (unsigned char key, int x, int y)
{
  if (key == 27)
  {
    switch_menu ();
  }
  else if (key == 13)
  {
    game_levelInit ();
    switch_game ();
    missionactive = true;
  }
}

void drawMouseCursor ()
{
  glPushMatrix ();
  glMatrixMode (GL_PROJECTION);
  glPushMatrix ();
  glLoadIdentity ();
  gluOrtho2D (0, width, 0, height);
  glScalef (1, -1, 1);
  glTranslatef (0, -height, 0);
  glMatrixMode (GL_MODELVIEW);
  glLoadIdentity ();
  gl->enableAlphaBlending ();
  glEnable (GL_ALPHA_TEST);
  glAlphaFunc (GL_GEQUAL, 0.1);
  glTexEnvi (GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
  gl->enableTextures (texcross2->textureID);
  int crossradius = width / 35;

  glBegin (GL_QUADS);
  glColor4ub (255, 255, 255, 255);
  glTexCoord2d (0, 0);
  glVertex2d (mousex - crossradius, mousey - crossradius);
  glTexCoord2d (0, 1);
  glVertex2d (mousex - crossradius, mousey + crossradius);
  glTexCoord2d (1, 1);
  glVertex2d (mousex + crossradius, mousey + crossradius);
  glTexCoord2d (1, 0);
  glVertex2d (mousex + crossradius, mousey - crossradius);
  glEnd ();
  glDisable (GL_ALPHA_TEST);
  glDisable (GL_TEXTURE_2D);
  gl->disableAlphaBlending ();
  glTexEnvi (GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
  glMatrixMode (GL_PROJECTION);
  glPopMatrix ();
  glMatrixMode (GL_MODELVIEW);
  glPopMatrix ();

  glPopMatrix ();
}

CModel *getModel (int id)
{
  if (id == FIGHTER_FALCON) return &model_fig;
  else if (id == FIGHTER_SWALLOW) return &model_figa;
  else if (id == FIGHTER_HAWK) return &model_figb;
  else if (id == FIGHTER_HAWK2) return &model_figc;
  else if (id == FIGHTER_BUZZARD) return &model_figd;
  else if (id == FIGHTER_TRANSPORT) return &model_figt;
  return &model_fig;
}

char *getModelText (int id)
{
  if (id == FIGHTER_FALCON)
    return "THE FALCON IS A NIMBLE AND\nFAST FIGHTER PROVIDING\nBOTH AIR-AIR AND\nAIR-GROUND-MISSILES.";
  else if (id == FIGHTER_HAWK)
    return "THE HAWK IS A TYPICAL\nALLROUNDER AND DESIGNED\nFOR GROUND ATTACKS.";
  else if (id == FIGHTER_HAWK2)
    return "THE HAWK II IS A ...";
  return "NO INFO";
}

void mission_mouse (int button, int state, int x, int y)
{
  float rx = (float) x / width;
  float ry = (float) y / height;
  int lastitemselected = missionmenuitemselected;
  int lastitem = menuitem;
  missionmenuitemselected = -1;

  if (ry >= 0.88 && ry <= 0.93)
  {
    if (rx >= 0.55 && rx <= 0.85)
    {
      missionmenuitemselected = 0;
      if (state == MOUSE_DOWN)
      {
        game_levelInit ();
        switch_game ();
        missionactive = true;
      }
    }
    if (rx >= 0.12 && rx <= 0.35)
    {
      missionmenuitemselected = 1;
      if (state == MOUSE_DOWN)
      {
        switch_menu ();
      }
    }
  }

  missionmenufighterselected = -1;
  if (ry >= 0.55 && ry <= 0.75)
  {
    if (rx >= 0.1 && rx < 0.25)
    {
      missionmenufighterselected = 0;
      if (state == MOUSE_DOWN)
        missionnew->wantfighter = 0;
    }
    if (rx >= 0.25 && rx < 0.4 && missionnew->selfighters >= 2)
    {
      missionmenufighterselected = 1;
      if (state == MOUSE_DOWN)
        missionnew->wantfighter = 1;
    }
    if (rx >= 0.4 && rx < 0.55 && missionnew->selfighters >= 3)
    {
      missionmenufighterselected = 2;
      if (state == MOUSE_DOWN)
        missionnew->wantfighter = 2;
    }
  }

  if (lastitemselected != missionmenuitemselected)
  {
//    missionmenutimer = 0; // do not alter, it will affect the background
  }
}

void mission_display ()
{
  char buf [256];
  int i;
  CColor colorblue (0, 100, 255, 255);
  CColor colorgreen (0, 255, 0, 255);
  CColor colororange (255, 120, 0, 255);
  CColor colorred (255, 0, 0, 255);
  float xstats = 4, ystats = 6;
  float xstatstab = 12;
  float piloty = 6;
  Pilot *p = pilots->pilot [pilots->aktpilot];
  CColor *colorstd = &colorred;
  if (p->mission_state [missionnew->id] == 1)
    colorstd = &colorblue;

  glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity ();
  glPushMatrix ();
  float zf = -3, yf;
  for (i = 0; i < 14; i ++)
  {
    yf = -3 + 0.5 * i - (float) (missionmenutimer & 63) / 64.0;
    glBegin (GL_QUADS);
    glColor3ubv (colorstd->c);
    glVertex3f (-3, yf, zf);
    glColor3ub (0, 0, 0);
    glVertex3f (-3, yf + 0.2, zf);
    glVertex3f (-2, yf + 0.2, zf);
    glVertex3f (-2, yf, zf);
    glColor3ubv (colorstd->c);
    glVertex3f (-3, yf, zf);
    glColor3ub (0, 0, 0);
    glVertex3f (-3, yf - 0.2, zf);
    glVertex3f (-2, yf - 0.2, zf);
    glVertex3f (-2, yf, zf);
    glColor3ubv (colorstd->c);
    glVertex3f (3, yf, zf);
    glColor3ub (0, 0, 0);
    glVertex3f (3, yf + 0.2, zf);
    glVertex3f (2, yf + 0.2, zf);
    glVertex3f (2, yf, zf);
    glColor3ubv (colorstd->c);
    glVertex3f (3, yf, zf);
    glColor3ub (0, 0, 0);
    glVertex3f (3, yf - 0.2, zf);
    glVertex3f (2, yf - 0.2, zf);
    glVertex3f (2, yf, zf);
    glEnd ();
  }

/*  xf = missionnew->wantfighter - 2.6;
  yf = -1.5;
  zf = -3.5;
  glBegin (GL_QUADS);
  glColor3ub (0, 100, 0);
  glVertex3f (xf, yf, zf);
  glVertex3f (xf + 0.9, yf, zf);
  glColor3ub (0, 0, 0);
  glVertex3f (xf + 0.9, yf + 0.5, zf);
  glVertex3f (xf, yf + 0.5, zf);
  glEnd ();*/

  CVector3 vec;
  CVector3 tl (-4.5, 5.5, -8.0);
  CRotation rot;
  rot.a = 270;
  rot.b = (270 - missionmenutimer * 4) % 360;
  rot.c = 90;
  glEnable (GL_LIGHTING);
  glEnable (GL_DEPTH_TEST);
  model_gl117.draw2 (&vec, &tl, &rot, 1.0, 0);
  tl.x = 4.5;
  model_gl117.draw2 (&vec, &tl, &rot, 1.0, 0);
  
  tl.x = -20; tl.y = -2.4;
  rot.a = 245;
  rot.b = 0;
  for (i = 0; i < missionnew->selfighters; i ++)
  {
    tl.x = -5 + (float) i * 2.3;
    if (missionnew->wantfighter == i/*missionmenufighterselected == i*/)
      rot.c = (5 + missionmenutimer * 4) % 360;
    else
      rot.c = 5;
    getModel (missionnew->selfighter [i])->draw2 (&vec, &tl, &rot, 0.9, 0);
  }
  glDisable (GL_DEPTH_TEST);
  glDisable (GL_LIGHTING);

/*  for (i = 0; i < 8; i ++)
  {
    xf = -2.5 + 0.5 * (i & 3);
    yf = -0.5 - 0.92 * (i / 4);
    zf = -3.5;
    gl->enableTextures (texchar [i]->textureID);
    glBegin (GL_QUADS);
    glColor3ub (255, 255, 255);
    glTexCoord2d (0, 0);
    glVertex3f (xf, yf, zf);
    glTexCoord2d (1, 0);
    glVertex3f (xf + 0.45, yf, zf);
    glTexCoord2d (1, 1);
    glVertex3f (xf + 0.45, yf + 0.85, zf);
    glTexCoord2d (0, 1);
    glVertex3f (xf, yf + 0.85, zf);
    glEnd ();
    glDisable (GL_TEXTURE_2D);
  }*/

  font1->drawTextCentered (0, 9.8, -1.5, missionnew->name);
  font1->drawText (-22, 14, -3, "BRIEFING:");
  font2->drawText (-22, 12, -3, missionnew->briefing);

  font1->drawText (xstats, ystats, -3, "STATUS:");
  if (p->mission_state [missionnew->id] == 1)
    font1->drawText (xstatstab, ystats, -3, "SUCCESS", colorstd);
  else if (p->mission_state [missionnew->id] == 2)
    font1->drawText (xstatstab, ystats, -3, "FAILED", colorstd);
  else
    font1->drawText (xstatstab, ystats, -3, "EMPTY", colorstd);
  font1->drawText (xstats, ystats - 2, -3, "SCORE:");
  int score = p->mission_score [missionnew->id];
  if (score < -10000 || score > 100000) score = 0;
  sprintf (buf, "%d", score);
  font1->drawText (xstatstab, ystats - 2, -3, buf, colorstd);
  
  font1->drawText (-22, piloty, -3, "PILOTS:");
  strcpy (buf, "AIRMAN ");
  strcat (buf, pilots->pilot [pilots->aktpilot]->name);
  font2->drawText (-22, piloty - 2, -3, buf);
  for (i = 1; i < missionnew->alliedfighters; i ++)
    font2->drawText (-22, piloty - 2 - i, -3, "COMPUTER");

  font1->drawText (-22, -5, -3, "CHOOSE FIGHTER:");
  if (missionmenuitemselected == 0)
    font1->drawTextRotated (3, -14, -2, "START MISSION", &colorred, -missionmenutimer * 5);
  else
    font1->drawText (3, -14, -2, "START MISSION");
  if (missionmenuitemselected == 1)
    font1->drawTextRotated (-12, -14, -2, "CANCEL", &colorred, -missionmenutimer * 5);
  else
    font1->drawText (-12, -14, -2, "CANCEL");
  if (missionmenufighterselected > -1)
  {
    float textx = xstats;
    if (missionnew->alliedfighters < 3)
      textx -= 8;
    font2->drawText (textx, -7, -3, getModelText (missionnew->selfighter [missionmenufighterselected]));
  }
  glPopMatrix ();

  drawMouseCursor ();
}

void menu_mouse (int button, int state, int x, int y)
{
  int i;
  float rx = (float) x / width;
  float ry = (float) y / height;
  int lastitemselected = menuitemselected;
  int lastitem = menuitem;
  menuitemselected = -1;

  if (rx >= 0.08 && rx <= 0.4)
  {
    if (ry >= 0.15 && ry <= 0.2)
    {
      menuitemselected = 0;
      if (state == MOUSE_DOWN)
        menuitem = 0;
    }
    else if (ry >= 0.22 && ry <= 0.27)
    {
      menuitemselected = 1;
      if (state == MOUSE_DOWN)
        menuitem = 1;
    }
#ifdef HAVE_SDL_NET
    else if (ry >= 0.28 && ry <= 0.33)
    {
      menuitemselected = 2;
      if (state == MOUSE_DOWN)
        menuitem = 2;
    }
#endif
    else if (ry >= 0.34 && ry <= 0.39)
    {
      menuitemselected = 3;
      if (state == MOUSE_DOWN)
        menuitem = 3;
    }
    else if (ry >= 0.40 && ry <= 0.45)
    {
      menuitemselected = 4;
      if (state == MOUSE_DOWN)
        menuitem = 4;
    }
    else if (ry >= 0.46 && ry <= 0.51)
    {
      menuitemselected = 5;
      if (state == MOUSE_DOWN)
      {
        menuitem = 5;
        switch_credits ();
      }
    }
    else if (ry >= 0.52 && ry <= 0.57)
    {
      menuitemselected = 6;
      if (state == MOUSE_DOWN)
      {
        menuitem = 6;
        game_quit ();
      }
    }
    else if (ry >= 0.64 && ry <= 0.69)
    {
      menuitemselected = 9;
      if (state == MOUSE_DOWN)
      {
        // no new menuitem!
        switch_game ();
      }
    }
  }

  if (menuitem == 0)
  {
    if (rx >= 0.48 && rx <= 0.85)
    {
      for (i = 0; i < pilots->aktpilots; i ++)
      {
        if (ry >= 0.22 + 0.06 * (float) i && ry <= 0.27 + 0.06 * (float) i)
        {
          menuitemselected = 20 + i;
          if (state == MOUSE_DOWN)
          {
            pilots->aktpilot = i;
          }
        }
      }
      if (ry >= 0.58 && ry <= 0.63)
      {
        menuitemselected = 10;
        if (state == MOUSE_DOWN)
          if (button == MOUSE_BUTTON_RIGHT)
          {
            pilots->remove ();
          }
      }
      if (ry >= 0.64 && ry <= 0.69)
      {
        menuitemselected = 11;
        if (state == MOUSE_DOWN)
        {
          pilotedit.init ();
        }
      }
    }
  }

  if (menuitem == 1)
  {
    if (rx >= 0.48 && rx <= 0.85)
    {
      if (ry >= 0.15 && ry <= 0.2)
      {
        menuitemselected = 10;
        if (state == MOUSE_DOWN)
        {
          switch_mission (MISSION_TUTORIAL);
        }
      }
      if (ry >= 0.22 && ry <= 0.27)
      {
        menuitemselected = 11;
        if (state == MOUSE_DOWN)
        {
          switch_mission (MISSION_DOGFIGHT);
        }
      }
      if (ry >= 0.28 && ry <= 0.33)
      {
        menuitemselected = 12;
        if (state == MOUSE_DOWN)
        {
          switch_mission (MISSION_SADEFENSE);
        }
      }
      if (ry >= 0.34 && ry <= 0.39)
      {
        menuitemselected = 13;
        if (state == MOUSE_DOWN)
        {
          switch_mission (MISSION_CRUISER);
        }
      }
      if (ry >= 0.40 && ry <= 0.45)
      {
        menuitemselected = 14;
        if (state == MOUSE_DOWN)
        {
          switch_mission (MISSION_MOON);
        }
      }
      if (ry >= 0.46 && ry <= 0.51)
      {
        menuitemselected = 15;
        if (state == MOUSE_DOWN)
        {
          switch_mission (MISSION_CANYON);
        }
      }
      if (ry >= 0.51 && ry <= 0.56)
      {
        menuitemselected = 16;
        if (state == MOUSE_DOWN)
        {
          switch_mission (MISSION_DESERT);
        }
      }
    }
  }

#ifdef HAVE_SDL_NET
  if (menuitem == 2)
  {
    if (rx >= 0.48 && rx <= 0.85)
    {
      if (ry >= 0.15 && ry <= 0.2)
      {
        menuitemselected = 10;
        if (state == MOUSE_DOWN)
        {
          switch_create ();
        }
      }
      else if (ry >= 0.22 && ry <= 0.27)
      {
        menuitemselected = 11;
        if (state == MOUSE_DOWN)
        {
          switch_join ();
        }
      }
    }
  }
#endif

  if (menuitem == 3)
  {
    if (rx >= 0.48 && rx <= 0.85)
    {
      if (ry >= 0.15 && ry <= 0.2)
      {
        menuitemselected = 10;
        if (state == MOUSE_DOWN)
        {
          if (button == MOUSE_BUTTON_LEFT)
          {
            quality ++;
            if (quality > 5) quality = 0;
          }
          else
          {
            quality --;
            if (quality < 0) quality = 5;
          }
        }
      }
      else if (ry >= 0.22 && ry <= 0.27)
      {
        menuitemselected = 11;
        if (state == MOUSE_DOWN)
        {
          if (button == MOUSE_BUTTON_LEFT)
          {
            view += 10;
            if (view > 110) view = 30;
            menu_reshape ();
          }
          else
          {
            view -= 10;
            if (view < 30) view = 110;
            menu_reshape ();
          }
        }
      }
      else if (ry >= 0.28 && ry <= 0.33)
      {
        menuitemselected = 12;
        if (state == MOUSE_DOWN)
        {
          if (button == MOUSE_BUTTON_LEFT)
          {
            controls ++;
            if (controls > 2) controls = 0;
            if (controls == 2 && !joystick) controls = 0;
#ifdef USE_GLUT
            if (controls == 0) controls = 1;
#endif
          }
        }
      }
#ifdef HAVE_SDL_MIXER
      else if (ry >= 0.34 && ry <= 0.39)
      {
        menuitemselected = 13;
        if (state == MOUSE_DOWN)
        {
          if (button == MOUSE_BUTTON_LEFT)
          {
            sound->volumesound += 10;
            if (sound->volumesound > 100)
              sound->volumesound = 0;
            sound->setVolume ();
            setPlaneVolume ();
            sound->play (SOUND_CLICK1);
            menu_reshape ();
          }
          else
          {
            sound->volumesound -= 10;
            if (sound->volumesound < 0)
              sound->volumesound = 100;
            sound->setVolume ();
            setPlaneVolume ();
            sound->play (SOUND_CLICK1);
            menu_reshape ();
          }
        }
      }
      else if (ry >= 0.40 && ry <= 0.45)
      {
        menuitemselected = 14;
        if (state == MOUSE_DOWN)
        {
          if (button == MOUSE_BUTTON_LEFT)
          {
            sound->volumemusic += 10;
            if (sound->volumemusic > 100)
              sound->volumemusic = 0;
            sound->setVolumeMusic ();
            menu_reshape ();
          }
          else
          {
            sound->volumemusic -= 10;
            if (sound->volumemusic < 0)
              sound->volumemusic = 100;
            sound->setVolumeMusic ();
            menu_reshape ();
          }
        }
      }
#endif
    }
  }

  if (lastitemselected != menuitemselected)
  {
    menutimer = 0;
  }

  if (lastitem != menuitem)
  {
    sound->play (SOUND_CLICK1);
  }

#ifdef USE_GLUT
  glutPostRedisplay();
#else
  sdldisplay = true;
#endif
}

void menu_display ()
{
  char buf [100];
  int i;

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity ();
  glPushMatrix ();

/*  if (quality >= 2)
    gl->enableAntiAliasing ();*/

  CColor color2 ((int) (255.0 * cosi [menutimer * 5 % 360]), 255, (int) (255.0 * cosi [menutimer * 10 % 360]), 255);
  CColor coloryellow (255, 255, 0, 200);

  int textx = -14, textx2 = 0;

  if (menuitemselected == 0)
    font1->drawTextRotated (textx, 10, -2, "PILOTS", &color2, -menutimer * 5);
  else
    font1->drawText (textx, 10, -2, "PILOTS");
  if (menuitemselected == 1)
    font1->drawTextRotated (textx, 8, -2, "MISSIONS", &color2, -menutimer * 5);
  else
    font1->drawText (textx, 8, -2, "MISSIONS");
#ifdef HAVE_SDL_NET
  if (menuitemselected == 2)
    font1->drawTextRotated (textx, 6, -2, "MULTIPLAYER", &color2, -menutimer * 5);
  else
    font1->drawText (textx, 6, -2, "MULTIPLAYER");
#endif
  if (menuitemselected == 3)
    font1->drawTextRotated (textx, 4, -2, "OPTIONS", &color2, -menutimer * 5);
  else
    font1->drawText (textx, 4, -2, "OPTIONS");
  if (menuitemselected == 4)
    font1->drawTextRotated (textx, 2, -2, "HELP", &color2, -menutimer * 5);
  else
    font1->drawText (textx, 2, -2, "HELP");
  if (menuitemselected == 5)
    font1->drawTextRotated (textx, 0, -2, "CREDITS", &color2, -menutimer * 5);
  else
    font1->drawText (textx, 0, -2, "CREDITS");
  if (menuitemselected == 6)
    font1->drawTextRotated (textx, -2, -2, "QUIT", &color2, -menutimer * 5);
  else
    font1->drawText (textx, -2, -2, "QUIT");
  if (missionactive)
  {
    if (menuitemselected == 9)
      font1->drawTextRotated (textx, -6, -2, "RETURN", &color2, -menutimer * 5);
    else
      font1->drawText (textx, -6, -2, "RETURN");
  }

  if (menuitem == 0)
  {
    font1->drawText (textx2 - 2, 10, -2, "ACTIVE:", &coloryellow);
    if (pilots->aktpilot < pilots->aktpilots)
    {
      font1->drawText (textx2 + 4, 10, -2, pilots->pilot [pilots->aktpilot]->name, &coloryellow);
    }
    for (i = 0; i < pilots->aktpilots; i ++)
    {
      if (menuitemselected == 20 + i)
      {
        font1->drawTextRotated (textx2, 12.5 - (float) i * 3, -3, "AIRMAN", &color2, -menutimer * 5);
        font1->drawTextRotated (textx2 + 2, 11.5 - (float) i * 3, -3, pilots->pilot [i]->name, &color2, -menutimer * 5);
      }
      else
      {
        font1->drawText (textx2, 12.5 - (float) i * 3, -3, "AIRMAN");
        font1->drawText (textx2 + 2, 11.5 - (float) i * 3, -3, pilots->pilot [i]->name);
      }
    }
    if (menuitemselected == 10)
      font1->drawTextRotated (textx2 - 2, -5, -2.5, "DELETE (RIGHT MB)", &color2, -menutimer * 5);
    else
      font1->drawText (textx2 - 2, -5, -2.5, "DELETE (RIGHT MB)");
    if (menuitemselected == 11)
      font1->drawTextRotated (textx2 - 2, -7, -2.5, "CREATE", &color2, -menutimer * 5);
    else
      font1->drawText (textx2 - 2, -7, -2.5, "CREATE");
    pilotedit.draw (textx2, -9, -2.5, menutimer / 8);
  }
  else
    pilotedit.active = false;

  if (menuitem == 1)
  {
    if (menuitemselected == 10)
      font1->drawTextRotated (textx2, 10, -2, "TUTORIAL", &color2, -menutimer * 5);
    else
      font1->drawText (textx2, 10, -2, "TUTORIAL");
    if (menuitemselected == 11)
      font1->drawTextRotated (textx2, 8, -2, "DOGFIGHT", &color2, -menutimer * 5);
    else
      font1->drawText (textx2, 8, -2, "DOGFIGHT");
    if (menuitemselected == 12)
      font1->drawTextRotated (textx2, 6, -2, "SA DEFENSE", &color2, -menutimer * 5);
    else
      font1->drawText (textx2, 6, -2, "SA DEFENSE");
    if (menuitemselected == 13)
      font1->drawTextRotated (textx2, 4, -2, "CRUISER", &color2, -menutimer * 5);
    else
      font1->drawText (textx2, 4, -2, "CRUISER");
    if (menuitemselected == 14)
      font1->drawTextRotated (textx2, 2, -2, "MOON", &color2, -menutimer * 5);
    else
      font1->drawText (textx2, 2, -2, "MOON");
    if (menuitemselected == 15)
      font1->drawTextRotated (textx2, 0, -2, "CANYON", &color2, -menutimer * 5);
    else
      font1->drawText (textx2, 0, -2, "CANYON");
    if (menuitemselected == 16)
      font1->drawTextRotated (textx2, -2, -2, "DESERT", &color2, -menutimer * 5);
    else
      font1->drawText (textx2, -2, -2, "DESERT");
    font1->drawText (-20, -15, -3, "MORE MISSIONS WITH THE NEXT RELEASE");
  }
  else if (menuitem == 3)
  {
    sprintf (buf, "QUALITY: %d", quality);
    if (menuitemselected == 10)
      font1->drawTextRotated (textx2, 10, -2, buf, &color2, -menutimer * 5);
    else
      font1->drawText (textx2, 10, -2, buf);
    sprintf (buf, "VIEW: %d", (int) view);
    if (menuitemselected == 11)
      font1->drawTextRotated (textx2, 8, -2, buf, &color2, -menutimer * 5);
    else
      font1->drawText (textx2, 8, -2, buf);
    strcpy (buf, "CONTROLS: ");
    if (controls == 0) strcat (buf, "KEYBOARD");
    else if (controls == 1) strcat (buf, "MOUSE");
    else if (controls == 2) strcat (buf, "JOYSTICK");
    if (menuitemselected == 12)
      font1->drawTextRotated (textx2, 6, -2, buf, &color2, -menutimer * 5);
    else
      font1->drawText (textx2, 6, -2, buf);
#ifdef HAVE_SDL_MIXER
    sprintf (buf, "SOUND: %d%%", (int) sound->volumesound);
    if (menuitemselected == 13)
      font1->drawTextRotated (textx2, 4, -2, buf, &color2, -menutimer * 5);
    else
      font1->drawText (textx2, 4, -2, buf);
    sprintf (buf, "MUSIC: %d%%", (int) sound->volumemusic);
    if (menuitemselected == 14)
      font1->drawTextRotated (textx2, 2, -2, buf, &color2, -menutimer * 5);
    else
      font1->drawText (textx2, 2, -2, buf);
#endif
  }
  else if (menuitem == 2)
  {
#ifdef HAVE_SDL_NET
    if (menuitemselected == 10)
      font1->drawTextRotated (textx2, 10, -2, "CREATE GAME", &color2, -menutimer * 5);
    else
      font1->drawText (textx2, 10, -2, "CREATE GAME");
    if (menuitemselected == 11)
      font1->drawTextRotated (textx2, 8, -2, "JOIN GAME", &color2, -menutimer * 5);
    else
      font1->drawText (textx2, 8, -2, "JOIN GAME");
#endif
  }
  else if (menuitem == 4)
  {
    int xs = -4, ys = 15;
    font1->drawText (xs, ys --, -3, "KEYS:");
    font1->drawText (xs, ys --, -3, "T\tNEXT TARGET");
    font1->drawText (xs, ys --, -3, "E\tTARGET NEAREST ENEMY");
    font1->drawText (xs, ys --, -3, "M\tSWITCH WEAPON");
    font1->drawText (xs, ys --, -3, "1..9\tCHANGE SPEED");
    font1->drawText (xs, ys --, -3, "F1..7\tCAMERAS");
    font1->drawText (xs, ys --, -3, "F8\tSHOW MAP");
    font1->drawText (xs, ys --, -3, "ESC\tMAIN MENU");
    font1->drawText (xs, ys --, -3, "SPACE\tFIRE CANNON");
    font1->drawText (xs, ys --, -3, "ENTER\tFIRE MISSILE");
    font1->drawText (xs, (-- ys) --, -3, "MOUSE:");
    font1->drawText (xs, ys --, -3, "LEFT B.\tFIRE CANNON");
    font1->drawText (xs, ys --, -3, "RIGHT B.\tFIRE MISSILE");
    font1->drawText (xs, (-- ys) --, -3, "JOYSTICK:");
    font1->drawText (xs, ys --, -3, "BUTTON1\tFIRE CANNON");
    font1->drawText (xs, ys --, -3, "BUTTON2\tTARGET NEAREST ENEMY");
    font1->drawText (xs, ys --, -3, "BUTTON3\tFIRE MISSILE");
    font1->drawText (xs, ys --, -3, "BUTTON4\tSWITCH WEAPON");
    font1->drawText (xs, ys --, -3, "COOLIE\tNEXT/PREV TARGET");
  }

  drawMouseCursor ();
}

void pause_display ()
{
//  glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity ();
//  glShadeModel(GL_SMOOTH);
  glPushMatrix ();

  CColor color (255, 255, 255, 255);
  font1->drawText (-3, -1, -1, "PAUSED", &color);

  glPopMatrix ();
//  glutSwapBuffers();
}

void credits_display ()
{
  glTranslatef (0, -3.5 + 0.015 * (float) creditstimer, 0);
  CColor col (255, 255, 255, 255);
  CColor col2 (255, 255, 0, 255);
  font2->drawTextCentered (0, 10, -2, "GAME PROGRAMMING", &col);
  font2->drawTextCentered (0, 8, -2, "GRAPHICS SOUND MUSIC", &col);
  font1->drawTextCentered (0, 6, -2, "THOMAS A. DREXL", &col2);
  font2->drawTextCentered (0, 2, -2, "INTRO MOON", &col);
  font1->drawTextCentered (0, 0, -2, "NORBERT DREXL", &col2);
}

void game_display ()
{
  int i;

  if (debug)
    printf ("\nentering myDisplayFunc()"); fflush (stdout);

  bool sunvisible = false, sunblinding = false;
  float pseudoview = getView ();

  if (fplayer->tl->y > l->getRayHeight (fplayer->tl->x, fplayer->tl->z))
	sunblinding = true;

// calculate light factor
  if (camera == 0 && sunblinding && day && weather == 0)
  {
    float np = fplayer->phi;
    if (np >= 180) np -= 360;
    sunlight = fabs (np) + fabs (fplayer->gamma - 180 - sungamma);
//  printf ("\nphi=%f, gamma=%f", fplayer->phi, fplayer->gamma);
    if (sunlight < 90)
    { sunlight = (90 - sunlight) / 20;
      if (sunlight < 1.0) sunlight = 1.0;
    /*printf ("\nlight=%f", sunlight); fflush (stdout);*/ }
    else sunlight = 1.0;
  }
  else
  {
    if (day) sunlight = 1.0;
    else sunlight = 0.75;
    if (flash)
    {
      sunlight = flash;
    }
  }


  glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
//  glClear(GL_DEPTH_BUFFER_BIT);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity ();

  glShadeModel(GL_SMOOTH);


  glPushMatrix ();
  
  if (camera != 1 && camera != 5)
    glRotatef (-camtheta, 0.0, 0.0, 1.0);
  if (camera == 0)
    glRotatef (-fplayer->gamma + 180, 1.0, 0.0, 0.0);
  else
    glRotatef (camgamma, 1.0, 0.0, 0.0);
  glRotatef (-camphi, 0.0, 1.0, 0.0);
//  if (camera == 0)
//    glRotatef (-20, 1.0, 0.0, 0.0);

  // draw sky
  glDisable (GL_FOG);
  glDisable (GL_DEPTH_TEST);

  float mylight = sunlight;
  if (!day) mylight /= 0.75;
  if (mylight > 1.0 && day)
    mylight = mylight / 20.0 + 0.95;
  else if (mylight > 1.0 && !day)
    mylight = mylight / 5.0 + 0.8;
  gl->foglum = mylight;
  sphere->drawGL (tlminf, tlinf, tlnull, space->alpha, mylight, true, false);

  if (weather == 0 || weather == 2)
  {
  if (!day)
  {
    glPointSize (1.0);
    int stars = maxstar;
    if (weather != 2) stars = maxstar / 2;
    for (i = 0; i < stars; i ++)
    {
      glPushMatrix ();
      glRotatef (/*-camphi +*/ star [i]->phi, 0.0, 1.0, 0.0);
      if (camera == 0)
        glRotatef (/*-fplayer->gamma + 180 +*/ star [i]->gamma, 1.0, 0.0, 0.0);
      else
        glRotatef (/*camgamma +*/ star [i]->gamma, 1.0, 0.0, 0.0);
      glTranslatef (0, 0, -10);
      star [i]->draw ();
      glPopMatrix ();
    }
  }
  }

//  sphere.draw (tlnull, tlnull, , 1.0);
  glEnable (GL_DEPTH_TEST);
  glEnable (GL_FOG);
//  glPopMatrix ();


// draw sun or moon (or earth)
//  glPushMatrix ();
  float r = 10.0;
//  float p = -fplayer->phi, t = -fplayer->gamma;
  float fac = view, zfac = view * 0.2;
//  if (camera != 1 && camera != 5)
//    glRotatef (-camtheta, 0.0, 0.0, 1.0);
  if (weather == 0 || weather == 2)
  {
  if (camera == 0)
    glRotatef (/*-fplayer->gamma + 180 +*/ sungamma, 1.0, 0.0, 0.0);
  else
    glRotatef (camgamma + sungamma, 1.0, 0.0, 0.0);
//  glRotatef (-camphi, 0.0, 1.0, 0.0);
  float zf = -11;
  if (day) zf = -12;
  if (l->type == 1 && !day) zf = -8;
  glTranslatef (0, 0, zf);
/*  if (camera == 0)
    glRotatef (-fplayer->gamma + 180 + sungamma, 1.0, 0.0, 0.0);
  else
    glRotatef (camgamma + sungamma, 1.0, 0.0, 0.0);
  glRotatef (-camphi, 0.0, 1.0, 0.0);*/
  gl->extractFrustum ();
  if (gl->isPointInFrustum (-1, 1, 0) || gl->isPointInFrustum (-1, -1, 0) ||
      gl->isPointInFrustum (1, -1, 0) || gl->isPointInFrustum (1, 1, 0))
  {
    sunvisible = true;
    glDisable (GL_DEPTH_TEST);
    if (day) gl->enableTextures (texsun->textureID);
    else if (l->type != 1) gl->enableTextures (texmoon->textureID);
    else gl->enableTextures (texearth->textureID);
    if (day && l->type != 1)
      glTexEnvi (GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
    gl->enableAlphaBlending ();
    glEnable (GL_ALPHA_TEST);
    float alphamax = 0.1;
    if (day) alphamax = 0.9;
    glAlphaFunc (GL_GEQUAL, alphamax);
  //  glDisable (GL_DITHER);
    glBegin (GL_QUADS);
    fac = view; zfac = view * 3.5;
    if (day && l->type != 1)
    {
      float gm = (40.0 - sungamma) / 80.0;
      if (gm < 0) gm = 0;
      if (gm > 0.5) gm = 0.5;
      glColor4f (1.0, 1.0 - gm, 0.8 - gm, 1.0);
    }
    else
      glColor4f (1.0, 1.0, 1.0, 1.0);
    glTexCoord2d (0, 1);
    glVertex3f (-1, 1, 0);
    glTexCoord2d (1, 1);
    glVertex3f (1, 1, 0);
  //  glColor4f (0.1, 0.9, 0.9, 1.0);
    glTexCoord2d (1, 0);
    glVertex3f (1, -1, 0);
    glTexCoord2d (0, 0);
    glVertex3f (-1, -1, 0);
    glEnd ();
//    if (day && l->type != 1)
//      glTexEnvi (GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
    glDisable (GL_ALPHA_TEST);
    glEnable (GL_DEPTH_TEST);
    glDisable (GL_TEXTURE_2D);
    gl->disableAlphaBlending ();
  }
  }
  glPopMatrix ();
  

  
    
  
    
  glPushMatrix ();

  /* Modeltransformation ausfuehren... */

  if (camera != 1 && camera != 5)
    glRotatef (-camtheta, 0.0, 0.0, 1.0);

  if (camera == 0)
    glRotatef (-fplayer->gamma + 180, 1.0, 0.0, 0.0);
  else
    glRotatef (camgamma, 1.0, 0.0, 0.0);

  glDisable (GL_FOG);
/*  glPushMatrix ();
  glDisable (GL_DEPTH_TEST);
  glBegin (GL_QUAD_STRIP);
  float fac = view, zfac = view * 0.2;
  glColor4f (0.0, 1.0, 1.0, 1.0);
  glVertex3f (-fac, 2.0*fac, -zfac);
  glVertex3f (fac, 2.0*fac, -zfac);
  glColor4f (0.1, 0.9, 0.9, 1.0);
  glVertex3f (-fac, fac*0.4, -zfac);
  glVertex3f (fac, fac*0.4, -zfac);
  glColor4f (0.5, 0.5, 0.5, 1.0);
  glVertex3f (-fac, -fac*0.125, -zfac);
  glVertex3f (fac, -fac*0.125, -zfac);
  glVertex3f (-fac, -2.0*fac, -zfac);
  glVertex3f (fac, -2.0*fac, -zfac);
  glEnd ();
  glEnable (GL_DEPTH_TEST);
  
  glPopMatrix ();*/
//  glEnable (GL_FOG);


  glRotatef (-camphi, 0.0, 1.0, 0.0);  /* Rotation um die Y-Achse */


    

//  glPushMatrix ();
//  if (camera == 0)
//    glRotatef (-20, 1.0, 0.0, 0.0);
  glScalef (1, 1, 1);








  /*glPushMatrix ();
  if (camera == 0)
    glRotatef (-20, 1.0, 0.0, 0.0);
  glDisable (GL_DEPTH_TEST);

  drawTexture (10.0, -fplayer->phi - 20, 20 + 30, -fplayer->phi + 20, - 20 + 30);

  glEnable (GL_DEPTH_TEST);
  gl->disableAlphaBlending ();
  glPopMatrix ();*/
  
  
//  fplayer->tl->y = -(0.6*zoom - (float)l->h[(int)camx+MAXX/2][MAXX/2-(int)camz]*zoomz * zoom);
//  if (camera != 50)
//    camy = fplayer->tl->y + fplayer->zoom / 3.0;
//  if (camera == 1 || camera == 2) camy += fplayer->zoom * 0.6;
  glTranslatef (-camx /*-2*px / MAXX * zoom*/, -camy /*0.62*zoom - (float)l->h[(int)px+MAXX/2][MAXX/2-(int)pz]*zoomz * zoom*/, -camz/*-2*pz / MAXX * zoom*/);    /* Verschiebung um -3 in z-Richtung */

//  glPushMatrix();









/*  if (lighting)
  {
    glEnable( GL_LIGHTING);
    glEnable( GL_LIGHT0 );
  }*/

  if (camera != 50)
  {
    gl->enableFog (pseudoview);
  }

//  glEnable (GL_DITHER);

// draw terrain
  l->calcDynamicLight (explosion);
  glEnable (GL_CULL_FACE);
  l->draw ((int) camphi, (int) fplayer->gamma);
  glDisable (GL_CULL_FACE);

  gl->extractFrustum ();
//  gl->enableTextures (texgrass);
//  glEnable (GL_CULL_FACE);
  if (camera != 50)
  {
    space->lum = sunlight;
	for (i = 0; i < space->no; i ++)
	{
	  if (space->o [i]->tl->y < l->getExactRayHeight (space->o [i]->tl->x, space->o [i]->tl->z))
		space->o [i]->lum = 0.5;
	  else
		space->o [i]->lum = 1.0;
	}
  if (flash > 5)
    flash1->draw ();
    if (lighting)
    {
      glEnable( GL_LIGHTING);
      glEnable( GL_LIGHT0 );
      glTexEnvi (GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
      space->drawGL ();
      glDisable (GL_LIGHTING);
      for (i = 0; i < space->no; i ++)
      {
        AIObj *dobj = (AIObj *) space->o [i];
        if (dobj->draw && dobj->drawlight && dobj->active)
        {
          if (dobj->smoke)
            if ((dobj->id >= MISSILE1 && dobj->id <= MISSILE2) || (dobj->id >= FIGHTER1 && dobj->id <= FIGHTER2))
              if (!(dobj->ttl == 0 && dobj->id >= MISSILE1 && dobj->id <= MISSILE2))
              {
                dobj->smoke->draw ();
              }
        }
      }
    }
    else
    {
      space->drawGL ();
    }
  }
//  glDisable (GL_CULL_FACE);
  glDisable (GL_TEXTURE_2D);

  glDisable (GL_LIGHTING);

  if (camera == 0)
  {
    glDisable (GL_DEPTH_TEST);
    cockpit->drawTargeter ();
    glEnable (GL_DEPTH_TEST);
  }

  glPopMatrix ();

//  gl->enableAntiAliasing ();

  /* Where is the sun? */
/* double ra=10.0;
  double winx, winy, winz;
  winx = ra*sin(fplayer->gamma)*cos(fplayer->phi)*width;
  winy = ra*sin(fplayer->gamma)*sin(fplayer->phi)*height;
  winz = ra*cos(fplayer->gamma);
  double proj[16];
  double modl[16];
  int vp[4];
  glGetDoublev( GL_PROJECTION_MATRIX, proj );
  glGetDoublev( GL_MODELVIEW_MATRIX, modl );
  vp[0]=0; vp[1]=0; vp[2]=width; vp[3]=height;
//  gluProject (0, 0, 1.0, proj, modl, vp, &winx, &winy, &winz);
  double objx, objy, objz;
  gluUnProject (winx, winy, winz, modl, proj, vp, &objx, &objy, &objz);
  printf ("\nre: x=%f, y=%f, z=%f", objx, objy, objz); fflush (stdout);
  glBegin (GL_LINES);
  glVertex3f (-objx, -objy, objz);
  glVertex3f (-objx, -objy, 5);
  glEnd ();*/

// draw flares
  if (sunvisible && camera == 0 && sunblinding && day)
  {
  glTexEnvi (GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
  int maxi = 4;
  for (i = maxi - 1; i >= 1; i --)
  {
  glDisable (GL_DEPTH_TEST);
  glPushMatrix ();
  r = 10.0;
  fac = view; zfac = view * 0.2;
  int myphi = (int) camphi;
  if (camera != 1 && camera != 5)
    glRotatef (-camtheta, 0.0, 0.0, 1.0);
//  else
//    glRotatef (-20, 0.0, 0.0, 1.0);
  if (camera == 0)
    glRotatef (-fplayer->gamma + 180 + sungamma * i / maxi, 1.0, 0.0, 0.0);
  else
    glRotatef (camgamma + sungamma * i / maxi, 1.0, 0.0, 0.0);
  if (myphi < 180) myphi = myphi * i / maxi;
  else myphi = 360 - (360 - myphi) * i / maxi;
  glRotatef (-myphi, 0.0, 1.0, 0.0);
  glTranslatef (0, 0, (float) -10.0 * i / maxi);
  if (camera == 0)
    glRotatef (-fplayer->gamma + 180 + sungamma * i / maxi, 1.0, 0.0, 0.0);
  else
    glRotatef (camgamma + sungamma * i / maxi, 1.0, 0.0, 0.0);
  glRotatef (-myphi, 0.0, 1.0, 0.0);
  glDisable (GL_DEPTH_TEST);
  gl->enableTextures (texflare->textureID);
  gl->enableAlphaBlending ();
//  glDisable (GL_DITHER);
  glBegin (GL_QUADS);
  fac = view; zfac = view * 3.5;
  glColor4f (1.0, 1.0, 1.0, 1.0);
  glTexCoord2d (0, 1);
  glVertex3f (-0.5, 0.5, 0);
  glTexCoord2d (1, 1);
  glVertex3f (0.5, 0.5, 0);
//  glColor4f (0.1, 0.9, 0.9, 1.0);
  glTexCoord2d (1, 0);
  glVertex3f (0.5, -0.5, 0);
  glTexCoord2d (0, 0);
  glVertex3f (-0.5, -0.5, 0);
  glEnd ();
  glEnable (GL_DEPTH_TEST);
  glDisable (GL_TEXTURE_2D);
  gl->disableAlphaBlending ();
  glPopMatrix ();
  }
  glTexEnvi (GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
  }  


//  float zf, g, g2;
//  glPushMatrix ();
  if (camera == 0)
  {
    cockpit->drawCross ();
    cockpit->drawHeading ();
    cockpit->drawRadar ();
    cockpit->drawTargetedElement ();
    cockpit->drawWeapon ();
  }
//  glPopMatrix ();
//  glutStrokeCharacter (GLUT_STROKE_ROMAN, 'A');

/*  drawText (-5, 0, -10, "DOGFIGHT");
  drawText (-5, -3, -10, "OPTIONS");*/

  mission->draw ();

  glPushMatrix ();
  glDisable (GL_DEPTH_TEST);
/*  glMatrixMode (GL_PROJECTION);
  glPushMatrix ();
  glLoadIdentity ();
  gluOrtho2D (0, width, 0, height);
  glScalef (1, -1, 1);
  glTranslatef (0, -height, 0);
  glMatrixMode (GL_MODELVIEW);
  glLoadIdentity ();

  glColor3d (255, 255, 0);
  char *c;
  char *string = "action fs demo";
  glRasterPos2f (20, 25);
  for (c = string; *c; c ++)
  {
    glutBitmapCharacter (GLUT_BITMAP_HELVETICA_12, *c);
//    glutStrokeCharacter (GLUT_STROKE_ROMAN, *c);
  }
  char buf [25];
  sprintf (buf, "FPS: %d", (int) fps);
  glRasterPos2f (20, 50);
  for (c = buf; *c; c ++)
  {
    glutBitmapCharacter (GLUT_BITMAP_8_BY_13, *c);
  }

  glMatrixMode (GL_PROJECTION);
  glPopMatrix ();
  glMatrixMode (GL_MODELVIEW);*/
  glPopMatrix ();

  char buf [25];
  CColor col;
  sprintf (buf, "FPS: %d", (int) fps);
  font1->drawText (-25, 25, -3.5, buf, &col);

  if (missionstate == 1)
  {
    if (fplayer->score == -1)
    {
      fplayer->score = mission->getScore (missionstate);
    }
    CColor colblue (0, 0, 255, 200);
    font1->drawTextCentered (0, 1, -1.2, "MISSION", &colblue);
    font1->drawTextCentered (0, -1, -1.2, "SUCCESS", &colblue);
    sprintf (buf, "SCORE: %d", fplayer->score);
    font1->drawTextCentered (0, -4, -2, buf, &colblue);
  }
  else if (missionstate == 2)
  {
    if (fplayer->score == -1)
    {
      fplayer->score = mission->getScore (missionstate);
    }
    CColor colred (255, 0, 0, 200);
    font1->drawTextCentered (0, 1, -1.2, "MISSION", &colred);
    font1->drawTextCentered (0, -1, -1.2, "FAILED", &colred);
    sprintf (buf, "SCORE: %d", fplayer->score);
    font1->drawTextCentered (0, -4, -2, buf, &colred);
  }

  if (debug)
    printf ("\nleaving myDisplayFunc()"); fflush (stdout);
}

float lastspeed;
int gametimer;

void game_timer ()
{
  if (multiplayer) return;

  int i, i2;

  gametimer ++;

  if (fplayer->autofire)
  {
    fplayer->fireCannon (laser);
    sound->play (SOUND_CANNON1);
  }

  if (lastshield > fplayer->shield && !fplayer->ai)
  {
    sound->play (SOUND_HIT1);
    lastshield = fplayer->shield;
  }

  if (debug)
    printf ("\nentering myTimerFunc()"); fflush (stdout);

    if (weather == 1 && !flash && !myrandom (30))
    {
      flash = 10;
      int fphi = (int) camphi + myrandom (50) - 25;
      if (fphi < 0) fphi += 360;
      else if (fphi >= 360) fphi -= 360;
      float pseudoview = getView ();
      float fdist = myrandom ((int) pseudoview - 20) + 10;
      float fx = fplayer->tl->x - sine [fphi] * fdist;
      float fz = fplayer->tl->z - cosi [fphi] * fdist;
      flash1->set (fx, l->getHeight (fx, fz), fz, camphi);
      int lev = (int) (128.0 - 80.0 * fdist / (pseudoview - 10));
      sound->setVolume (SOUND_THUNDER1, lev);
      sound->play (SOUND_THUNDER1);
    }

  if (initing) return;

  if (flash)
    flash --;
  if (flash <= 5 && flash > 0)
    flash --;

  if (lastspeed != fplayer->speed && !(gametimer & 15))
    setPlaneVolume ();
  lastspeed = fplayer->speed;

  for (i = 0; i < maxfighter; i ++)
  {
    for (i2 = 0; i2 < maxlaser; i2 ++)
      if (laser [i2]->active)
        fighter [i]->collide (laser [i2]);
    for (i2 = 0; i2 < maxmissile; i2 ++)
      if (missile [i2]->active)
        fighter [i]->collide (missile [i2]);
    for (i2 = 0; i2 < maxfighter; i2 ++)
      if (fighter [i2]->active)
        if (i != i2)
          fighter [i]->collide (fighter [i2]);
  }

  for (i = 0; i < maxfighter; i ++)
  {
    fighter [i]->aiAction ((AIObj **) fighter, missile, laser);
  }
  for (i = 0; i < maxlaser; i ++)
  {
    laser [i]->move ();
  }
  for (i = 0; i < maxmissile; i ++)
  {
    missile [i]->aiAction ((AIObj **) fighter, missile, laser);
  }

  for (i = 0; i < maxexplosion; i ++)
    explosion [i]->move ();

  if (fplayer->shield <= 0)
    camera = 1;
/*  if (!fplayer->active && !fplayer->draw)
    game_levelInit ();*/

  float cf = -fplayer->zoom / 2;
  camtheta = fplayer->theta;
  if (camera == 0)  // cockpit
  {
    camx = fplayer->tl->x + cf * sine [(int) fplayer->phi];// * MAXX / zoom / 2;
    camy = fplayer->tl->y + fplayer->zoom / 3.0;
    camz = fplayer->tl->z + cf * cosi [(int) fplayer->phi];// * MAXX / zoom / 2;
    camphi = fplayer->phi;
    fplayer->draw = 0;
  }
  if (camera == 1) // chase
  {
    cf = fplayer->zoom * 2;
    camx = fplayer->tl->x + cf * sine [(int) fplayer->phi];// * MAXX / zoom / 2;
    camy = fplayer->tl->y + fplayer->zoom;
    camz = fplayer->tl->z + cf * cosi [(int) fplayer->phi];// * MAXX / zoom / 2;
    camphi = fplayer->phi;
    fplayer->draw = 1;
    camgamma = 20;
  }
  else if (camera == 2) // backwards
  {
    cf = -fplayer->zoom * 2;
    camx = fplayer->tl->x + cf * sine [(int) fplayer->phi];// * MAXX / zoom / 2;
    camy = fplayer->tl->y + fplayer->zoom;
    camz = fplayer->tl->z + cf * cosi [(int) fplayer->phi];// * MAXX / zoom / 2;
    camphi = fplayer->phi + 180.0;
    fplayer->draw = 1;
    camgamma = 20;
  }
  else if (camera == 3) // other players
  {
    cf = fighter [aktcam]->zoom * 2;
    camx = fighter [aktcam]->tl->x + cf * sine [(int) fighter [aktcam]->phi];// * MAXX / zoom / 2;
    camy = fighter [aktcam]->tl->y + fighter [aktcam]->zoom;
    camz = fighter [aktcam]->tl->z + cf * cosi [(int) fighter [aktcam]->phi];// * MAXX / zoom / 2;
    camphi = fighter [aktcam]->phi;
    camgamma = 20;
    camtheta = fighter [aktcam]->theta;
    fplayer->draw = 1;
  }
  else if (camera == 4) // missile
  {
    cf = missile [0]->zoom * 5;
    camx = missile [0]->tl->x + cf * sine [(int) missile [0]->phi];// * MAXX / zoom / 2;
    camy = missile [0]->tl->y + fplayer->zoom;
    camz = missile [0]->tl->z + cf * cosi [(int) missile [0]->phi];// * MAXX / zoom / 2;
    camphi = missile [0]->phi;
    fplayer->draw = 1;
  }
  else if (camera == 5) // top
  {
    cf = fplayer->zoom * 15;
    camx = fplayer->tl->x + cf * sine [(int) fplayer->phi];// * MAXX / zoom / 2;
    camy = fplayer->tl->y + 5.5;
    camz = fplayer->tl->z + cf * cosi [(int) fplayer->phi];// * MAXX / zoom / 2;
    camphi = fplayer->phi;
    fplayer->draw = 1;
    camgamma = 50;
  }
  else if (camera == 6) // left
  {
    cf = fplayer->zoom * 2;
    camphi = fplayer->phi + 90.0;
    if (camphi >= 360) camphi -= 360;
    else if (camphi < 0) camphi += 360;
    camx = fplayer->tl->x + cf * sine [(int) camphi];// * MAXX / zoom / 2;
    camy = fplayer->tl->y + fplayer->zoom;
    camz = fplayer->tl->z + cf * cosi [(int) camphi];// * MAXX / zoom / 2;
    fplayer->draw = 1;
    camgamma = 20;
  }
  else if (camera == 7) // right
  {
    cf = fplayer->zoom * 2;
    camphi = fplayer->phi + 270.0;
    if (camphi >= 360) camphi -= 360;
    else if (camphi < 0) camphi += 360;
    camx = fplayer->tl->x + cf * sine [(int) camphi];// * MAXX / zoom / 2;
    camy = fplayer->tl->y + fplayer->zoom;
    camz = fplayer->tl->z + cf * cosi [(int) camphi];// * MAXX / zoom / 2;
    fplayer->draw = 1;
    camgamma = 20;
  }
  else if (camera == 50)
  {
    camx = 20;
    camz = 80;
    camy = 250;
    camphi = 20;
    camgamma = 75;
    game = GAME_PAUSE;
  }
  if (camphi >= 360.0) camphi -= 360.0;
#ifdef USE_GLUT
  glutPostRedisplay();
#else
  sdldisplay = true;
#endif

  fplayer->rectheta -= dtheta;
  fplayer->recgamma += dgamma;

//  printf ("%f, %f\n", fplayer->tl->x, fplayer->tl->z);
  missionstate = mission->processtimer ();

  if (missionstate == 2)
  {
    missionending ++;
    if (missionending >= 35)
    {
      missionending = 0;
      printf ("initing new mission"); fflush (stdout);
      missionactive = false;
      createMission (MISSION_DEMO);
      game_levelInit ();
      switch_menu ();
    }
  }

  if (missionstate == 1)
  {
    missionending ++;
    if (missionending >= 35)
    {
      missionending = 0;
      printf ("initing new mission"); fflush (stdout);
      missionactive = false;
      createMission (MISSION_DEMO);
      game_levelInit ();
      switch_menu ();
    }
  }

  if (debug)
    printf ("\nleaving myTimerFunc()"); fflush (stdout);
}

int net_thread_main (void *data)
{
  while (true)
  {

  int i, i2;

  gametimer ++;

  if (debug)
    printf ("\nentering myTimerFunc()"); fflush (stdout);

    if (weather == 1 && !flash && !myrandom (30))
    {
      flash = 10;
      int fphi = (int) camphi + myrandom (50) - 25;
      if (fphi < 0) fphi += 360;
      else if (fphi >= 360) fphi -= 360;
      float pseudoview = getView ();
      float fdist = myrandom ((int) pseudoview - 20) + 10;
      float fx = fplayer->tl->x - sine [fphi] * fdist;
      float fz = fplayer->tl->z - cosi [fphi] * fdist;
      flash1->set (fx, l->getHeight (fx, fz), fz, camphi);
      int lev = (int) (128.0 - 80.0 * fdist / (pseudoview - 10));
      sound->setVolume (SOUND_THUNDER1, lev);
      sound->play (SOUND_THUNDER1);
    }

  if (flash)
    flash --;
  if (flash <= 5 && flash > 0)
    flash --;

  if (lastspeed != fplayer->speed && !(gametimer & 15))
    setPlaneVolume ();
  lastspeed = fplayer->speed;

  for (i = 0; i < maxfighter; i ++)
  {
    for (i2 = 0; i2 < maxlaser; i2 ++)
      if (laser [i2]->active)
        fighter [i]->collide (laser [i2]);
    for (i2 = 0; i2 < maxmissile; i2 ++)
      if (missile [i2]->active)
        fighter [i]->collide (missile [i2]);
    for (i2 = 0; i2 < maxfighter; i2 ++)
      if (fighter [i2]->active)
        if (i != i2)
          fighter [i]->collide (fighter [i2]);
  }

  for (i = 0; i < maxfighter; i ++)
  {
    fighter [i]->aiAction ((AIObj **) fighter, missile, laser);
  }
  for (i = 0; i < maxlaser; i ++)
    laser [i]->move ();
  for (i = 0; i < maxmissile; i ++)
    missile [i]->aiAction ((AIObj **) fighter, missile, laser);

  for (i = 0; i < maxexplosion; i ++)
    explosion [i]->move ();

  if (fplayer->shield <= 0)
    camera = 1;
/*  if (!fplayer->active && !fplayer->draw)
    game_levelInit ();*/

  float cf = -fplayer->zoom / 2;
  camtheta = fplayer->theta;
  if (camera == 0)  // cockpit
  {
    camx = fplayer->tl->x + cf * sine [(int) fplayer->phi];// * MAXX / zoom / 2;
    camy = fplayer->tl->y + fplayer->zoom / 3.0;
    camz = fplayer->tl->z + cf * cosi [(int) fplayer->phi];// * MAXX / zoom / 2;
    camphi = fplayer->phi;
    fplayer->draw = 0;
  }
  if (camera == 1) // chase
  {
    cf = fplayer->zoom * 2;
    camx = fplayer->tl->x + cf * sine [(int) fplayer->phi];// * MAXX / zoom / 2;
    camy = fplayer->tl->y + fplayer->zoom;
    camz = fplayer->tl->z + cf * cosi [(int) fplayer->phi];// * MAXX / zoom / 2;
    camphi = fplayer->phi;
    fplayer->draw = 1;
    camgamma = 20;
  }
  else if (camera == 2) // backwards
  {
    cf = -fplayer->zoom * 2;
    camx = fplayer->tl->x + cf * sine [(int) fplayer->phi];// * MAXX / zoom / 2;
    camy = fplayer->tl->y + fplayer->zoom;
    camz = fplayer->tl->z + cf * cosi [(int) fplayer->phi];// * MAXX / zoom / 2;
    camphi = fplayer->phi + 180.0;
    fplayer->draw = 1;
    camgamma = 20;
  }
  else if (camera == 3) // other players
  {
    cf = fighter [aktcam]->zoom * 2;
    camx = fighter [aktcam]->tl->x + cf * sine [(int) fighter [aktcam]->phi];// * MAXX / zoom / 2;
    camy = fighter [aktcam]->tl->y + fighter [aktcam]->zoom;
    camz = fighter [aktcam]->tl->z + cf * cosi [(int) fighter [aktcam]->phi];// * MAXX / zoom / 2;
    camphi = fighter [aktcam]->phi;
    camgamma = 20;
    camtheta = fighter [aktcam]->theta;
    fplayer->draw = 1;
  }
  else if (camera == 4) // missile
  {
    cf = missile [0]->zoom * 5;
    camx = missile [0]->tl->x + cf * sine [(int) missile [0]->phi];// * MAXX / zoom / 2;
    camy = missile [0]->tl->y + fplayer->zoom;
    camz = missile [0]->tl->z + cf * cosi [(int) missile [0]->phi];// * MAXX / zoom / 2;
    camphi = missile [0]->phi;
    fplayer->draw = 1;
  }
  else if (camera == 5) // top
  {
    cf = fplayer->zoom * 15;
    camx = fplayer->tl->x + cf * sine [(int) fplayer->phi];// * MAXX / zoom / 2;
    camy = fplayer->tl->y + 5.5;
    camz = fplayer->tl->z + cf * cosi [(int) fplayer->phi];// * MAXX / zoom / 2;
    camphi = fplayer->phi;
    fplayer->draw = 1;
    camgamma = 50;
  }
  else if (camera == 6) // left
  {
    cf = fplayer->zoom * 2;
    camphi = fplayer->phi + 90.0;
    if (camphi >= 360) camphi -= 360;
    else if (camphi < 0) camphi += 360;
    camx = fplayer->tl->x + cf * sine [(int) camphi];// * MAXX / zoom / 2;
    camy = fplayer->tl->y + fplayer->zoom;
    camz = fplayer->tl->z + cf * cosi [(int) camphi];// * MAXX / zoom / 2;
    fplayer->draw = 1;
    camgamma = 20;
  }
  else if (camera == 7) // right
  {
    cf = fplayer->zoom * 2;
    camphi = fplayer->phi + 270.0;
    if (camphi >= 360) camphi -= 360;
    else if (camphi < 0) camphi += 360;
    camx = fplayer->tl->x + cf * sine [(int) camphi];// * MAXX / zoom / 2;
    camy = fplayer->tl->y + fplayer->zoom;
    camz = fplayer->tl->z + cf * cosi [(int) camphi];// * MAXX / zoom / 2;
    fplayer->draw = 1;
    camgamma = 20;
  }
  else if (camera == 50)
  {
    camx = 20;
    camz = 80;
    camy = 250;
    camphi = 20;
    camgamma = 75;
    game = GAME_PAUSE;
  }
  if (camphi >= 360.0) camphi -= 360.0;
#ifdef USE_GLUT
  glutPostRedisplay();
#else
  sdldisplay = true;
#endif

  fplayer->rectheta -= dtheta;
  fplayer->recgamma += dgamma;

//  printf ("%f, %f\n", fplayer->tl->x, fplayer->tl->z);
  missionstate = mission->processtimer ();

  if (missionstate == 2)
  {
    missionending ++;
    if (missionending >= 35)
    {
      missionending = 0;
      printf ("initing new mission"); fflush (stdout);
      missionactive = false;
      createMission (MISSION_DEMO);
      game_levelInit ();
      switch_menu ();
    }
  }

  if (missionstate == 1)
  {
    missionending ++;
    if (missionending >= 35)
    {
      missionending = 0;
      printf ("initing new mission"); fflush (stdout);
      missionactive = false;
      createMission (MISSION_DEMO);
      game_levelInit ();
      switch_menu ();
    }
  }

  if (debug)
    printf ("\nleaving myTimerFunc()"); fflush (stdout);


  if (multiplayer)
  {

    if (isserver)
    {
      server->sendMessage (1, ":", 1);
      int len = fplayer->net_write ();
      server->sendMessage (1, fplayer->net, len);
      len = fighter[1]->net_write ();
      server->sendMessage (1, fighter[1]->net, len);
//      while (server->getMessage (1, fighter [1]->net))
//        fighter [1]->net_read ();
    }
    else
    {
//      int len = fplayer->net_write ();
//      client->sendMessage (fplayer->net, len);
      char buffer[10];
      while (! client->getMessage(buffer));
      while (!client->getMessage (fighter [0]->net)) ;
      fighter [0]->net_read ();
      while (!client->getMessage (fighter [1]->net)) ;
      fighter [1]->net_read ();
      // if (client)
    }

  }

#ifdef HAVE_SDL
    SDL_Delay (50);
#endif
  }
}

void menu_timer ()
{
  menutimer ++;
  if (!(menutimer & 0xFF))
  {
    if (camera == 5)
    {
      camera = 1;
      if (missile [0]->active)
        camera = 4;
    }
    else if (camera == 1 || camera == 4) camera = 2;
    else if (camera == 2) camera = 5;
  }
#ifdef USE_GLUT
  glutPostRedisplay();
#else
  sdldisplay = true;
#endif
}

void mission_timer ()
{
  missionmenutimer ++;
#ifdef USE_GLUT
  glutPostRedisplay();
#else
  sdldisplay = true;
#endif
}

void credits_timer ()
{
  creditstimer ++;
  if (creditstimer > 360)
    creditstimer = 0;
#ifdef USE_GLUT
  glutPostRedisplay();
#else
  sdldisplay = true;
#endif
}
//#include <time.h>

void create_key (unsigned char key, int x, int y)
{
  if (key == 's')
  {
    createMission (MISSION_MULTIPLAYER_DOGFIGHT);
    game_levelInit ();
    switch_game ();
    missionactive = true;
  }
}

void join_key (unsigned char key, int x, int y)
{
  if (key == 's')
  {
    createMission (MISSION_MULTIPLAYER_DOGFIGHT);
    game_levelInit ();
    switch_game ();
    missionactive = true;
  }
}

void create_timer ()
{
#ifndef USE_GLUT
//  server->createSocketSet ();
  server->getClient ();
  SDL_Delay (100);
#endif
}

void join_timer ()
{
#ifndef USE_GLUT
  client->getServer ("Lara", "client1");
  SDL_Delay (100);
#endif
}

void myInit ()
{
  int i;
  if (debug)
    printf ("\nentering myInit()"); fflush (stdout);

  if (debug)
    printf ("\n initing landscape"); fflush (stdout);

  texsun = gl->genTextureTGA ("../textures/sun2.tga", 1, 2, 0);
  texmoon = gl->genTextureTGA ("../textures/moon1.tga", 1, 2, 0);
  texearth = gl->genTextureTGA ("../textures/earth.tga", 1, 0, 0);
  texflare = gl->genTextureTGA ("../textures/flare1.tga", 1, 2, 0);
  texgrass = gl->genTextureTGA ("../textures/grass1.tga", 0, 0, 1);
  texrocks = gl->genTextureTGA ("../textures/rocks1.tga", 0, 0, 1);
  texwater = gl->genTextureTGA ("../textures/water1.tga", 0, 0, 1);
  texsand = gl->genTextureTGA ("../textures/sand1.tga", 0, 0, 1);
  texredstone = gl->genTextureTGA ("../textures/redstone2.tga", 0, 0, 1);
  textree = gl->genTextureTGA ("../textures/tree1.tga", 0, 3, 1);
  textree2 = gl->genTextureTGA ("../textures/tree2.tga", 0, 3, 1);
  textree3 = gl->genTextureTGA ("../textures/tree3.tga", 0, 3, 1);
  textree4 = gl->genTextureTGA ("../textures/tree4.tga", 0, 3, 1);
  texcactus1 = gl->genTextureTGA ("../textures/cactus1.tga", 0, 3, 1);
  texsmoke = gl->genTextureTGA ("../textures/smoke1.tga", 0, 4, 1);
  texsmoke2 = gl->genTextureTGA ("../textures/smoke2.tga", 0, 4, 1);
  texcross = gl->genTextureTGA ("../textures/cross.tga", 0, 2, 1);
  texcross2 = gl->genTextureTGA ("../textures/cross2.tga", 0, 2, 1);
//  texfont1 = gl->genTextureTGA ("textures/font1.tga", 0, 3, 0);
/*  for (i = 0; i < maxchars; i ++)
  {
    char buf [64] = "../textures/char0.tga";
    buf [16] = '1' + i;
    texchar [i] = gl->genTextureTGA (buf, 0, 3, 1);
  }*/

//  l = new GLLandscape (space);

  tlinf = new CVector3 (1E10, 1E10, 1E10);
  tlminf = new CVector3 (-1E10, -1E10, -1E10);
  tlnull = new CVector3 (0, 0, 0);

  if (debug)
    printf ("\n initing fighters"); fflush (stdout);

  for (i = 0; i < maxgroundobj; i ++)
  {
    groundobj [i] = new DynamicObj (space, &model_tent1, 3);
  }

/*  obj = new Model ();
  obj->loadFromFile ("./data/f4.v3d");*/

  CModel *explsphere = new CSphere ();
  ((CSphere *) explsphere)->init (1, 9);
  explsphere->setColor (new CColor (255, 255, 1));
  for (i = 0; i < explsphere->object [0]->numVertices; i ++)
    explsphere->object [0]->vertex [i].color.setColor (myrandom (100) + 155, myrandom (100) + 100, 0);
//  ((CSphere *) explsphere)->invertNormals ();
  for (i = 0; i < maxexplosion; i ++)
  {
    explosion [i] = new CExplosion (space, explsphere);
  }

  for (i = 0; i < maxfighter; i ++)
  {
    fighter [i] = new AIObj (space, &model_fig, 0.4);
  }

  if (debug)
    printf ("\n initing sphere"); fflush (stdout);

  objsphere = new CSphere (1, 9, 1, 1, 1);
  sphere = new CSpaceObj (objsphere, 10.0);
  //sphere = new CSpaceObj ();
  sphere->rot->b = 90;
  sphere->draw = 2;
  sphere->drawlight = false;

  flash1 = new Flash ();

  if (debug)
    printf ("\n initing lasers"); fflush (stdout);

//  objlaser = new CModel ();
//  objlaser->loadFromFile ("./data/c1.v3d");
  for (i = 0; i < maxlaser; i ++)
  {
    laser [i] = new DynamicObj (space, &model_cannon1, 0.07);
  }

  if (debug)
    printf ("\n initing missiles"); fflush (stdout);

//  objmissile = new CModel ();
//  objmissile->loadFromFile ("./data/r1.v3d");
  for (i = 0; i < maxmissile; i ++)
  {
    missile [i] = new AIObj (space, &model_missile1, 0.1);
  }

  for (i = 0; i < maxstar; i ++)
  {
    star [i] = new Star (myrandom (360), myrandom (85), 0.4 + 0.1 * myrandom (8));
  }

  cockpit = new Cockpit ();

  createMission (MISSION_DEMO);
  game_levelInit ();

  menu_reshape ();

  if (debug)
    printf ("\nleaving myInit()"); fflush (stdout);
}

class InitKugel
{
  public:
  int explosion;
  CModel *m;
  CVector3 tl;
  InitKugel(){}

  InitKugel (CModel *m)
  {
    tl.x = (int) (0.1 * myrandom(800) - 40);
    tl.y = (int) (0.1 * myrandom(800) - 40);
    tl.z = (int) (0.1 * myrandom(800) - 40);
    this->m = m;
    explosion = 0;
  }

  InitKugel (float x, float y, float z, CModel *m)
  {
    tl.x = x;
    tl.y = y;
    tl.z = z;
    this->m = m;
    explosion = 0;
  }
  
  void draw()
  {
    if (explosion > 200) return;
    if (explosion) explosion ++;
    CVector3 tlnull;
    CRotation rot;
    glPushMatrix();
    m->draw3 (&tlnull, &tl, &rot, 0.8, explosion);
    glPopMatrix();
  }
};


CRotation rot;
CRotation rot2;
CVector3 tl;
CVector3 tl2;
int initexplode = 0;
int initexplode1 = 0;
InitKugel *mykugel [100];
int i;
int inittimer = 0;

void init_reshape ()
{
  /* Darstellung auf gesamten Clientbereich des Fensters zulassen */
  glViewport(0, 0, (GLint) width, (GLint) height);

  glMatrixMode (GL_PROJECTION);
  glLoadIdentity ();
  /* angle, aspect, near Clip, far Clip */
  float v = view;
  if (camera == 50) v = 100000.0;
  gluPerspective (80.0, 1.0, 0.20, 80); // should be sqrt(2) or 1.5
  glPolygonMode (GL_FRONT_AND_BACK, polygonMode);
}

void myFirstInit ()
{
  int i;

  mathtab_init ();

  gl = new GL (1.0, 1000.0);
  font1 = new Font ("../textures/font1.tga", 32, '!');
  font2 = new Font ("../textures/font2.tga", 32, '!');
//  texfont1 = gl->genTextureTGA ("../textures/font2.tga", 0, 1, 0);
  g_Load3ds.Import3DS (&model_fig, "../models/fig7.3ds");
  model_fig.setName ("FALCON");
  g_Load3ds.Import3DS (&model_figa, "../models/fig4.3ds");
  model_figa.setName ("SWALLOW");
  g_Load3ds.Import3DS (&model_figb, "../models/fig2.3ds");
  model_figb.setName ("HAWK");
  g_Load3ds.Import3DS (&model_figc, "../models/fig3.3ds");
  model_figc.setName ("HAWK II");
  g_Load3ds.Import3DS (&model_figd, "../models/fig1.3ds");
  model_figd.setName ("BUZZARD");
  g_Load3ds.Import3DS (&model_figt, "../models/transp1.3ds");
  model_figt.setName ("TRANSPORT");
  // cannon at daylight
  g_Load3ds.Import3DS (&model_cannon1, "../models/cannon1.3ds");
  // cannon at night
  g_Load3ds.Import3DS (&model_cannon2, "../models/cannon2.3ds");
  model_cannon2.nolight = true;
  model_cannon2.object [0]->vertex [2].color.c [0] = 50;
  model_cannon2.object [0]->vertex [2].color.c [1] = 50;
  model_cannon2.object [0]->vertex [2].color.c [2] = 50;
  model_cannon2.object [0]->vertex [1].color.c [0] = 50;
  model_cannon2.object [0]->vertex [1].color.c [1] = 50;
  model_cannon2.object [0]->vertex [1].color.c [2] = 50;
  g_Load3ds.Import3DS (&model_missile1, "../models/missile1.3ds");
  model_missile1.setName ("AAM MK1");
  g_Load3ds.Import3DS (&model_missile2, "../models/missile2.3ds");
  model_missile2.setName ("AAM MK2");
  g_Load3ds.Import3DS (&model_missile3, "../models/missile3.3ds");
  model_missile3.setName ("AAM MK3");
  g_Load3ds.Import3DS (&model_missile4, "../models/missile4.3ds");
  model_missile4.setName ("AGM MK1");
  g_Load3ds.Import3DS (&model_missile5, "../models/missile5.3ds");
  model_missile5.setName ("AGM MK2");
  g_Load3ds.Import3DS (&model_flak1, "../models/flak2.3ds");
  model_flak1.setName ("SA CANNON");
  g_Load3ds.Import3DS (&model_flarak1, "../models/flarak1.3ds");
  model_flarak1.setName ("SAM");
  g_Load3ds.Import3DS (&model_ship1, "../models/ship1.3ds");
  model_ship1.setName ("CRUISER");
  g_Load3ds.Import3DS (&model_tent1, "../models/tent1.3ds");
  model_tent1.setName ("TENT");
  g_Load3ds.Import3DS (&model_gl117, "../models/gl-117.3ds");
/*	for(i = 0; i < model.numOfMaterials; i++)
	{
		if(strlen(model.pMaterials[i]->strFile) > 0)
		{
//			CreateTexture(g_Texture, model.pMaterials[i].strFile, i);
		}
		model.pMaterials[i]->texureId = i;
	}*/

  /* Z-Buffer f. Berechnung verdeckter Flaechen einschalten */
  glEnable(GL_DEPTH_TEST);

  /* Vorder- u. Rueckseite der Polygone nur als Randlinien darstellen */
  glPolygonMode (GL_FRONT_AND_BACK, GL_FILL);

  if (debug)
    printf ("\n initing space"); fflush (stdout);
  space = new Space ();
  space->drawlight = true;
  clip1 = space->z1;
  clip2 = space->z2;
  clip1->x = -ZOOM;
  clip1->y = -ZOOM;
  clip1->z = -ZOOM;
  clip2->x = ZOOM;
  clip2->y = ZOOM;
  clip2->z = ZOOM;

  init_reshape ();

  CColor* mycolor = new CColor (200, 200, 0);
  CColor* mycolor2 = new CColor (100, 100, 0);
  CSphere *mysphere = new CSphere (1, 8, 1, 1, 1);
  mysphere->setColor (mycolor2);
  mysphere->setNorthPoleColor (mycolor, 1.9);
  for (i = 0; i < 100; i++)
  {
    mykugel [i] = new InitKugel (mysphere);
  }

  tl.x = 0.0;
  tl.y = 0.0;
  tl.z = -5.0;
  tl2.x = 0.0;
  tl2.y = 0.0;
  tl2.z = -5.0;
  rot.a = 270;
  rot2.c = 90;
  rot2.a = 270;
  rot2.b = 270;
//  rot2.a = 270;
  initexplode = 0;
  initexplode1 = 0;

  sungamma = 60;
  setLightSource (60);

  glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_FALSE);
	glEnable(GL_LIGHT0);
	glEnable(GL_LIGHTING);
	glEnable(GL_COLOR_MATERIAL);

  glHint (GL_PERSPECTIVE_CORRECTION_HINT, GL_FASTEST);
  glDisable (GL_DITHER);
}


void init_key (int key, int x, int y)
{
//  game_quit ();
  myInit ();
  switch_menu ();
  fplayer->ai = true;
  camera = 5;
}

void init_display ()
{
  int i;
//  char buf [20];
//  char buf2 [20];
  CVector3 vec;
  CColor color (200, 200, 200, 255);

//  gluPerspective (80.0, (float) width / height, 0.20, 50.0); // should be sqrt(2) or 1.5
  glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity ();
//  glShadeModel(GL_SMOOTH);
//  glPushMatrix ();
//  gluPerspective (80.0, (float) width / height, 0.20, 150.0); // should be sqrt(2) or 1.5

/*  glBegin (GL_TRIANGLES);
  glColor3ub (255,255,0);
  glVertex3f (-1,-1,-1.1);
  glVertex3f (1,-1,-1.1);
  glVertex3f (0,1,-1.1);
  glEnd ();*/

  glPushMatrix ();

  glEnable (GL_DEPTH_TEST);
  glEnable (GL_LIGHTING);

  glPushMatrix ();
  glTranslatef (0,0,-5);
  model_fig.draw (&vec, &tl, &rot, 1.0, 1.0, initexplode1);
  glPopMatrix ();

  if (initexplode1 < 0)
  {
    glPushMatrix ();
    glTranslatef (0,0,-5);
    model_gl117.draw2 (&vec, &tl2, &rot2, 1.0, initexplode);
    glPopMatrix ();
  }

  glDisable (GL_LIGHTING);
  glTranslatef (1,1,-50);

  glPushMatrix ();
  gl->rotate (0 ,inittimer, 0);
  gl->rotate (0 ,0 ,inittimer);
  int num = 50;
  if (quality < 2) num = 10;
  for (i = 0; i < num; i++)
  {
    mykugel[i]->draw ();
  }
  glPopMatrix ();
  glPushMatrix ();
  gl->rotate (0 ,0 ,360 - inittimer);
  gl->rotate (0 ,360 - inittimer, 0);
  for (i = 100 - num; i < 100; i++)
  {
    mykugel[i]->draw ();
  }
  glPopMatrix ();
  glPopMatrix ();


/*  glPushMatrix ();
  glTranslatef (0,0,-5);
  glEnable (GL_DEPTH_TEST);
  model_fig.draw2 (&vec, &tl2, &rot2, 1.0, initexplode);
  glPopMatrix ();*/

/*  glPushMatrix ();
  glTranslatef (0,0,inittextz);
  gl->rotate ((int) inittextrot, 0, 0);
  strcpy (buf, "GL-117");
  buf2 [1] = 0;
  for (i = 0; i < 10; i++)
  {
    buf2 [0] = buf [i];
    drawText (i-3, -0.5, 0.05, buf2, &color);
    gl->rotate (-18, 0, 0);
  }*/

  glPopMatrix ();
  //drawText (0, 0, -0.9, "LOADING...", &color);

  font2->drawText (-20, -20, -3, VERSIONSTRING, &color);

//  glPopMatrix ();
//  glutSwapBuffers ();
}

void init_timer ()
{
  if (initexplode > 30) initexplode = -1;
  if (initexplode1 > 30) initexplode1 = -1;
/*  if (inittextz < -0.5)
  {
    inittextz += 0.06;
  }*/
  if (inittimer > 200)
  {
    if (!mykugel [0]->explosion)
      for (int i = 0; i < 100; i ++)
        mykugel [i]->explosion ++;
  }
  tl.x = 8.0 * pow (1.5, -(5 + tl.z)) - 0.4;
  tl.y = 0.5 * tl.x;
  tl.z += 0.15;
  if (initexplode1 == -1 && tl2.z < 3)
  {
    tl2.z += 0.25;
  }
  if (initexplode1 >= 0 && tl.z > 2) initexplode1 ++;
//  tl2.z += 0.15;
  if (!mykugel [0]->explosion)
    inittimer ++;
  if (mykugel [0]->explosion >= 100)
  {
    init_key (27, 0, 0); // switch to menu
  }
//  initexplode ++;
//  inittextrot += 5;
  
//  rot.a ++;
  if (tl2.z < 3)
  {
    rot2.b -= 20;
    if (rot2.b < 0) rot2.b += 360;
  }
  if (tl.z > -4.0)
  {
    rot.b --;
//    rot2.b --;
  }
//  rot.c ++;
#ifdef USE_GLUT
  glutPostRedisplay();
#else
  sdldisplay = true;
#endif
}

static void myKeyboardFunc (unsigned char key, int x, int y)
{
  if (game == GAME_PLAY || game == GAME_PAUSE)
    game_key (key, x, y);
  else if (game == GAME_INIT)
    init_key (key, x, y);
  else if (game == GAME_MENU)
    menu_key (key, x, y);
  else if (game == GAME_CREDITS)
    credits_key (key, x, y);
  else if (game == GAME_CREATE)
    create_key (key, x, y);
  else if (game == GAME_JOIN)
    join_key (key, x, y);
  else if (game == GAME_MISSION)
    mission_key (key, x, y);
}

static void mySpecialFunc (int key, int x, int y)
{
  if (game == GAME_PLAY || game == GAME_PAUSE)
    game_keyspecial (key, x, y);
}

static void mySpecialFuncUp (int key, int x, int y)
{
  if (game == GAME_PLAY || game == GAME_PAUSE)
    game_keyspecialup (key, x, y);
}

static void myPassiveMotionFunc (int x, int y)
{
  mousex = x; mousey = y;
  if (game == GAME_PLAY)
    game_mousemotion (x, y);
  else if (game == GAME_MENU)
    menu_mouse (-1, -1, x, y);
  else if (game == GAME_MISSION)
    mission_mouse (-1, -1, x, y);
}

static void myMouseFunc (int button, int state, int x, int y)
{
  if (game == GAME_PLAY)
  {
    game_mouse (button, state, x, y);
  }
  else if (game == GAME_MENU)
  {
    menu_mouse (button, state, x, y);
  }
  else if (game == GAME_MISSION)
  {
    mission_mouse (button, state, x, y);
  }
}

static void myReshapeFunc (int width, int height)
{
  ::width = width;
  ::height = height;
  if (game == GAME_PLAY || game == GAME_PAUSE)
    game_reshape ();
  else if (game == GAME_MENU || game == GAME_MISSION)
    menu_reshape ();
  else if (game == GAME_INIT)
    init_reshape ();
  else if (game == GAME_CREDITS)
    credits_reshape ();
}

static void myDisplayFunc ()
{
  if (game == GAME_INIT)
  {
    init_display ();
    game_view ();
//    myInit();
//    game = GAME_PLAY;
  }
  else if (game == GAME_PLAY)
  {
    game_display ();
    game_view ();
  }
  else if (game == GAME_PAUSE)
  {
    game_display ();
    pause_display ();
    game_view ();
  }
  else if (game == GAME_MENU)
  {
    if (camera == 50) camera = 0;
    game_display ();
    menu_display ();
    game_view ();
  }
  else if (game == GAME_CREDITS)
  {
    if (camera == 50) camera = 0;
    game_display ();
    credits_display ();
    game_view ();
  }
  else if (game == GAME_MISSION)
  {
    mission_display ();
    game_view ();
  }
}

static void myIdleFunc ()
{
#ifdef USE_GLUT
  glutPostRedisplay ();
#endif
}

static void myJoystickAxisFunc (int x, int y, int t, int r)
{
  if (game == GAME_PLAY)
  {
    game_joystickaxis (x, y, t, r);
  }
}

static void myJoystickButtonFunc (int button)
{
  if (game == GAME_PLAY)
  {
    game_joystickbutton (button);
  }
}

static void myJoystickHatFunc (int hat)
{
  if (game == GAME_PLAY)
  {
    game_joystickhat (hat);
  }
}

#define TIMER_INTERVAL 30

static void myTimerFunc (int value)
{
//  fplayer->aiAction (l);
  if (game == GAME_PLAY)
    game_timer ();
  else if (game == GAME_INIT)
    init_timer ();
  else if (game == GAME_MENU)
  {
    if (!missionactive)
      game_timer ();
    menu_timer ();
  }
  else if (game == GAME_CREDITS)
  {
    credits_timer ();
  }
  else if (game == GAME_CREATE)
    create_timer ();
  else if (game == GAME_JOIN)
    join_timer ();
  else if (game == GAME_MISSION)
    mission_timer ();

#ifdef USE_GLUT
  glutTimerFunc (TIMER_INTERVAL, myTimerFunc, 0);
#endif
}

static void sdlTimerFunc ()
{
  if (game == GAME_PLAY)
    game_timer ();
  else if (game == GAME_INIT)
    init_timer ();
  else if (game == GAME_MENU)
  {
    if (!missionactive)
      game_timer ();
    menu_timer ();
  }
  else if (game == GAME_CREDITS)
  {
    credits_timer ();
  }
  else if (game == GAME_CREATE)
    create_timer ();
  else if (game == GAME_JOIN)
    join_timer ();
  else if (game == GAME_MISSION)
    mission_timer ();
}

#ifndef USE_GLUT
Uint32 sdlTimeLeft ()
{
  static Uint32 nexttime = 0;
  Uint32 now;
  now = SDL_GetTicks ();
  if (nexttime <= now)
  {
    nexttime = now + TIMER_INTERVAL;
    return 0;
  }
  return nexttime - now;
}

int joystickx = 0, joysticky = 0, joystickt = 0, joystickr = 0;
int joystickbutton = -1;

void sdlMainLoop ()
{
  SDL_Event event;
  while (1)
  {
    while (SDL_PollEvent (&event))
    {
      switch (event.type)
      {
        case SDL_MOUSEMOTION:
          myPassiveMotionFunc (event.motion.x, event.motion.y);
          break;
        case SDL_MOUSEBUTTONDOWN:
          myMouseFunc (event.button.button, event.button.state, event.button.x, event.button.y);
          break;
        case SDL_KEYDOWN:
          if (!event.key.keysym.unicode)
            mySpecialFunc (event.key.keysym.sym, 0, 0);
          else
            myKeyboardFunc (event.key.keysym.sym, 0, 0);
          break;
        case SDL_KEYUP:
          if (!event.key.keysym.unicode)
            mySpecialFuncUp (event.key.keysym.sym, 0, 0);
          break;
        case SDL_JOYAXISMOTION:
//          if (abs (event.jaxis.value) > 500)
          {
            if (event.jaxis.axis == 0)
            {
              joystickx = event.jaxis.value;
            }
            else if (event.jaxis.axis == 1)
            {
              joysticky = event.jaxis.value;
            }
            else if (event.jaxis.axis == 2)
            {
              joystickt = event.jaxis.value;
            }
            else if (event.jaxis.axis == 3)
            {
              joystickr = event.jaxis.value;
            }
            if (joystickx > -3000 && joystickx < 3000) joystickx = 0;
            if (joysticky > -3000 && joysticky < 3000) joysticky = 0;
//            printf ("\naxis=%d, val=%d", event.jaxis.axis, event.jaxis.value); 
          }
          break;
        case SDL_JOYBUTTONDOWN:
          joystickbutton = event.jbutton.button;
          if (joystickbutton >= 2)
            myJoystickButtonFunc (joystickbutton);
          break;
        case SDL_JOYBUTTONUP:
          joystickbutton = -1;
          break;
        case SDL_JOYHATMOTION:
          myJoystickHatFunc (event.jhat.value);
          break;
        case SDL_ACTIVEEVENT:
          sdlreshape = true;
          sdldisplay = true;
          break;
      }
    }
//    printf ("\nx=%d, y=%d", joystickx, joysticky);
    if (controls >= 2)
    {
      myJoystickAxisFunc (joystickx, joysticky, joystickt, joystickr);
      if (joystickbutton == 0)
        myJoystickButtonFunc (0);
      else
        joystickbutton = -1;
    }
    if (sdldisplay) myDisplayFunc ();
    sdldisplay = false;
    if (sdlreshape) myReshapeFunc (width, height);
    sdlreshape = false;
    SDL_Delay (sdlTimeLeft ());
    sdlTimerFunc ();
  }
}
#endif

int main (int argc, char **argv)
{
  printf ("\nStartup %s ... ", VERSIONSTRING); fflush (stdout);

  load_config ();
  save_config ();

/*
  time_t t;
  time (&t);
  srandom ((long) t);*/

  srand (1);

  server = NULL;
  client = NULL;

  pilots = new PilotList ("../saves/pilots");

#ifdef USE_GLUT
  printf ("\nUsing GLUT only"); fflush (stdout);
  glutInit(&argc, argv);

  glutInitDisplayMode(GLUT_DEPTH | GLUT_RGB | GLUT_DOUBLE);
  char gamestr [256];
  sprintf (gamestr, "%dx%d:%d", width, height, bpp);
  glutGameModeString (gamestr);
  if (fullscreen && glutGameModeGet (GLUT_GAME_MODE_POSSIBLE))
  {
//    width = 800; height = 600;
    glutEnterGameMode ();
  }
  else
  {
    glutInitWindowPosition (0, 0);
    glutInitWindowSize (width, height);
    if (glutCreateWindow ("GL-117") == GL_FALSE)
      exit(1);
  }

//  glutFullScreen ();
  myFirstInit ();

  sound = new SoundSystem ();

  glutReshapeFunc(myReshapeFunc);
  glutDisplayFunc(myDisplayFunc);
  glutKeyboardFunc(myKeyboardFunc);
  glutSpecialFunc(mySpecialFunc);
  glutPassiveMotionFunc(myPassiveMotionFunc);
  glutMouseFunc(myMouseFunc);
  glutIdleFunc(myIdleFunc);
  glutTimerFunc(20, myTimerFunc, 0);

  gluPerspective (80.0, (float) width / height, 0.20, 50.0); // should be sqrt(2) or 1.5
  if (controls <= 0)
    controls = 1;
  glutMainLoop();
#else
  printf ("\nUsing SDL and GLUT"); fflush (stdout);
	if (SDL_Init (SDL_INIT_VIDEO | SDL_INIT_AUDIO | SDL_INIT_JOYSTICK) < 0)
  {
		fprintf (stderr, "\nCouldn't initialize SDL: %s\n", SDL_GetError ());
		exit (1);
	}
	atexit (SDL_Quit);

  sound = new SoundSystem ();
  sound->volumesound = volumesound;
  sound->volumemusic = volumemusic;
  sound->setVolume ();
  sound->setVolumeMusic ();

  sound->playMusic (MUSIC_STANDBY1);

#ifdef HAVE_SDL_NET
	// initialize SDL_net
	if(SDLNet_Init()==-1)
	{
		fprintf (stderr, "\nSDLNet_Init: %s\n",SDLNet_GetError()); fflush (stderr);
		exit(2);
	}
  printf ("\nUsing SDL_net"); fflush (stdout);
#endif

	if (bpp == 0) {
		if ( SDL_GetVideoInfo()->vfmt->BitsPerPixel <= 8 ) {
			bpp = 8;
		} else {
			bpp = 16;
		}
	}

	Uint32 video_flags;
  video_flags = SDL_OPENGL;
  if (fullscreen) video_flags |= SDL_FULLSCREEN;

	int rgb_size[3];
	switch (bpp) {
	  case 8:
		rgb_size[0] = 2;
		rgb_size[1] = 3;
		rgb_size[2] = 3;
		break;
	  case 15:
	  case 16:
		rgb_size[0] = 5;
		rgb_size[1] = 5;
		rgb_size[2] = 5;
		break;
    default:
		rgb_size[0] = 8;
		rgb_size[1] = 8;
		rgb_size[2] = 8;
		break;
	}
	SDL_GL_SetAttribute (SDL_GL_RED_SIZE, rgb_size [0]);
	SDL_GL_SetAttribute (SDL_GL_GREEN_SIZE, rgb_size [1]);
	SDL_GL_SetAttribute (SDL_GL_BLUE_SIZE, rgb_size [2]);
	SDL_GL_SetAttribute (SDL_GL_DEPTH_SIZE, 16);
	SDL_GL_SetAttribute (SDL_GL_DOUBLEBUFFER, 1);
	if (SDL_SetVideoMode (width, height, bpp, video_flags) == NULL)
  {
  	if (SDL_VideoModeOK (width, height, bpp, video_flags) != 0)
    {
		  fprintf (stderr, "\nCouldn't set GL mode: %s\n", SDL_GetError ());
		  SDL_Quit ();
		  exit (1);
    }
	}

	SDL_WM_SetCaption ("GL-117", "GL-117");

  SDL_ShowCursor (0);

  myFirstInit ();
  myReshapeFunc (width, height);

  joystick = SDL_NumJoysticks ();
  if (joystick > 0)
  {
    SDL_JoystickEventState (SDL_ENABLE);
    sdljoystick = SDL_JoystickOpen (0);
    printf ("\nJoystick detected."); fflush (stdout);
  }
  else
  {
    printf ("\nNo joystick found."); fflush (stdout);
    sdljoystick = NULL;
    if (controls >= 2)
      controls = 0;
  }

//  joystick = 0; // disable joystick manually

	SDL_EnableUNICODE (1);
	SDL_EnableKeyRepeat (SDL_DEFAULT_REPEAT_DELAY,
	                     SDL_DEFAULT_REPEAT_INTERVAL);

  sdlMainLoop ();
#endif

  return 0;
}

#endif

